<?php
/**
 * ArmurierDataBean.php : DataBean utilis dans la page Armurier
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class armurierDataBean {
  
  /** Message d'information */
  var $msgInfo = "";
  var $dateFin = "";
  /** Identite */
  var $name = "";
  /** couteau en ventes */
  var $couteau = array();
  /** flingues en ventes */
  var $flingue = array();
  /** armure en ventes */
  var $armure = array();
  /** invetaires */
  var $inventaires = array();
  /** Portefeuille */
  var $portefeuille = "";
  
  function armurierDataBean() {
  }  
  function setMsgInfo($msgInfo) {
    $this->msgInfo = $msgInfo;	
  }
  function getMsgInfo() {
    return $this->msgInfo;	
  }
  function setName($name) {
    $this->name = $name;	
  }
  function getName() {
    return $this->name;	
  }
  function setDateFin($dateFin) {
    $this->dateFin = $dateFin;	
  }
  function getDateFin() {
    return $this->dateFin;	
  }
  function getCouteauAt($index) {
    return $this->couteau[$index];
  }
  function getNbcouteau() {
    return sizeof($this->couteau);
  }
  function addCouteau($inventaire) {
    array_push($this->couteau, $inventaire);
  }
  function setCouteauAt($index, $inventaire) {
    $this->couteau[$index] = $inventaire;
  }
  function getFlingueAt($index) {
    return $this->flingue[$index];
  }
  function getNbflingue() {
    return sizeof($this->flingue);
  }
  function addFlingue($inventaire) {
    array_push($this->flingue, $inventaire);
  }
  function setFlingueAt($index, $inventaire) {
    $this->flingue[$index] = $inventaire;
  }
  function getArmureAt($index) {
    return $this->armure[$index];
  }
  function getNbarmure() {
    return sizeof($this->armure);
  }
  function addArmure($inventaire) {
    array_push($this->armure, $inventaire);
  }
  function setArmureAt($index, $inventaire) {
    $this->armure[$index] = $inventaire;
  }
  function getInventaireAt($index) {
    return $this->inventaires[$index];
  }
  function getNbInventaire() {
    return sizeof($this->inventaires);
  }
  function addInventaire($inventaire) {
    array_push($this->inventaires, $inventaire);
  }
  function setInventaireAt($index, $inventaire) {
    $this->inventaires[$index] = $inventaire;
  }
  function setPortefeuille($portefeuille) {
    $this->portefeuille = $portefeuille;	
  }
  function getPortefeuille() {
    return $this->portefeuille;	
  }
}
?>