<?php
/**
 * ChatDataBean.php : DataBean utilis dans la page Tchat
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class ChatDataBean {
  
  /** Identite */
  var $name = "";
  /** Connects */
  var $enligne = array();
  /** Messages */
  var $messages = array();
  
  function ChatDataBean() {
  }  
  
  function setName($name) {
    $this->name = $name;	
  }
  function getName() {
    return $this->name;	
  }
  /*les connectes */
  function getNbEnLigne() {
    return sizeof($this->enligne);	
  }
  function getEnligneAt($index) {
    return $this->enligne[$index];
  }
  function addEnligne($liste) {
    array_push($this->enligne, $liste);
  }
  function setEnligneAt($index, $liste) {
    $this->enligne[$index] = $liste;
  }
  /*les connectes */
  function getNbMessages() {
    return sizeof($this->messages);	
  }
  function getMessagesAt($index) {
    return $this->messages[$index];
  }
  function setMessages($liste) {
    $this->messages = $liste;
  }

}
?>