<?php
/**
 * FicheAdversaireDataBean.php : DataBean utilis pour reprsenter un adversaire
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class FicheAdversaireDataBean {
  
  /** Identite */
  var $name = "";
  var $avatar = "";
  var $reputation = "";
  var $reputation_lvl = "";
  /** comptences */
  var $competences = array();
  /** description */
  var $description = "";
  var $attitude = "";
  
  function FicheAdversaireDataBean() {
  }
  
  function setName($name) {
    $this->name = $name;	
  }

  function getName() {
    return $this->name;	
  }

  function setAvatar($avatar) {
    $this->avatar = $avatar;	
  }
  function getAvatar() {
    return $this->avatar;	
  }

  function setReputation($reputation) {
    $this->reputation = $reputation;	
  }
  function getReputation() {
    return $this->reputation;	
  }

  function setReputationLvl($reputation) {
    $this->reputation_lvl = $reputation;	
  }
  function getReputationLvl() {
    return $this->reputation_lvl;	
  }

  function getCompetenceAt($index) {
    return $this->competences[$index];
  }
  function getNbCompetence() {
    return sizeof($this->competences);
  }
  function addCompetence($competence) {
    array_push($this->competences, $competence);
  }
  function setCompetenceAt($index, $competence) {
    $this->competences[$index] = $competence;
  }

  function setDescription($description) {
    $this->description = $description;	
  }
  function getDescription() {
    return $this->description;	
  }

  function setAttitude($attitude) {
    $this->attitude = $attitude;	
  }
  function getAttitude() {
    return $this->attitude;	
  }

}
?>