<?php
/**
 * PlanqueDataBean.php : DataBean utilis pour la planque
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class PlanqueDataBean {

  var $competence_SEC = "";
  var $quartier_actuel = 0;
  var $level_SEC = 0;
  var $level_MED = 0;  
  var $quartier = array();
  var $argent = 0;
  var $reputation = 0;
  
  function PlanqueDataBean() {
  }
  
  function setCompetence_SEC($competence_SEC) {
    $this->competence_SEC = $competence_SEC;	
  }

  function getCompetence_SEC() {
    return $this->competence_SEC;	
  }

  function setArgent($argent) {
    $this->argent = $argent;	
  }
  
  function getArgent() {
    return $this->argent;	
  }

  function setReputation($reputation) {
    $this->reputation = $reputation;	
  }
  
  function getReputation() {
    return $this->reputation;	
  }
  
  function setQuartier_actuel($quartier_actuel) {
    $this->quartier_actuel = $quartier_actuel;	
  }

  function getQuartier_actuel() {
    return $this->quartier_actuel;	
  }

  function setLevel_SEC($level_SEC) {
    $this->level_SEC = $level_SEC;	
  }

  function getLevel_SEC() {
    return $this->level_SEC;	
  }

  function setLevel_MED($level_MED) {
    $this->level_MED = $level_MED;	
  }

  function getLevel_MED() {
    return $this->level_MED;	
  }
  
  function getQuartierAt($index) {
    return $this->quartier[$index];
  }
  function getNbQuartier() {
    return sizeof($this->quartier);
  }
  function addQuartier($quartier) {
    array_push($this->quartier, $quartier);
  }
  function setQuartierAt($index, $quartier) {
    $this->quartier[$index] = $quartier;
  }  

  function setQuartiers($quartiers) {
    $this->quartier = $quartiers;
  }  

}
?>