<?php
/**
 * ScenarioRueDataBean.php : DataBean utilis pour les mini scnarios
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class ScenarioRueDataBean {
  
  /** La competence */
  var $even;
  var $actionList;
  var $effectList;
  
  function ScenarioRueDataBean() {
  }

  function getEvent() {
    return $this->event;
  }
  function setEvent($event) {
    $this->event = $event;
  }

  function getActionAt($i) {
    return $this->actionList[$i];
  }
  function getNbActions() {
    return sizeof($this->actionList);
  }
  function addAction($action) {
    return array_push($this->actionList, $action);
  }
  function resetActionList() {
    $this->actionList = array();
  }
  function setActionList($actionList) {
    $this->actionList = $actionList;
  }

  function getEffectAt($i) {
    return $this->effectList[$i];
  }
  function getNbEffects() {
    return sizeof($this->effectList);
  }
  function addEffect($effect) {
    return array_push($this->effectList, $effect);
  }
  function resetEffectList() {
    $this->effectList = array();
  }
}

?>