<?php
/**
 * DateManager.php : Gestionaire de Date
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class DateManager {

  function DateManager() {
  }
  
  function getCurrentDate() {
    return time();
  }

  function getFutureDate($secondes) {
    return time() + $secondes;
  }

  function getPastDate($secondes) {
    return time() - $secondes;
  }
  
  function compteRebour($date) {
    $timer = time();	
    return ($date >= $timer ? $date - $timer : 0);
  }

  function mySQLToDate($datetime) {
    return strtotime($datetime);
  }

  function dateToString($date) {
    $dateStr = "";
    if (date("Y-m-d") != date("Y-m-d", $date)) {
    	$dateStr = " le " . date("d/m/Y", $date) . ' ';
    }
    return $dateStr . ' &agrave; '. date("H:i:s", $date);
  }
    
}

?>