<?php
/**
 * SystemeDes.php : Gestionaire de Ds
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class SystemeDes {

  var $xp_mult;
  
  function SystemeDes($xp_mult) {
    $this->xp_mult = $xp_mult;
  }
  
  function jeter($level, $bonus, $bonus2) {
    return round((rand(1, 5+$level) + $bonus) * ((10 + $bonus2) / 10));
  }

  function jeterN($nombre, $face) {
    $resultats = 0;
    for ($i = 0; $i < $nombre; $i++) {
      $resultat += $this->jeter($face-5, 0, 0);
    }
    return $resultat;
  }

  function jeterOpposition($jr_level, $jr_bonus, $jr_bonus2, $ad_level, $ad_bonus, $ad_bonus2) {
    $jr_des = $this->jeter($jr_level, $jr_bonus, $jr_bonus2);
    $ad_des = $this->jeter($ad_level, $ad_bonus, $ad_bonus2);
    //$logManager->message("D1 : ".$jr_des." D2 : ".$ad_des);
    return  $jr_des - $ad_des;
  }

  function jeterDifficulte($jr_level, $jr_bonus, $jr_bonus2, $diff) {
    $jr_des = $this->jeter($jr_level, $jr_bonus, $jr_bonus2);
    $ad_des = $this->jeter($diff-5, 0, 0);
    //$logManager->message("D1 : ".$jr_des." D2 : ".$ad_des);
    return  $jr_des - $ad_des;
  }
  
  function calculeXP($reussite, $jr_level, $op_level) {
    $temp = $reussite - (($jr_level - $op_level)/2);
    if ($temp < 1) $temp = 1;
    return  round($temp * $this->xp_mult);
  }
  
}
?>