<?php
/**
 * UserManager.php : Manager pour l'utilisateur
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

 class UserManager {
  
  var $status;
  
  // Constructeur
  function UserManager() {
    $session="";
  }
  
  // Verification de la session
  function isValid($session) {
    // La session est elle active
    $this->restoreData($session);
    if ($this->getStatus()!="actif") {
        return false;
    }
    else {
      // La session est active
      return true;
    }
  }

  
  function connect($pass,$adminpass,$session) {
    if (md5($pass)==$adminpass) {
      $this->status = "actif";
      $this->saveData($session);
      return true;
    }  
    else {
      return false;
    }
  }

  function forceConnect($session) {
      $this->status = "actif";
      $this->saveData($session);
      return true;
  }

  function saveData($session) {
      $session->save("status",$this->status);
      return true;
  }

  function restoreData($session) {
      $this->status=$session->load("status");
      return true;
  }
  
  function getStatus() {
    return $this->status;
  }
}  
?>