<?php
/**
 * action_bagarre.php : partie mtier d'une bagarre contre un pj dans le bar
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_bagarre : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_newsingameDao.php");
  include_once("dao/objets/Darkcity_newsingame.php");

  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");
  $adv_name = $sessionManager->load("adversaire");

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $inventaireDao = new Darkcity_inventaireDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armeDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $bonusDao = new Darkcity_bonusDao;
  $occupationDao = new Darkcity_occupationDao;
  $planqueDao = new Darkcity_planqueDao;
  $newsingameDao = new Darkcity_newsingameDao;
  $planqueJ2 = $planqueDao->getObject(&$datasource, $adv_name);

  $occupationJ1 = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupationJ1->getOccupation_bar() <= $currentDate) {

  // Vrifier que l'dversaire est tjrs disponible
  $occupationJ2 = $occupationDao->getObject(&$datasource, $adv_name);
  if ($occupationJ2->getOccupation_datefin() <= $currentDate and $occupationJ2->getOccupation_attaque() <= $currentDate) {
  // Joueur 1 Level PHY / BGR
  $logManager->message("action_bagarre : Joueur 1 Level PHY / BGR");
  $J1_competence = $competenceDao->getObject(&$datasource, $user_name);
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_BGR = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_PHY = $levelList[0]->getXptable_level();
  $J1_vie = $J1_competence->getCompetence_VIE();
  $J1_argent = $J1_competence->getCompetence_ARG();
  $J1_reputation = $J1_competence->getCompetence_REP();
  // Joueur 1 Occupation
  $J1_occupation = $occupationDao->getObject(&$datasource, $user_name);
  // Joueur 1 Bonus PHY / BGR
  $logManager->message("action_bagarre : Joueur 1 Bonus PHY / BGR");
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'PHY' OR inventaire_cmpname = 'BGR') AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_idxArmure = -1;
  $J1_idxArme = -1;
  for ($i = 0; $i < sizeof($J1_inventaire); $i++) {
    $armeT = $J1_inventaire[$i];
    if ($armeT->getInventaire_cmpname() == 'BGR') $J1_idxArme = $i;
    if ($armeT->getInventaire_cmpname() == 'PHY') $J1_idxArmure = $i;
  }
  $J1_arme = "";
  $J1_arme_precision = 0;
  $J1_arme_nombre = 0;
  $J1_arme_degat = 0;
  $J1_arme_bonus = 0;
  $J1_arme_pds = 0;
  $J1_arme_fiabilite = "";
  if ($J1_idxArme > -1) {
    $armeT = $J1_inventaire[$J1_idxArme];
    $arme = $armeDao->getObject(&$datasource, $armeT->getInventaire_objid());
    $J1_arme = $arme->getAblanche_name();
    $J1_arme_precision = $arme->getAblanche_precision();
    $J1_arme_nombre = $arme->getAblanche_nombre();
    $J1_arme_degats = $arme->getAblanche_degats();
    $J1_arme_bonus = $arme->getAblanche_bonus();
    $J1_arme_pds = $armeT->getInventaire_structure();
    $J1_arme_fiabilite = $arme->getAblanche_fiabilite();
  }
  $J1_armure = "";
  $J1_armure_bonus = 0;
  $J1_armure_pds = 0;
  if ($J1_idxArmure > -1) {
    $armure = $armureDao->getObject(&$datasource, $J1_inventaire[$J1_idxArmure]->getInventaire_objid());
    $J1_armure = $armure->getArmure_name();
    $J1_armure_bonus = $armure->getArmure_bonus();
    $J1_armure_pds = $J1_inventaire[$J1_idxArmure]->getInventaire_structure();
  }
  // joueur 1 bonus supplementaire
  $logManager->message("action_bagarre : joueur 1 bonus supplementaire");
  $J1_bonus_BGR = 0;
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "BGR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_BGR = $bonus->getBonus_bonus();
  }
  $J1_bonus_PHY = 0;
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "PHY");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_PHY = $bonus->getBonus_bonus();
  }
  

  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $adv_name); 
    if ($competence_cpy->getCompetence_VIE() != "" && $competence_cpy->getCompetence_VIE() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_TIR($competence_cpy->getCompetence_TIR());
      $competence->setCompetence_BGR($competence_cpy->getCompetence_BGR());
      $competence->setCompetence_PHY($competence_cpy->getCompetence_PHY());
      $competence->setCompetence_REC($competence_cpy->getCompetence_REC());
      $competence->setCompetence_SEC($competence_cpy->getCompetence_SEC());
      $competence->setCompetence_RPR($competence_cpy->getCompetence_RPR());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competence->setCompetence_MED($competence_cpy->getCompetence_MED());
      $competence->setCompetence_PER($competence_cpy->getCompetence_PER());
      $competence->setCompetence_REP($competence_cpy->getCompetence_REP());
      $competence->setCompetence_VIE($competence_cpy->getCompetence_VIE());
      $competence->setCompetence_ARG($competence_cpy->getCompetence_ARG());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
    $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
    $sql = "SELECT * FROM darkcity_inventaire_cpy WHERE inventaire_user = '".$adv_name."' ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
    $inventaire_cpyList = $inventaire_cpyDao->listQuery(&$datasource, $sql); 
    for ($i = 0; $i < sizeof($inventaire_cpyList); $i++) {
      $objet_cpy = $inventaire_cpyList[$i];
      $objet = new Darkcity_inventaire;
      $objet->setInventaire_id($objet_cpy->getInventaire_id());
      $objet->setInventaire_cmpname($objet_cpy->getInventaire_cmpname());
      $objet->setInventaire_user($objet_cpy->getInventaire_user());
      $objet->setInventaire_objid($objet_cpy->getInventaire_objid());
      $objet->setInventaire_structure($objet_cpy->getInventaire_structure());
      $objet->setInventaire_actif($objet_cpy->getInventaire_actif());
      $inventaireDao = new Darkcity_inventaireDao;  
      $objetTemp = $inventaireDao->getObject(&$datasource, $objet->getInventaire_id()); 
      if ($objetTemp->getInventaire_cmpname() == "") {
        $inventaireDao->create(&$datasource, $objet);
      } else {
        $inventaireDao->save(&$datasource, $objet);
      }
      $inventaire_cpyDao->delete(&$datasource, $objet_cpy);
    }
  
  // Joueur 2 Level PHY / BGR
  $logManager->message("action_bagarre : Joueur 2 Level PHY / BGR");
  $J2_competence = $competenceDao->getObject(&$datasource, $adv_name); 
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2_level_BGR = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2_level_PHY = $levelList[0]->getXptable_level();
  $J2_vie = $J2_competence->getCompetence_VIE();
  $J2_argent = $J2_competence->getCompetence_ARG();
  $J2_reputation = $J2_competence->getCompetence_REP();
  
  // Joueur 2 Bonus PHY / BGR
  $logManager->message("action_bagarre : Joueur 2 Bonus PHY / BGR");
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$adv_name."' AND (inventaire_cmpname = 'PHY' OR inventaire_cmpname = 'BGR') AND inventaire_actif = '1';";
  $J2_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J2_idxArmure = -1;
  $J2_idxArme = -1;
  for ($i = 0; $i < sizeof($J2_inventaire); $i++) {
    $armeT = $J2_inventaire[$i];
    if ($armeT->getInventaire_cmpname() == 'BGR') $J2_idxArme = $i;
    if ($armeT->getInventaire_cmpname() == 'PHY') $J2_idxArmure = $i;
  }
  $J2_arme = "";
  $J2_arme_precision = 0;
  $J2_arme_nombre = 0;
  $J2_arme_degat = 0;
  $J2_arme_bonus = 0;
  $J2_arme_pds = 0;
  $J2_arme_fiabilite = "";
  if ($J2_idxArme > -1) {
    $armeT = $J2_inventaire[$J2_idxArme];
    $arme = $armeDao->getObject(&$datasource, $armeT->getInventaire_objid());
    $J2_arme = $arme->getAblanche_name();
    $J2_arme_precision = $arme->getAblanche_precision();
    $J2_arme_nombre = $arme->getAblanche_nombre();
    $J2_arme_degats = $arme->getAblanche_degats();
    $J2_arme_bonus = $arme->getAblanche_bonus();
    $J2_arme_pds = $J2_inventaire[$J2_idxArme]->getInventaire_structure();
    $J2_arme_fiabilite = $arme->getAblanche_fiabilite();
  }
  $J2_armure = "";
  $J2_armure_bonus = 0;
  $J2_armure_pds = 0;
  if ($J2_idxArmure > -1) {
    $armure = $armureDao->getObject(&$datasource, $J2_inventaire[$J2_idxArmure]->getInventaire_objid());
    $J2_armure = $armure->getArmure_name();
    $J2_armure_bonus = $armure->getArmure_bonus();
    $J2_armure_pds = $J2_inventaire[$J2_idxArmure]->getInventaire_structure();
  }
  // Joueur 2 Occupation
  $J2_occupation = $occupationDao->getObject(&$datasource, $adv_name);
  // joueur 2 bonus supplementaire
  $logManager->message("action_bagarre : Joueur 2 bonus supplementaire");
  $J2_bonus_BGR = 0;
  $bonus = $bonusDao->getObject(&$datasource, $adv_name, "BGR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J2_bonus_BGR = $bonus->getBonus_bonus();
  }
  $J2_bonus_PHY = 0;
  $bonus = $bonusDao->getObject(&$datasource, $adv_name, "PHY");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J2_bonus_PHY = $bonus->getBonus_bonus();
  }

  $texte = "";
  $continuer_cbt = $TRUE;   
  // Le joueur 2 FUIT il
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J1_reputation)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1levelREP = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J2_reputation)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2levelREP = $levelList[0]->getXptable_level();
  if ($planqueJ2->getPlanque_attitude() == "FUITE") {
    $texte="$user_name et $adv_name sont face  face prt  en dcoudre. Cependant $adv_name tente de s'enfuir et $user_name tente de le rattraper...\n";
  
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_PIL()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $J2_level_PIL = $levelList[0]->getXptable_level();

    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PIL()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $J1_level_PIL = $levelList[0]->getXptable_level();

    $poursuite = $systemeDes->jeterOpposition($J2_level_PIL, 0, 0, $J1_level_PIL, 0, 0);
    $logManager->message("poursuite : ".$J2_level_PIL." ".$J1_level_PIL." ".$poursuite);

    if ($poursuite > 0) {
      $texte=$texte."$adv_name semble bien plus rapide que $user_name, et il finit par lui chapper.\n";
  
      $texteJ1=$texteJ1."Vous lui avez vraiment fait peur, vous vous pavanez comme un coq.\n\n";
     	// (Ton level / (celui de l'aversaire * 20)) 
    	// 30 / 40	= 0.0375 (3,75 %) 
  	  // 40 / 30  = 0.0666 (6.66 %)
      // 40 / 10  = 0.2    (20%)   
      $pourcentage = ($J2_level_PIL / ($J1_level_PIL * 20));
      $J1bonusREP = 25 + round((abs($J2_reputation) * $pourcentage)/5);
      if ($J1bonusREP > 1000) $J1bonusREP = 1000;
      $logManager->message('Fuite = '.$J1_level_PIL.', '.$J2_level_PIL.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
      //
      $texteJ1=$texteJ1."Votre Mauvaise Rputation augmente de $J1bonusREP points";
      $J1_competence->setCompetence_REP($J1_competence->getCompetence_REP() - $J1bonusREP);
      $competenceDao->save(&$datasource, $J1_competence);
     
      $xp_pil = $systemeDes->calculeXP($poursuite, $J2_level_PIL, $J1_level_PIL); 
      $texteJ2="\nVous gagnez $xp_pil points d'expriences en Poursuite.";
      $J2_competence->setCompetence_PIL($J2_competence->getCompetence_PIL() + $xp_pil);
      $competenceDao->save(&$datasource, $J2_competence);
      $messageManager->sendMessage('', $user_name, "Vous avez attaqu ".$adv_name, htmlspecialchars($texte.$texteJ1, ENT_QUOTES), $dateManager->getCurrentDate());
      $messageManager->sendMessage('', $adv_name, "$user_name vous a attaqu.", htmlspecialchars($texte.$texteJ2, ENT_QUOTES), $dateManager->getCurrentDate());
      $continuer_cbt = $FALSE;      
    }
    else {
      $texte=$texte."$user_name rattrappe facilement $adv_name, cela va donc partir en bagarre.\n\n";
    }
  }
  // le joueur 2 Tente t'il le Baratin
  if ($planqueJ2->getPlanque_attitude() == "BARATIN") {
     $texte="$user_name et $adv_name sont face  face prt  en dcoudre cependant, $adv_name tente de raisonner $user_name...\n";
  
     $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
     $levelList = $xptableDao->listQuery(&$datasource, $sql); 
     $J2_level_PER = $levelList[0]->getXptable_level();

     $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
     $levelList = $xptableDao->listQuery(&$datasource, $sql); 
     $J1_level_PER = $levelList[0]->getXptable_level();

     $palabre = $systemeDes->jeterOpposition($J2_level_PER, 0, 0, $J1_level_PER, 0, 0);
     $logManager->message("palabre : ".$J2_level_PER." ".$J1_level_PER." ".$palabre);
    
     if ($palabre > 0) {
     	$texte=$texte."Aprs un court palabre, $user_name semble dsempar, il a perdu toute mchancet et a l'air plutt idiot.\n";
     	$texte=$texte."Ce que lui a dit $adv_name l'a  priori bien calm, une bagarre inutile d'vite.\n\n";
     	// (Ton level / (celui de l'aversaire * 20)) 
    	// 30 / 40	= 0.0375 (3,75 %) 
  	  // 40 / 30  = 0.0666 (6.66 %)
      // 40 / 10  = 0.2    (20%)   
      $pourcentage = ($J1_level_PER / ($J2_level_PER * 20));
      $J1bonusREP = round(abs($J1_reputation) * $pourcentage);
        if ($J1_reputation >= 0) {
        	 $J1bonusREP = round(-0.3 * J1bonusREP);
        }
        if ($J1bonusREP > 1000) $J1bonusREP = 1000;
        if ($J1bonusREP < -1000) $J1bonusREP = -1000;
        $xp_reputation = $systemeDes->calculeXP($palabre, $J2levelREP, $J1levelREP);
        $texteJ1="Votre air idiot n'a chapp  personne, votre Rputation diminue de ".abs($J1bonusREP)." points.";
        $J1_competence->setCompetence_REP($J1_competence->getCompetence_REP() + $J1bonusREP);
        $competenceDao->save(&$datasource, $J1_competence);
        $xp_per = $systemeDes->calculeXP($palabre, $J2_level_PER, $J1_level_PER); 
        $texteJ2="Vous gagnez $xp_per points d'expriences en Persuasion.";
        $J2_competence->setCompetence_PER($J2_competence->getCompetence_PER() + $xp_per);
        $competenceDao->save(&$datasource, $J2_competence);

        $messageManager->sendMessage('', $user_name, "Vous avez attaqu ".$adv_name, htmlspecialchars($texte.$texteJ1, ENT_QUOTES), $dateManager->getCurrentDate());
        $messageManager->sendMessage('', $adv_name, "$user_name vous a attaqu.", htmlspecialchars($texte.$texteJ2, ENT_QUOTES), $dateManager->getCurrentDate());

        $continuer_cbt = $FALSE;      
     }
     else {
     	$texte=$texte."Aprs un court palabre, il semble que cela ne change rien, cela va donc partir en bagarre.\n\n";
     }
  }
  $mult = 1;
  if ($planqueJ2->getPlanque_attitude() == "COMBAT") {
    $mult = 1.3;
  }

  if ($continuer_cbt) {
 
  $logManager->message("action_bagarre : Texte d'intro");
  $texte=$texte."Un combat s'engage entre ".$user_name." et ".$adv_name."\n\n";
  $texte=$texte."$user_name :\n";
  $texte=$texte."* Niveau de bagarre 1D".($J1_level_BGR+5)."+".($J1_arme_precision+$J1_bonus_BGR).".\n";
  $texte=$texte."* Niveau de physique 1D".($J1_level_PHY+5)."+".($J1_armure_bonus+$J1_bonus_PHY).".\n";
  if ($J1_arme != "") {
    $texte=$texte."* Il se bat avec ".$J1_arme." infligeant ".$J1_arme_nombre."D".$J1_arme_degats."+".$J1_arme_bonus." de dgts.\n";
  }
  else  {
    $texte=$texte."* Il se bat  main nues infligeant 1D3 de dgts.\n";
  }
  if ($J1_armure != "") {
    $texte=$texte."* Il porte galement ".$J1_armure." pour se protger.\n";
  }
  $texte=$texte."\n$adv_name :\n";
  $texte=$texte."* Niveau de bagarre 1D".($J2_level_BGR+5)."+".($J2_arme_precision+$J2_bonus_BGR).".\n";
  $texte=$texte."* Niveau de physique 1D".($J2_level_PHY+5)."+".($J2_armure_bonus+$J2_bonus_PHY).".\n";
  if ($J2_arme != "") {
    $texte=$texte."* Il se bat avec ".$J2_arme." infligeant ".$J2_arme_nombre."D".$J2_arme_degats."+".$J2_arme_bonus." de dgts.\n";
  }
  else  {
    $texte=$texte."* Il se bat  main nues infligeant 1D3 de dgts.\n";
  }
  if ($J2_armure != "") {
    $texte=$texte."* Il porte galement ".$J2_armure." pour se protger.\n";
  }
 
  $J1_xp_BGR = 0;
  $J1_xp_PHY = 0;
  $J2_xp_BGR = 0;
  $J2_xp_PHY = 0;
  $J1_total_degats = 0;
  $J2_total_degats = 0;
  $round = 1;
  $continu_combat = $TRUE;
  $abandon = "";

  // Le combat
  while ($continu_combat) {  
    $logManager->message("action_bagarre : Round ".$round);
    $texte=$texte."\nRound ".$round." :\n";
    $texte=$texte.$user_name." porte un coup de ".($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme : "poing").", ";
    $attaqueJ1 = $systemeDes->jeterOpposition($J1_level_BGR, $J1_arme_bonus+$J1_bonus_BGR, 0, $J2_level_PHY, $J2_armure_bonus+$J2_bonus_PHY, 0);
    $logManager->message("action_bagarre : ".$user_name.($attaqueJ1 > 0 ? " touche." : " rate")); 
    if ($attaqueJ1 > 0) {
      $degats = $systemeDes->jeterN(($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_nombre : 1), ($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_degats : 3)) +  ($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_bonus : 0);
      $texte=$texte."il touche ".$adv_name." et lui inflige ".$degats." points de dgats.";
      $J2_vie -= $degats;
      $J1_total_degats += $degats;
      $J1_xp_BGR += $systemeDes->calculeXP($attaqueJ1,$J1_level_BGR, $J2_level_PHY);
      $continu_combat = ($J2_vie >= 25);
      if ($J2_armure != "" && $J2_armure_pds > 0) {
        $J2_armure_pds -= 1;
        if ($J2_armure_pds <= 0) {
          $J2_armure_pds = 0;
          $J2_armure_bonus = 0;
          $texte=$texte." ".$J2_armure." de ".$adv_name." se casse et devient inefficace.";        
        }
      }
      if (!$continu_combat) {
        $abandon = "J2";
        if ($J2_vie < 1) $J2_vie = 1;
        $texte=$texte."\n".$adv_name." tombe vanouie, le combat est termin.";        
      }     
    }
    else {
      $texte=$texte."il rate ".$adv_name.".";
      $J2_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ1), $J2_level_PHY, $J1_level_BGR);
      if ($J1_arme != "" && $J1_arme_pds > 0) {
        if ($systemeDes->jeterN(1,($J1_arme_fiabilite == "F" ? 2 : ($J1_arme_fiabilite == "S" ? 3 : 4))) == 1) {
          $dg = $systemeDes->jeterN(1, 6);
          $J1_arme_pds -= $dg;
          $texte=$texte." ".$J1_arme." de ".$user_name." prend un choc de $dg points de structure.";        
          if ($J1_arme_pds <= 0) {
            $J1_arme_pds = 0;
            $J1_arme_precision = 0;
            $texte=$texte." ".$J1_arme." de ".$user_name." se casse et devient inefficace.";        
          }
        }
      }
    }
    if ($continu_combat) {
      $texte=$texte."\n".$adv_name." porte un coup de ".($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme : "poing").", ";
      $attaqueJ2 = $systemeDes->jeterOpposition($J2_level_BGR, $J2_arme_bonus+$J2_bonus_BGR, 0, $J1_level_PHY, $J1_armure_bonus+$J1_bonus_PHY, 0);
      $logManager->message("action_bagarre : ".$adv_name.($attaqueJ2 > 0 ? " touche." : " rate")); 
      if ($attaqueJ2 > 0) {
        $degats = $systemeDes->jeterN(($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_nombre : 1), ($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_degats : 3)) +  ($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_bonus : 0);
        $texte=$texte."il touche ".$user_name." et lui inflige ".$degats." points de dgats.";
        $J1_vie -= $degats;
        $J2_total_degats += $degats;
        $J2_xp_BGR += $systemeDes->calculeXP($attaqueJ2, $J2_level_BGR, $J1_level_PHY);
        $continu_combat = ($J1_vie >= 25);
        if ($J1_armure != "" && $J1_armure_pds > 0) {
          $J1_armure_pds -= 1;
          if ($J1_armure_pds <= 0) {
            $J1_armure_pds = 0;
            $J1_armure_bonus = 0;
            $texte=$texte." ".$J1_armure." de ".$user_name." se casse et devient inefficace.";        
          }
        }
        if (!$continu_combat) {
          $abandon = "J1";
          if ($J1_vie < 1) $J1_vie = 1;
          $texte=$texte."\n".$user_name." tombe vanouie, le combat est termin.";        
        }
      }
      else {
        $texte=$texte."il rate ".$user_name.".";
        $J1_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ2), $J1_level_PHY, $J2_level_BGR);
        if ($J2_arme != "" && $J2_arme_pds > 0) {
          if ($systemeDes->jeterN(1,($J2_arme_fiabilite == "F" ? 2 : ($J2_arme_fiabilite == "S" ? 3 : 4))) == 1) {
            $dg = $systemeDes->jeterN(1, 6);
            $J2_arme_pds -= $dg;
            $texte=$texte." ".$J2_arme." de ".$adv_name." prend un choc de $dg points de structure.";        
            if ($J2_arme_pds <= 0) {
              $J2_arme_pds = 0;
              $J2_arme_precision = 0;
              $texte=$texte." ".$J2_arme." de ".$adv_name." se casse et devient inefficace.";        
            }
          }
        }
      }
    }  
    $texte=$texte."\n";
    $continu_combat = ($continu_combat && $round < $NB_ROUNDS);
    $round++;
  }
  // Les XP du J2 sont valoriss par le multiplicatuer
  $J2_xp_BGR = round($J2_xp_BGR * $mult);
  $J2_xp_PHY = round($J2_xp_PHY * $mult);
  $texte=$texte."\nFin du combat :\n";
  $texte=$texte."Dgats infligs par ".$user_name." : ".$J1_total_degats."\n";
  $texte=$texte."Dgats infligs par ".$adv_name." : ".$J2_total_degats."\n";
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J1_reputation)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1levelREP = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J2_reputation)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2levelREP = $levelList[0]->getXptable_level();
  
  $J1xpREP = 0;
  $J2xpREP = 0;
  // Reputations
  if ($J1_total_degats == $J2_total_degats && $abandon == "") {
    $texte=$texte."Egalit.\n";
    $pourcentage = (($J2_level_BGR + $J2_level_PHY) / (($J1_level_BGR + $J1_level_PHY) * 20));
    $J1xpREP = -1 * round((abs($J2_reputation) * $pourcentage)/2);
    $J2xpREP = 0;
    $J1xpREP -= 25;
    $gain = 0;
  }
  else if (($J1_total_degats > $J2_total_degats && $abandon != "J1") || $abandon == "J2") {
    $texte=$texte."Vainqueur ".$user_name.".\n";
    $gain = round($J2_argent / 10);
    if ($gain > 3000) $gain = 3000;
    $J1_argent += $gain; 
    $J2_argent -= $gain; 
    $pourcentage = (($J2_level_BGR + $J2_level_PHY) / (($J1_level_BGR + $J1_level_PHY) * 20));
    $J1xpREP = -1 * round(abs($J2_reputation) * $pourcentage);
    $J2xpREP = 0;
    if ($J2_reputation < 0) {
      $J2xpREP = -1 * $J1xpREP;
    }
    $J1xpREP -= 25;
  }
  else {
    $texte=$texte."Vainqueur ".$adv_name.".\n";
    $gain = round($J1_argent / 10);
    if ($gain > 3000) $gain = 3000;
    $J2_argent += $gain; 
    $J1_argent -= $gain; 
    $pourcentage = (($J1_level_BGR + $J1_level_PHY) / (($J2_level_BGR + $J2_level_PHY) * 20));
    $J1xpREP = round(abs($J1_reputation) * $pourcentage);
    $J2xpREP = 0;
    if ($J2_reputation < 0) {
      $J2xpREP = -1 * $J1xpREP;
    }
    if ($J1_reputation >= 0) {
       $J1xpREP = round(-0.3 * $J1xpREP);
    }
  }
  if ($J1xpREP > 1000) $J1xpREP = 1000;
  if ($J1xpREP < -1000) $J1xpREP = -1000;
  if ($J2xpREP > 1000) $J2xpREP = 1000;
  if ($J2xpREP < -1000) $J2xpREP = -1000;

  // Texte spcifique J1
  $texteJ1 = "\nVous gagnez ".$J1_xp_BGR." points d'exprience en Bagarre\n";
  $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_PHY." points d'exprience en Physique\n";
  $texteJ1 = $texteJ1."Vous ".($J1xpREP < 0 ? "gagnez" : "perdez")." ".abs($J1xpREP)." points de Mauvaise Rputation.\n";
  $J1_reputation += $J1xpREP;

  // Texte spcifique J2
  $texteJ2 = "\nVous gagnez ".$J2_xp_BGR." points d'exprience en Bagarre\n";
  $texteJ2 = $texteJ2."Vous gagnez ".$J2_xp_PHY." points d'exprience en Physique\n";
  if ((($J1_total_degats > $J2_total_degats && $abandon != "J1") || $abandon == "J2") && $gain > 0) {
    $texteJ2 = $texteJ2."Vous perdez ".$gain."$\n";
    $texteJ1 = $texteJ1."Vous gagnez ".$gain."$\n";
  } else if ((($J1_total_degats < $J2_total_degats && $abandon != "J2") || $abandon == "J1") && $gain > 0) {
    $texteJ2 = $texteJ2."Vous gagnez ".$gain."$\n";
    $texteJ1 = $texteJ1."Vous perdez ".$gain."$\n";
  }
  if ($J2_reputation < 0) {
    $texteJ2 = $texteJ2."Vous ".($J2xpREP < 0 ? "gagnez" : "perdez").abs($J2xpREP)." points de Mauvaise Rputation.";
    $J2_reputation += $J2xpREP;
  }

  // On sauvegarde les nouvelles comptences de J1
  $J1_competence->setCompetence_BGR($J1_competence->getCompetence_BGR()+$J1_xp_BGR);
  $J1_competence->setCompetence_PHY($J1_competence->getCompetence_PHY()+$J1_xp_PHY);
  $J1_competence->setCompetence_VIE($J1_vie);
  $J1_competence->setCompetence_ARG($J1_argent);
  $J1_competence->setCompetence_REP($J1_reputation);
  $logManager->message("action_bagarre : ".$user_name." ".$J1_competence->toString()); 
  $competenceDao->save(&$datasource, $J1_competence);

  // On sauvegarde l'inventaire de J1
  if ($J1_idxArme > -1) {
    $objet = $J1_inventaire[$J1_idxArme];
    $objet->setInventaire_structure($J1_arme_pds);
    if ($J1_arme_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  if ($J1_idxArmure > -1) {
    $objet = $J1_inventaire[$J1_idxArmure];
    $objet->setInventaire_structure($J1_armure_pds);
    if ($J1_armure_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  
  
  // On sauvegarde les nouvelles comptences de J2
  $J2_competence->setCompetence_BGR($J2_competence->getCompetence_BGR()+$J2_xp_BGR);
  $J2_competence->setCompetence_PHY($J2_competence->getCompetence_PHY()+$J2_xp_PHY);
  $J2_competence->setCompetence_VIE($J2_vie);
  $J2_competence->setCompetence_ARG($J2_argent);
  $J2_competence->setCompetence_REP($J2_reputation);
  $logManager->message("action_bagarre : ".$adv_name." ".$J2_competence->toString()); 
  $competenceDao->save(&$datasource, $J2_competence);

  // On sauvegarde l'inventaire de J2
  if ($J2_idxArme > -1) {
    $objet = $J2_inventaire[$J2_idxArme];
    $objet->setInventaire_structure($J2_arme_pds);
    if ($J2_arme_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  if ($J2_idxArmure > -1) {
    $objet = $J2_inventaire[$J2_idxArmure];
    $objet->setInventaire_structure($J2_armure_pds);
    if ($J2_armure_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  
  $messageManager->sendMessage('', $user_name, "Vous avez attaqu ".$adv_name, htmlspecialchars(str_replace("&#39;","'",$texte.$texteJ1), ENT_QUOTES), $dateManager->getCurrentDate());

  $messageManager->sendMessage('', $adv_name, "$user_name vous a attaqu.", htmlspecialchars(str_replace("&#39;","'",$texte.$texteJ2), ENT_QUOTES), $dateManager->getCurrentDate());
}
  // On sauvegarde l'occupation de J1
  $J1_occupation->setOccupation_bar($dateManager->getFutureDate($DELAI_BAR));
  $occupationDao->save(&$datasource, $J1_occupation);
  // On sauvegarde l'occupation de J2
  $J2_occupation->setOccupation_attaque($dateManager->getFutureDate(30*$MINUTE));
  $occupationDao->save(&$datasource, $J2_occupation);
  $logManager->message("action_bagarre : \n".$texte.$texteJ1); 
  }
  else {
    $infoManager->setMessage(htmlspecialchars("Vous avez trop tard, cette personne est parti  d'autres occupations...",ENT_QUOTES));
    $J1_occupation->setOccupation_bar($currentDate);
    $occupationDao->save(&$datasource, $J1_occupation);
  }
  }
  $logManager->message("action_bagarre : fin");
?>