<?php
/**
 * action_bagarre_pnj.php : partie mtier d'une bagarre contre un pnj
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

  $logManager->message("action_bagarre : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("databean/FicheAdversaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");

  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");
  $pnj = $sessionManager->load("pnj");
  $adv_name = $pnj->getName();
  $logManager->message($adv_name);
  
  
  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $inventaireDao = new Darkcity_inventaireDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armeDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $bonusDao = new Darkcity_bonusDao;
  $occupationDao = new Darkcity_occupationDao;

  // Joueur 1 Level PHY / BGR
  $logManager->message("action_bagarre : Joueur 1 Level PHY / BGR");
  $J1_competence = $competenceDao->getObject(&$datasource, $user_name);
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_BGR = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_PHY = $levelList[0]->getXptable_level();
  $J1_vie = $J1_competence->getCompetence_VIE();
  $J1_argent = $J1_competence->getCompetence_ARG();
  $J1_reputation = $J1_competence->getCompetence_REP();
  // Joueur 1 Occupation
  $J1_occupation = $occupationDao->getObject(&$datasource, $user_name);
  // Joueur 1 Bonus PHY / BGR
  $logManager->message("action_bagarre : Joueur 1 Bonus PHY / BGR");
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'PHY' OR inventaire_cmpname = 'BGR') AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_idxArmure = -1;
  $J1_idxArme = -1;
  for ($i = 0; $i < sizeof($J1_inventaire); $i++) {
    $armeT = $J1_inventaire[$i];
    if ($armeT->getInventaire_cmpname() == 'BGR') $J1_idxArme = $i;
    if ($armeT->getInventaire_cmpname() == 'PHY') $J1_idxArmure = $i;
  }
  $J1_arme = "";
  $J1_arme_precision = 0;
  $J1_arme_nombre = 0;
  $J1_arme_degat = 0;
  $J1_arme_bonus = 0;
  $J1_arme_pds = 0;
  $J1_arme_fiabilite = "";
  if ($J1_idxArme > -1) {
    $armeT = $J1_inventaire[$J1_idxArme];
    $arme = $armeDao->getObject(&$datasource, $armeT->getInventaire_objid());
    $J1_arme = $arme->getAblanche_name();
    $J1_arme_precision = $arme->getAblanche_precision();
    $J1_arme_nombre = $arme->getAblanche_nombre();
    $J1_arme_degats = $arme->getAblanche_degats();
    $J1_arme_bonus = $arme->getAblanche_bonus();
    $J1_arme_pds = $armeT->getInventaire_structure();
    $J1_arme_fiabilite = $arme->getAblanche_fiabilite();
  }
  $J1_armure = "";
  $J1_armure_bonus = 0;
  $J1_armure_pds = 0;
  if ($J1_idxArmure > -1) {
    $armure = $armureDao->getObject(&$datasource, $J1_inventaire[$J1_idxArmure]->getInventaire_objid());
    $J1_armure = $armure->getArmure_name();
    $J1_armure_bonus = $armure->getArmure_bonus();
    $J1_armure_pds = $J1_inventaire[$J1_idxArmure]->getInventaire_structure();
  }
  // joueur 1 bonus supplementaire
  $logManager->message("action_bagarre : joueur 1 bonus supplementaire");
  $J1_bonus_BGR = 0;
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "BGR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_BGR = $bonus->getBonus_bonus();
  }
  $J1_bonus_PHY = 0;
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "PHY");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_PHY = $bonus->getBonus_bonus();
  }

  // PNJ
  $logManager->message("action_bagarre : PNJ Level PHY / BGR");
  $cmp = $pnj->getCompetenceAt(0);
  $J2_level_TIR = $cmp->getLevel();
  $cmp = $pnj->getCompetenceAt(1);
  $J2_level_BGR = $cmp->getLevel();
  $cmp = $pnj->getCompetenceAt(2);
  $J2_level_PHY = $cmp->getLevel();
  $J2_vie = 100;
  
  // Joueur 2 Bonus PHY / BGR
  
  $logManager->message("action_bagarre : Joueur 2 Bonus PHY / BGR");
  $J2_idxArmure = -1;
  $J2_idxArme = -1;

  $J2_arme = "";
  $J2_arme_precision = 0;
  $J2_arme_nombre = 0;
  $J2_arme_degat = 0;
  $J2_arme_bonus = 0;
  $J2_arme_pds = 0;
  $J2_arme_fiabilite = "";
  $sql = "SELECT * FROM darkcity_arme_blanche WHERE ablanche_level <= ".$J2_level_BGR." ORDER BY ablanche_level DESC;";
  $logManager->message("action_tir_pnj : ".$sql);
  $armeList = $armeDao->listQuery(&$datasource, $sql);
  if (sizeof($armeList) > 0) {
    $arme = $armeList[$systemeDes->jeterN(1,sizeof($armeList))-1];
    $J2_idxArme = 0;
    $J2_arme = $arme->getAblanche_name();
    $J2_arme_precision = $arme->getAblanche_precision();
    $J2_arme_nombre = $arme->getAblanche_nombre();
    $J2_arme_degats = $arme->getAblanche_degats();
    $J2_arme_bonus = $arme->getAblanche_bonus();
    $J2_arme_pds = $arme->getAblanche_structure();
    $J2_arme_fiabilite = $arme->getAblanche_fiabilite();
  }
  $J2_armure = "";
  $J2_armure_bonus = 0;
  $J2_armure_pds = 0;
  /*
  if ($J2_idxArmure > -1) {
    $armure = $armureDao->getObject(&$datasource, $J2_inventaire[$J2_idxArmure]->getInventaire_objid());
    $J2_armure = $arme->getAblanche_name();
    $J2_armure_bonus = $arme->getAblanche_precision();
    $J2_armure_pds = $J2_inventaire[$J2_idxArmure]->getInventaire_structure();
  }
  */

  $J2_bonus_BGR = 0;
  $J2_bonus_PHY = 0;
 
  $logManager->message("action_bagarre : Texte d'intro");
  $texte="Un combat s'engage entre ".$user_name." et ".$pnj->getName()."\n\n";
  $texte=$texte."$user_name :\n";
  $texte=$texte."* Niveau de bagarre 1D".($J1_level_BGR+5)."+".($J1_arme_precision+$J1_bonus_BGR).".\n";
  $texte=$texte."* Niveau de physique 1D".($J1_level_PHY+5)."+".($J1_armure_bonus+$J1_bonus_PHY).".\n";
  if ($J1_arme != "") {
    $texte=$texte."* Il se bat avec ".$J1_arme." infligeant ".$J1_arme_nombre."D".$J1_arme_degats."+".$J1_arme_bonus." de dgts.\n";
  }
  else  {
    $texte=$texte."* Il se bat  main nues infligeant 1D3 de dgts.\n";
  }
  if ($J1_armure != "") {
    $texte=$texte."* Il porte galement ".$J1_armure." pour se protger.\n";
  }
  $texte=$texte."\n".$pnj->getName()." :\n";
  $texte=$texte."* Niveau de bagarre 1D".($J2_level_BGR+5)."+".($J2_arme_precision+$J2_bonus_BGR).".\n";
  $texte=$texte."* Niveau de physique 1D".($J2_level_PHY+5)."+".($J2_armure_bonus+$J2_bonus_PHY).".\n";
  if ($J2_arme != "") {
    $texte=$texte."* Il se bat avec ".$J2_arme." infligeant ".$J2_arme_nombre."D".$J2_arme_degats."+".$J2_arme_bonus." de dgts.\n";
  }
  else  {
    $texte=$texte."* Il se bat  main nues infligeant 1D3 de dgts.\n";
  }
  if ($J2_armure != "") {
    $texte=$texte."* Il porte galement ".$J2_armure." pour se protger.\n";
  }

  $J1_xp_BGR = 0;
  $J1_xp_PHY = 0;
  $J2_xp_BGR = 0;
  $J2_xp_PHY = 0;
  $J1_total_degats = 0;
  $J2_total_degats = 0;
  $round = 1;
  $continu_combat = $TRUE;
  // Le combat
  $abandon = "";
  while ($continu_combat) {  
    $logManager->message("action_bagarre : Round ".$round);
    $texte=$texte."\nRound ".$round." :\n";
    $texte=$texte.$user_name." porte un coup de ".($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme : "poing").", ";
    $attaqueJ1 = $systemeDes->jeterOpposition($J1_level_BGR, $J1_arme_bonus+$J1_bonus_BGR, 0, $J2_level_PHY, $J2_armure_bonus+$J2_bonus_PHY, 0);
    $logManager->message("action_bagarre : ".$user_name.($attaqueJ1 > 0 ? " touche." : " rate")); 
    if ($attaqueJ1 > 0) {
      $degats = $systemeDes->jeterN(($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_nombre : 1), ($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_degats : 3)) +  ($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_bonus : 0);
      $texte=$texte."il touche ".$adv_name." et lui inflige ".$degats." points de dgats.";
      $J2_vie -= $degats;
      $J1_total_degats += $degats;
      $J1_xp_BGR += $systemeDes->calculeXP($attaqueJ1,$J1_level_BGR, $J2_level_PHY);
      $continu_combat = ($J2_vie >= 25);
      if ($J2_armure != "" && $J2_armure_pds > 0) {
        $J2_armure_pds -= 1;
        if ($J2_armure_pds <= 0) {
          $J2_armure_pds = 0;
          $J2_armure_bonus = 0;
          $texte=$texte." ".$J2_armure." de ".$adv_name." se casse et devient inefficace.";        
        }
      }
      if (!$continu_combat) {
        $abandon = "J2";
        if ($J2_vie < 1) $J2_vie = 1;
        $texte=$texte."\n".$adv_name." tombe vanouie, le combat est termin.";        
      }
      
    }
    else {
      $texte=$texte."il rate ".$adv_name.".";
      $J2_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ1), $J2_level_PHY, $J1_level_BGR);
      if ($J1_arme != "" && $J1_arme_pds > 0) {
        if ($systemeDes->jeterN(1,($J1_arme_fiabilite == "F" ? 2 : ($J1_arme_fiabilite == "S" ? 3 : 4))) == 1) {
          $dg = $systemeDes->jeterN(1, 6);
          $J1_arme_pds -= $dg;
          $texte=$texte." ".$J1_arme." de ".$user_name." prend un choc de $dg points de structure.";        
          if ($J1_arme_pds <= 0) {
            $J1_arme_pds = 0;
            $J1_arme_precision = 0;
            $texte=$texte." ".$J1_arme." de ".$user_name." se casse et devient inefficace.";        
          }
        }
      }
    }
    if ($continu_combat) {
      $texte=$texte."\n".$adv_name." porte un coup de ".($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme : "poing").", ";
      $attaqueJ2 = $systemeDes->jeterOpposition($J2_level_BGR, $J2_arme_bonus+$J2_bonus_BGR, 0, $J1_level_PHY, $J1_armure_bonus+$J1_bonus_PHY, 0);
      $logManager->message("action_bagarre : ".$adv_name.($attaqueJ2 > 0 ? " touche." : " rate")); 
      if ($attaqueJ2 > 0) {
        $degats = $systemeDes->jeterN(($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_nombre : 1), ($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_degats : 3)) +  ($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_bonus : 0);
        $texte=$texte."il touche ".$user_name." et lui inflige ".$degats." points de dgats.";
        $J1_vie -= $degats;
        $J2_total_degats += $degats;
        $J2_xp_BGR += $systemeDes->calculeXP($attaqueJ2, $J2_level_BGR, $J1_level_PHY);
        $continu_combat = ($J1_vie >= 25);
        if ($J1_armure != "" && $J1_armure_pds > 0) {
          $J1_armure_pds -= 1;
          if ($J1_armure_pds <= 0) {
            $J1_armure_pds = 0;
            $J1_armure_bonus = 0;
            $texte=$texte." ".$J1_armure." de ".$user_name." se casse et devient inefficace.";        
          }
        }
        if (!$continu_combat) {
          $abandon = "J1";
          if ($J1_vie < 1) $J1_vie = 1;
          $texte=$texte."\n".$user_name." tombe vanouie, le combat est termin.";        
        }
      }
      else {
        $texte=$texte."il rate ".$user_name.".";
        $J1_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ2), $J1_level_PHY, $J2_level_BGR);
        if ($J2_arme != "" && $J2_arme_pds > 0) {
          if ($systemeDes->jeterN(1,($J2_arme_fiabilite == "F" ? 2 : ($J2_arme_fiabilite == "S" ? 3 : 4))) == 1) {
            $dg = $systemeDes->jeterN(1, 6);
            $J2_arme_pds -= $dg;
            $texte=$texte." ".$J2_arme." de ".$adv_name." prend un choc de $dg points de structure.";        
            if ($J2_arme_pds <= 0) {
              $J2_arme_pds = 0;
              $J2_arme_precision = 0;
              $texte=$texte." ".$J2_arme." de ".$user_name." se casse et devient inefficace.";        
            }
          }
        }
      }
    }  
    $texte=$texte."\n";
    $continu_combat = ($continu_combat && $round < $NB_ROUNDS);
    $round++;
  }

  $texte=$texte."\nFin du combat :\n";
  $texte=$texte."Dgats infligs par ".$user_name." : ".$J1_total_degats."\n";
  $texte=$texte."Dgats infligs par ".$adv_name." : ".$J2_total_degats."\n";
  if ($J1_total_degats == $J2_total_degats && $abandon == "") {
    $texte=$texte."Egalit.\n";
    $gain = 0;
    $xp_reputation = $J2_level_BGR * $XP_MULTIPLIEUR;
  }
  else if (($J1_total_degats > $J2_total_degats && $abandon != "J1") || $abandon == "J2") {
    $texte=$texte."Vainqueur ".$user_name.".\n";
    $gain = 0;
    $gain =  50 + (round(($J2_level_BGR + $J2_level_TIR + $J2_level_PHY)/3) * 5);
    $J1_argent += $gain; 
    $xp_reputation = $J2_level_BGR * $XP_MULTIPLIEUR * 2;
  }
  else {
    $texte=$texte."Vainqueur ".$adv_name.".\n";
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J1_reputation)."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $xp_reputation = ($levelList[0]->getXptable_level() * $XP_MULTIPLIEUR);
    if (abs($J1_reputation) < $xp_reputation) $xp_reputation = $J1_reputation;
  }

  // Texte spcifique J1
  $texteJ1 = "\nVous gagnez ".$J1_xp_BGR." points d'exprience en Bagarre\n";
  $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_PHY." points d'exprience en Physique\n";
  if ($gain > 0) {
      if ($adv_name == "Policier") {
        $texteJ1 = $texteJ1."Vous faites les poches de votre victime et gagnez ".$gain."$\n";
      }
      else {
        $texteJ1 = $texteJ1."La police vous offre une prime pour avoir arrt ce bandit : ".$gain."$\n";
      }
  }
  if (($J1_total_degats < $J2_total_degats && $abandon != "J2") || $abandon == "J1") {
    $texteJ1 = $texteJ1."Votre dfaite fait diminuer votre ".($adv_name == "Policier" ? "Mauvaise" : "Bonne")." rputation de ".$xp_reputation." points.";
    $J1_reputation = ($adv_name == "Policier" ? $J1_reputation + $xp_reputation : $J1_reputation - $xp_reputation);
  }
  else if ($J1_total_degats > $J2_total_degats || $abandon == "J2") {
    $texteJ1 = $texteJ1."Votre victoire fait augmenter votre ".($adv_name == "Policier" ? "Mauvaise" : "Bonne")." rputation de ".$xp_reputation." points.";
    $J1_reputation = ($adv_name == "Policier" ? $J1_reputation - $xp_reputation : $J1_reputation + $xp_reputation);
  }
  else {
    $texteJ1 = $texteJ1."Cette galit n'affecte pas votre Rputation.";
  }
  // On sauvegarde les nouvelles comptences de J1
  // On met  jour la comptence
  $competence_cpyDao = new Darkcity_competence_cpyDao;
  $competence_cpy = new Darkcity_competence_cpy;
  $competence_cpy->setCompetence_user($J1_competence->getCompetence_user());
  $competence_cpy->setCompetence_TIR($J1_competence->getCompetence_TIR());
  $competence_cpy->setCompetence_BGR($J1_competence->getCompetence_BGR()+$J1_xp_BGR);
  $competence_cpy->setCompetence_PHY($J1_competence->getCompetence_PHY()+$J1_xp_PHY);
  $competence_cpy->setCompetence_REC($J1_competence->getCompetence_REC());
  $competence_cpy->setCompetence_SEC($J1_competence->getCompetence_SEC());
  $competence_cpy->setCompetence_RPR($J1_competence->getCompetence_RPR());
  $competence_cpy->setCompetence_PIL($J1_competence->getCompetence_PIL());
  $competence_cpy->setCompetence_MED($J1_competence->getCompetence_MED());
  $competence_cpy->setCompetence_PER($J1_competence->getCompetence_PER());
  $competence_cpy->setCompetence_REP($J1_reputation);
  $competence_cpy->setCompetence_VIE($J1_vie);
  $competence_cpy->setCompetence_ARG($J1_argent);
  $competence_cpyDao->create(&$datasource, $competence_cpy);
/*
  $J1_competence->setCompetence_BGR($J1_competence->getCompetence_BGR()+$J1_xp_BGR);
  $J1_competence->setCompetence_PHY($J1_competence->getCompetence_PHY()+$J1_xp_PHY);
  $J1_competence->setCompetence_VIE($J1_vie);
  $J1_competence->setCompetence_ARG($J1_argent);
  $J1_competence->setCompetence_REP($J1_reputation);
  $competenceDao->save(&$datasource, $J1_competence);
*/
  // On sauvegarde l'inventaire de J1
  $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
  if ($J1_idxArme > -1) {
    $objet = $J1_inventaire[$J1_idxArme];
    $objet_cpy = new Darkcity_inventaire_cpy;
    $objet_cpy->setInventaire_id($objet->getInventaire_id());
    $objet_cpy->setInventaire_cmpname($objet->getInventaire_cmpname());
    $objet_cpy->setInventaire_user($objet->getInventaire_user());
    $objet_cpy->setInventaire_objid($objet->getInventaire_objid());
    $objet_cpy->setInventaire_structure($J1_arme_pds);
    $objet_cpy->setInventaire_actif(($objet_cpy->getInventaire_structure() == 0 ? $FALSE : $TRUE));
    $inventaire_cpyDao->create(&$datasource, $objet_cpy);
  }
  if ($J1_idxArmure > -1) {
    $objet = $J1_inventaire[$J1_idxArmure];
    $objet_cpy = new Darkcity_inventaire_cpy;
    $objet_cpy->setInventaire_id($objet->getInventaire_id());
    $objet_cpy->setInventaire_cmpname($objet->getInventaire_cmpname());
    $objet_cpy->setInventaire_user($objet->getInventaire_user());
    $objet_cpy->setInventaire_objid($objet->getInventaire_objid());
    $objet_cpy->setInventaire_structure($J1_armure_pds);
    $objet_cpy->setInventaire_actif(($objet_cpy->getInventaire_structure() == 0 ? $FALSE : $TRUE));
    $inventaire_cpyDao->create(&$datasource, $objet_cpy);
  }

  // On sauvegarde l'occupation de J1
  //$J1_occupation->setOccupation_occupation("Vous tes occup dans les rues de DarkCity");
  $J1_occupation->setOccupation_rue($dateManager->getFutureDate($DELAI_RUE));
  $occupationDao->save(&$datasource, $J1_occupation);

  $messageManager->sendMessage('', $user_name, "Vous avez rencontr&eacute; un ".$adv_name.", il y a eu lutte.", htmlspecialchars(str_replace("&#39;","'",$texte.$texteJ1), ENT_QUOTES), $dateManager->getCurrentDate());

  $logManager->message("action_bagarre : \n".$texte.$texteJ1); 
  $logManager->message("action_bagarre : fin");
?>