<?php
/**
 * action_contrat_police.php : partie mtier d'une contrat  la police
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_bagarre : debut");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_quartierDao.php");
  include_once("dao/objets/Darkcity_quartier.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");
  include_once("dao/accesseurs/Darkcity_sessionDao.php");
  include_once("dao/objets/Darkcity_session.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_newsingameDao.php");
  include_once("dao/objets/Darkcity_newsingame.php");

  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");
  $adv_name = $sessionManager->load("adversaire");

  $competenceDao = new Darkcity_competenceDao;
  $competence_cpyDao = new Darkcity_competence_cpyDao;
  $xptableDao = new Darkcity_xptableDao;
  $inventaireDao = new Darkcity_inventaireDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armeDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $bonusDao = new Darkcity_bonusDao;
  $occupationDao = new Darkcity_occupationDao;
  $planqueDao = new Darkcity_planqueDao;
  $quartierDao = new Darkcity_quartierDao;
  $sessionDao = new Darkcity_sessionDao;
  $objetDao = new Darkcity_objetDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $newsingameDao = new Darkcity_newsingameDao;
  $continuer_contrat = $TRUE;
  $delai_contrat = 0;
  $occupationJ1 = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupationJ1->getOccupation_contrat() <= $dateManager->getCurrentDate()) {

  // Vrifier que l'dversaire est tjrs disponible
  $occupationJ2 = $occupationDao->getObject(&$datasource, $adv_name);
  if ($occupationJ2->getOccupation_datefin() <= $currentDate and $occupationJ2->getOccupation_attaque() <= $currentDate) {
  
  $J1_competence = $competenceDao->getObject(&$datasource, $user_name);
  
  $competence_cpy = $competence_cpyDao->getObject(&$datasource, $adv_name); 
  if ($competence_cpy->getCompetence_VIE() != "" && $competence_cpy->getCompetence_VIE() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_TIR($competence_cpy->getCompetence_TIR());
      $competence->setCompetence_BGR($competence_cpy->getCompetence_BGR());
      $competence->setCompetence_PHY($competence_cpy->getCompetence_PHY());
      $competence->setCompetence_REC($competence_cpy->getCompetence_REC());
      $competence->setCompetence_SEC($competence_cpy->getCompetence_SEC());
      $competence->setCompetence_RPR($competence_cpy->getCompetence_RPR());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competence->setCompetence_MED($competence_cpy->getCompetence_MED());
      $competence->setCompetence_PER($competence_cpy->getCompetence_PER());
      $competence->setCompetence_REP($competence_cpy->getCompetence_REP());
      $competence->setCompetence_VIE($competence_cpy->getCompetence_VIE());
      $competence->setCompetence_ARG($competence_cpy->getCompetence_ARG());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
  }
    $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
    $sql = "SELECT * FROM darkcity_inventaire_cpy WHERE inventaire_user = '".$adv_name."' ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
    $inventaire_cpyList = $inventaire_cpyDao->listQuery(&$datasource, $sql); 
    for ($i = 0; $i < sizeof($inventaire_cpyList); $i++) {
      $objet_cpy = $inventaire_cpyList[$i];
      $objet = new Darkcity_inventaire;
      $objet->setInventaire_id($objet_cpy->getInventaire_id());
      $objet->setInventaire_cmpname($objet_cpy->getInventaire_cmpname());
      $objet->setInventaire_user($objet_cpy->getInventaire_user());
      $objet->setInventaire_objid($objet_cpy->getInventaire_objid());
      $objet->setInventaire_structure($objet_cpy->getInventaire_structure());
      $objet->setInventaire_actif($objet_cpy->getInventaire_actif());
      $inventaireDao = new Darkcity_inventaireDao;  
      $inventaireDao->save(&$datasource, $objet);
      $inventaire_cpyDao->delete(&$datasource, $objet_cpy);
    }
  
  $J2_competence = $competenceDao->getObject(&$datasource, $adv_name);
  $J1_occupation = $occupationDao->getObject(&$datasource, $user_name);
  $J2_occupation = $occupationDao->getObject(&$datasource, $adv_name);
  
  /* Les XP */
  $J1_xp_REC = 0;
  $J1_xp_SEC = 0;
  $J1_xp_PIL = 0;
  $J1_xp_PER = 0;
  $J1_xp_TIR = 0;
  $J1_xp_BGR = 0;
  $J1_xp_PHY = 0;
  $J1_vie = $J1_competence->getCompetence_VIE();
  $J1_argent = $J1_competence->getCompetence_ARG();
  $J1_reputation = $J1_competence->getCompetence_REP();
  
  $J2_xp_PIL = 0;
  $J2_xp_PER = 0;
  $J2_xp_TIR = 0;
  $J2_xp_BGR = 0;
  $J2_xp_PHY = 0;
  $J2_vie = $J2_competence->getCompetence_VIE();
  $J2_argent = $J2_competence->getCompetence_ARG();
  $J2_reputation = $J2_competence->getCompetence_REP();

  $texteNews = "";
  
/**********************************************************************************************/
/* ACTION DE RECHERCHE                                                                        */  
/**********************************************************************************************/
  // JOUEUR 1
  // Son level en recherche
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_REC()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_REC = $levelList[0]->getXptable_level();
  // A t'il un objet qui l'aide
  $J1_bonus_REC = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'REC' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet_REC = $J1_inventaire[0];
    $objet = $objetDao->getObject(&$datasource, $J1_objet_REC->getInventaire_objid());
    $J1_bonus_REC = $objet->getObjet_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "REC");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_REC += $bonus->getBonus_bonus();
  }
  
  // JOUEUR 2
  // Son level en rputation
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J2_competence->getCompetence_REP())."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2_level_REP = $levelList[0]->getXptable_level();
  $J2_level_REC = $J2_level_REP;
  // Amlioration par rapport au quartiers rsidentiel
  $J2_planque = $planqueDao->getObject(&$datasource, $adv_name);
  // 0 => +10%, 1 => +0%, 2 => -10%, 2 => -20%
  if ($J2_planque->getPlanque_quartier() == 1) {
    $J2_level_REC = round($J2_level_REP + $J2_level_REP * 0.1);
  }
  else if ($J2_planque->getPlanque_quartier() == 2) {
    $J2_level_REC = round($J2_level_REP);
  }
  else if ($J2_planque->getPlanque_quartier() == 3) {
    $J2_level_REC = round($J2_level_REP - $J2_level_REP * 0.1);
  }
  else {
    $J2_level_REC = round($J2_level_REP - $J2_level_REP * 0.2);
  }
  $J2_quartier = $quartierDao->getObject(&$datasource, $J2_planque->getPlanque_quartier());
  // A t'il un bonus supplmentaire
  $J2_bonus_REC = 0;
  $bonus = $bonusDao->getObject(&$datasource, $adv_name, "REP");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J2_bonus_REC += $bonus->getBonus_bonus();
  }

  // On lance la recherche 3 tentatives
  $delai_contrat += $DELAI_ACTION;
  $resultat = $systemeDes->jeterOpposition($J1_level_REC, $J1_bonus_REC, 0, $J2_level_REC, $J2_bonus_REC, 0);
  if ($resultat <= 0) {
    $delai_contrat += $DELAI_ACTION;
    $resultat = $systemeDes->jeterOpposition($J1_level_REC, $J1_bonus_REC, 0, $J2_level_REC, $J2_bonus_REC, 0);
  }
  if ($resultat <= 0) {
     $delai_contrat += $DELAI_ACTION;
     $resultat = $systemeDes->jeterOpposition($J1_level_REC, $J1_bonus_REC, 0, $J2_level_REC, $J2_bonus_REC, 0);
  }
  $texte="$user_name part  la recherche de $adv_name (1D".(5+$J2_level_REC)."+".$J2_bonus_REC.").\n";
  $texte=$texte."Son quipement et ses contacts lui permettent d'avoir un niveau de recherche de 1D".(5+$J1_level_REC)."+".$J1_bonus_REC." \n";
  if ($J1_objet) {
    $J1_objet_REC->setInventaire_structure($J1_objet_REC->getInventaire_structure() - 1);
    $J1_objet_REC->setInventaire_actif($J1_objet_REC->getInventaire_structure() > 0);
    $inventaireDao->save(&$datasource, $J1_objet_REC);
  }
  if ($resultat > 0) {
    $J1_xp_REC = $systemeDes->calculeXP($resultat, $J1_level_REC, $J2_level_REC);
    $texte=$texte."Il finit par trouver sa trace dans le quartier \"".$J2_quartier->getQuartier_titre()."\", et finalement se retrouve devant chez lui.\n";	
  }
  else { 
    $texte=$texte."Malgrs tous ses efforts, $adv_name reste introuvable, il faut se rendre  l'vidence, ce n'est pas encore aujourd'hui qu'il sera arrt.\n"	;
    $continuer_contrat = $FALSE;
    // (Ton level / (celui de l'aversaire * 20)) 
    // 30 / 40	= 0.0375 (3,75 %) 
    // 40 / 30  = 0.0666 (6.66 %)
    // 40 / 10  = 0.2    (20%)   
    $J1bonusREP = 0;
    $J2bonusREP = 0;
    $logManager->message('Recherche = '.$J1_level_REC.', '.$J2_level_REP.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
    $texteNews = "$user_name a tent d&#39;arrter $adv_name, malheureusement malgrs tous les efforts de notre hros le bandit reste introuvable...";          
  }
  $texte=$texte."La recherche aura dure ".($delai_contrat / $MINUTE)." minutes.\n";	
  $logManager->message("La recherche aura dur ".($delai_contrat / $MINUTE)." minutes. :".$resultat);
  
/**********************************************************************************************/
/* ACTION SECURITE SI LE JOUEUR 2 N'EST PAS CONNECTE                                          */  
/**********************************************************************************************/
  if ($continuer_contrat) {
    $J2_session = $sessionDao->getObject(&$datasource, $adv_name);
    if ($J2_session->getSession_sessionid() == "" || $J2_session->getSession_lastaction() < $dateManager->getPastDate(30*$MINUTE)) {
      // JOUEUR 1
      // Son level en securite
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_SEC()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $J1_level_SEC = $levelList[0]->getXptable_level();
      // A t'il un objet qui l'aide
      $J1_bonus_SEC = 0;
      $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'SEC' AND inventaire_actif = '1';";
      $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
      $J1_objet = sizeof($J1_inventaire) > 0;
      if ($J1_objet) {
        $J1_objet_SEC = $J1_inventaire[0];
        $objet = $objetDao->getObject(&$datasource, $J1_objet_SEC->getInventaire_objid());
        $J1_bonus_SEC = $objet->getObjet_bonus(); 
      }
      // A t'il un bonus supplmentaire
      $bonus = $bonusDao->getObject(&$datasource, $user_name, "SEC");  
      if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
        $J1_bonus_SEC += $bonus->getBonus_bonus();
      }   
   
      // JOUEUR 2
      // Le level de scurit de la planque
      $J2_level_SEC = $J2_planque->getPlanque_securite() * 10;
      // 3 => +10%
      if ($J2_planque->getPlanque_quartier() == 4) {
        $J2_level_SEC = round($J2_level_SEC + $J2_level_SEC * 0.15);
      }
      
      $duree = $DELAI_ACTION;
      $resultat = $systemeDes->jeterOpposition($J1_level_SEC, $J1_bonus_SEC, 0, $J2_level_SEC, 0, 0);
      if($resultat <= 0) {
        $duree += $DELAI_ACTION;
        $resultat = $systemeDes->jeterOpposition($J1_level_SEC, $J1_bonus_SEC, 0, $J2_level_SEC, 0, 0);
      }
      if($resultat <= 0) {
        $duree += $DELAI_ACTION;
        $resultat = $systemeDes->jeterOpposition($J1_level_SEC, $J1_bonus_SEC, 0, $J2_level_SEC, 0, 0);
      }
      $texte=$texte."\nLa planque de $adv_name est vrouille (1D".(5+$J2_level_SEC).") $user_name va tenter de forcer la scurit.\n";
      $texte=$texte."Son quipement lui permet d'avoir un niveau de scurit de 1D".(5+$J1_level_SEC)."+".$J1_bonus_SEC." \n";
      if ($J1_objet) {
        $J1_objet_SEC->setInventaire_structure($J1_objet_SEC->getInventaire_structure() - 1);
        $J1_objet_SEC->setInventaire_actif($J1_objet_SEC->getInventaire_structure() > 0);
        $inventaireDao->save(&$datasource, $J1_objet_SEC);
      }
      if ($resultat > 0) {
        $J1_xp_SEC = $systemeDes->calculeXP($resultat, $J1_level_SEC, $J2_level_SEC);
        $texte=$texte."Il finit par forcer la serrure, et entre dans la planque de $adv_name.\n";	
      }
      else { 
        $texte=$texte."Malgrs tous ses efforts, la planque $adv_name reste inviolable, il faut se rendre  l'vidence, ce n'est pas encore aujourd'hui qu'il sera arrt.\n"	;
        $continuer_contrat = $FALSE;
        // (Ton level / (celui de l'aversaire * 20)) 
        // 30 / 40	= 0.0375 (3,75 %) 
        // 40 / 30  = 0.0666 (6.66 %)
        // 40 / 10  = 0.2    (20%)   
        $J1bonusREP = 0;
        $J2bonusREP = 0;
        $logManager->message('Scurit = '.$J1_level_SEC.', '.$J2_level_SEC.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
        //
        $texteNews = "$user_name a tent d&#39;arrter $adv_name, malheureusement notre hros s&#39;est retrouv bloqu devant la porte du bandit...";          
      }
      $texte=$texte."La dure de cette opration est de ".($duree / $MINUTE)." minutes.\n";	
      $delai_contrat += $duree;
      $logManager->message("L'effraction aura dure ".($duree / $MINUTE)." minutes. :".$resultat);
    }
  }
  
  
/**********************************************************************************************/
/* ACTION POURSUITE SI CARACTERE JOUEUR 2 RAPIDE                                              */  
/**********************************************************************************************/
  if ($continuer_contrat) {
    if ($J2_planque->getPlanque_attitude() == 'FUITE') {
      // JOUEUR 1 level poursuite
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PIL()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $J1_level_PIL = $levelList[0]->getXptable_level();
      // A t'il un objet qui l'aide
      $J1_bonus_PIL = 0;
      $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PIL' AND inventaire_actif = '1';";
      $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
      $J1_vehicule_name = "";
      $J1_objet = sizeof($J1_inventaire) > 0;
      $J1_moto = $FALSE;
      if ($J1_objet) {
        $J1_objet_PIL = $J1_inventaire[0];
        $objet = $vehiculeDao->getObject(&$datasource, $J1_objet_PIL->getInventaire_objid());
        $J1_bonus_PIL = $objet->getVehicule_bonus(); 
        $J1_vitesse_PIL = $objet->getVehicule_acceleration();
        $J1_pds_PIL = $J1_objet_PIL->getInventaire_structure();
        $J1_vehicule_name = $objet->getVehicule_name();
        $J1_moto = $objet->getVehicule_type() == 'M';
      }
      // A t'il un bonus supplmentaire
      $bonus = $bonusDao->getObject(&$datasource, $user_name, "PIL");  
      if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
        $J1_bonus_PIL += $bonus->getBonus_bonus();
      }   

      // JOUEUR 2 level poursuite
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_PIL()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $J2_level_PIL = $levelList[0]->getXptable_level();
      // A t'il un objet qui l'aide
      $J2_bonus_PIL = 0;
      $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$adv_name."' AND inventaire_cmpname = 'PIL' AND inventaire_actif = '1';";
      $J2_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
      $J2_vehicule_name = "";
      $J2_objet = sizeof($J2_inventaire) > 0;
      if ($J2_objet) {
        $J2_objet_PIL = $J2_inventaire[0];
        $objet = $vehiculeDao->getObject(&$datasource, $J2_objet_PIL->getInventaire_objid());
        $J2_bonus_PIL = $objet->getVehicule_bonus(); 
        $J2_vitesse_PIL = $objet->getVehicule_acceleration();
        $J2_pds_PIL = $J2_objet_PIL->getInventaire_structure();
        $J2_vehicule_name = $objet->getVehicule_name();
      }
      // A t'il un bonus supplmentaire
      $bonus = $bonusDao->getObject(&$datasource, $user_name, "PIL");  
      if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
        $J2_bonus_PIL += $bonus->getBonus_bonus();
      }         
      
      // Jet d'opposition
      if ($J1_vehicule_name == "") $J1_vitesse_PIL = -5;
      if ($J2_vehicule_name == "") $J2_vitesse_PIL = -5;
      $duree = $DELAI_ACTION;
      $resultat = $systemeDes->jeterOpposition($J1_level_PIL, $J1_bonus_PIL, $J1_vitesse_PIL, $J2_level_PIL, $J2_bonus_PIL, $J2_vitesse_PIL);
      if($resultat <= 0) {
        $duree += $DELAI_ACTION;
        $resultat = $systemeDes->jeterOpposition($J1_level_PIL, $J1_bonus_PIL, $J1_vitesse_PIL, $J2_level_PIL, $J2_bonus_PIL, $J2_vitesse_PIL);
      }
      if($resultat <= 0) {
        $duree += $DELAI_ACTION;
        $resultat = $systemeDes->jeterOpposition($J1_level_PIL, $J1_bonus_PIL, $J1_vitesse_PIL, $J2_level_PIL, $J2_bonus_PIL, $J2_vitesse_PIL);
      }
      $texte=$texte."\n$adv_name prend la fuite ".($J2_vehicule_name != "" ? "  bord de ".$J2_vehicule_name : "")." (1D".(5+$J2_level_PIL)."+".$J2_bonus_PIL.")\n";
      $texte=$texte."$user_name part  sa poursuite ".($J1_vehicule_name != "" ? "  bord de ".$J1_vehicule_name : "")." (1D".(5+$J1_level_PIL)."+".$J1_bonus_PIL.")\n";
      if ($resultat > 0) {
        $J1_xp_PIL = $systemeDes->calculeXP($resultat, $J1_level_PIL, $J2_level_PIL);
        $texte=$texte."Aprs une folle course poursuite $user_name rattrape $adv_name.\n";	
        if ($J2_objet) {
          $dg = $systemeDes->jeterN(1, 6);
          $pds = $J2_objet_PIL->getInventaire_structure() - $dg;
          $texte=$texte."Durant la course poursuite $J2_vehicule_name de $adv_name prend quelques chocs, et perd $dg points de structure.\n";
          $J2_objet_PIL->setInventaire_structure($pds < 0 ? 0 : $pds);
          $J2_objet_PIL->setInventaire_actif($J2_objet_PIL->getInventaire_structure() > 0);
          $inventaireDao->save(&$datasource, $J2_objet_PIL);
        }
        if ($J2_objet && $J1_objet && $J1_moto) {
          $dg = $systemeDes->jeterN(1, 6);
          $pds = $J1_objet_PIL->getInventaire_structure() - $dg;
          $texte=$texte."Durant la course poursuite $J1_vehicule_name de $user_name prend quelques chocs, et perd $dg points de structure\n";
          $J1_objet_PIL->setInventaire_structure($pds < 0 ? 0 : $pds);
          $J1_objet_PIL->setInventaire_actif($J1_objet_PIL->getInventaire_structure() > 0);
          $inventaireDao->save(&$datasource, $J1_objet_PIL);
        }
      }
      else { 
        $texte=$texte."$adv_name est bien plus rapide, et au bout d'un moment il sme $user_name.\n"	;
        $J2_xp_PIL = $systemeDes->calculeXP(abs($resultat), $J2_level_PIL, $J1_level_PIL);
        if ($J1_objet) {
          $dg = $systemeDes->jeterN(1, 6);
          $pds = $J1_objet_PIL->getInventaire_structure() - $dg;
          $texte=$texte."Durant la course poursuite $J1_vehicule_name de $user_name prend quelques chocs, et perd $dg points de structure\n";
          $J1_objet_PIL->setInventaire_structure($pds < 0 ? 0 : $pds);
          $J1_objet_PIL->setInventaire_actif($J1_objet_PIL->getInventaire_structure() > 0);
          $inventaireDao->save(&$datasource, $J1_objet_PIL);
        }
	// (Ton level / (celui de l'aversaire * 20)) 
    	// 30 / 40	= 0.0375 (3,75 %) 
  	// 40 / 30  = 0.0666 (6.66 %)
        // 40 / 10  = 0.2    (20%)   
        $pourcentage = ($J1_level_PIL / ($J2_level_PIL * 20));
        $J1bonusREP = -1 * round(abs($J1_reputation) * $pourcentage);
        $J2bonusREP = $J1bonusREP;
        if ($J1_reputation < 0) $J1bonusREP = 0;
        $logManager->message('Poursuite = '.$J1_level_PIL.', '.$J2_level_PIL.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
        //
        $continuer_contrat = $FALSE;
        $texteNews = "$user_name a tent d&#39;arrter $adv_name, malheureusement ce dernier a pris la fuite, notre pauvre hros n&#39;a pu le rattraper. Aux dernires nouvelles $adv_name court toujours.";          
      }
      $texte=$texte."La dure de cette opration est de ".($duree / $MINUTE)." minutes.\n";	
      $delai_contrat += $duree;
      $texte=$texte."\n";
    }
  }
  
/**********************************************************************************************/
/* ACTION PERSUASION SI CARACTERE JOUEUR 2 BARATINEUR                                         */  
/**********************************************************************************************/
  if ($continuer_contrat) {
    if ($J2_planque->getPlanque_attitude() == 'BARATIN') {
      // JOUEUR 1 level persuasion
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $J1_level_PER = $levelList[0]->getXptable_level();
      // A t'il un objet qui l'aide
      $J1_bonus_PER = 0;
      $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
      $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
      $J1_objet = sizeof($J1_inventaire) > 0;
      if ($J1_objet) {
        $J1_objet_PER = $J1_inventaire[0];
        $objet = $objetDao->getObject(&$datasource, $J1_objet_PER->getInventaire_objid());
        $J1_bonus_PER = $objet->getObjet_bonus(); 
      }
      // A t'il un bonus supplmentaire
      $bonus = $bonusDao->getObject(&$datasource, $user_name, "PER");  
      if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
        $J1_bonus_PER += $bonus->getBonus_bonus();
      }   

      // JOUEUR 2 level persuasion
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $J2_level_PER = $levelList[0]->getXptable_level();
      // A t'il un objet qui l'aide
      $J2_bonus_PER = 0;
      $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$adv_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
      $J2_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
      $J2_objet = sizeof($J2_inventaire) > 0;
      if ($J2_objet) {
        $J2_objet_PER = $J2_inventaire[0];
        $objet = $objetDao->getObject(&$datasource, $J2_objet_PER->getInventaire_objid());
        $J2_bonus_PER = $objet->getObjet_bonus(); 
      }
      // A t'il un bonus supplmentaire
      $bonus = $bonusDao->getObject(&$datasource, $user_name, "PER");  
      if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
        $J2_bonus_PER += $bonus->getBonus_bonus();
      }         
      
      // Jet d'opposition
      $duree = $DELAI_ACTION;
      $resultat = $systemeDes->jeterOpposition($J1_level_PER, $J1_bonus_PER, 0, $J2_level_PER, $J2_bonus_PER, 0);
      if($resultat <= 0) {
        $duree += $DELAI_ACTION;
        $resultat = $systemeDes->jeterOpposition($J1_level_PER, $J1_bonus_PER, 0, $J2_level_PER, $J2_bonus_PER, 0);
      }
      if($resultat <= 0) {
        $duree += $DELAI_ACTION;
        $resultat = $systemeDes->jeterOpposition($J1_level_PER, $J1_bonus_PER, 0, $J2_level_PER, $J2_bonus_PER, 0);
      }
      $texte=$texte."\n$adv_name tente de baratiner $user_name afin de lui indiquer qu'il se trompe de personne (1D".(5+$J2_level_PER)."+".$J2_bonus_PER.")\n";
      $texte=$texte."$user_name tente de dmler le vrai du faux de l'histoire de $adv_name (1D".(5+$J1_level_PER)."+".$J1_bonus_PER.")\n";
      if ($J1_objet) {
        $J1_objet_PER->setInventaire_structure($J1_objet_PER->getInventaire_structure() - 1);
        $J1_objet_PER->setInventaire_actif($J1_objet_PER->getInventaire_structure() > 0);
        $inventaireDao->save(&$datasource, $J1_objet_PER);
      }
      if ($J2_objet) {
        $J2_objet_PER->setInventaire_structure($J2_objet_PER->getInventaire_structure() - 1);
        $J2_objet_PER->setInventaire_actif($J2_objet_PER->getInventaire_structure() > 0);
        $inventaireDao->save(&$datasource, $J2_objet_PER);
      }
      if ($resultat > 0) {
        $J1_xp_PER = $systemeDes->calculeXP($resultat, $J1_level_PER, $J2_level_PER);
        $texte=$texte."$user_name ne se laisse pas avoir par les explications douteuses de $adv_name.\n";	
      }
      else { 
        $texte=$texte."$adv_name arrive  embrouiller $user_name, celui-ci n'est plus du tout sr de l'exactitude de sa cible.\n"	;
        $J2_xp_PER = $systemeDes->calculeXP(abs($resultat), $J2_level_PER, $J1_level_PER);
        $continuer_contrat = $FALSE;
	// (Ton level / (celui de l'aversaire * 20)) 
    	// 30 / 40	= 0.0375 (3,75 %) 
  	// 40 / 30  = 0.0666 (6.66 %)
        // 40 / 10  = 0.2    (20%)   
        $pourcentage = ($J1_level_PER / ($J2_level_PER * 20));
        $J1bonusREP = -1 * round(abs($J1_reputation) * $pourcentage);
        $J2bonusREP = $J1bonusREP;
        if ($J1_reputation < 0) $J1bonusREP = 0;
        $logManager->message('Persuasion = '.$J1_level_PER.', '.$J2_level_PER.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
        $texteNews = "$user_name a tent d&#39;arrter $adv_name, cependant devant l&#39;abscence de preuve formelles $adv_name est reparti libre...";          
        //
      }
      $texte=$texte."La dure de cette opration est de ".($duree / $MINUTE)." minutes.\n";	
      $delai_contrat += $duree;
      $texte=$texte."\n";
    }
  }

/**********************************************************************************************/
/* ACTION COMBAT CHOIX ENTRE BAGARRE ET TIR                                                   */  
/**********************************************************************************************/
  if ($continuer_contrat) {
    $texte=$texte."\n";
    $delai_contrat += $DELAI_ACTION;	
    if ($action == "tir") {
      include("metier/action_tir_contrat.php");
    } 
    else {
      include("metier/action_bagarre_contrat.php");
    }
  }
  
  $logManager->message("Contrat : ".$texte);
  $logManager->message('$J1_xp_REC = '.$J1_xp_REC);
  $logManager->message('$J1_xp_SEC = '.$J1_xp_SEC);
  $logManager->message('$J1_xp_PIL = '.$J1_xp_PIL);
  $logManager->message('$J1_xp_PER = '.$J1_xp_PER);
  $logManager->message('$J1_xp_TIR = '.$J1_xp_TIR);
  $logManager->message('$J1_xp_BGR = '.$J1_xp_BGR);
  $logManager->message('$J1_xp_PHY = '.$J1_xp_PHY);
  $logManager->message('$J2_xp_PIL = '.$J2_xp_PIL);
  $logManager->message('$J2_xp_PER = '.$J2_xp_PER);
  $logManager->message('$J2_xp_TIR = '.$J2_xp_TIR);
  $logManager->message('$J2_xp_BGR = '.$J2_xp_BGR);
  $logManager->message('$J2_xp_PHY = '.$J2_xp_PHY);
  
/**********************************************************************************************/
/* LES GAINS DU JOUEUR 1                                                                      */  
/**********************************************************************************************/
  $texteJ1 = "\n\n";
  if ($J1_xp_REC >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_REC." points d'exprience en Recherche\n";
  if ($J1_xp_SEC >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_SEC." points d'exprience en Scurit\n";
  if ($J1_xp_PIL >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_PIL." points d'exprience en Poursuite\n";
  if ($J1_xp_PER >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_PER." points d'exprience en Persuasion\n";
  if ($J1_xp_TIR >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_TIR." points d'exprience en Tir\n";
  if ($J1_xp_BGR >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_BGR." points d'exprience en Bagarre\n";
  if ($J1_xp_PHY >0) $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_PHY." points d'exprience en Physique\n";
  if ($continuer_contrat) {
  if ($vainqueur == "J1") {
    if ($action == tir) $pourcentage = (($J2_level_TIR + $J2_level_PHY) / (($J1_level_TIR + $J1_level_PHY) * 20));
    else $pourcentage = (($J2_level_BGR + $J2_level_PHY) / (($J1_level_BGR + $J1_level_PHY) * 20));
    $J1bonusREP = round(abs($J2_reputation) * $pourcentage);
    $J2bonusREP = $J1bonusREP;
    $J1bonusREP += 25;
    
    $logManager->message('Combat = '.$J1_level_PHY.', '.$J2_level_PHY.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
    $texteJ1 = $texteJ1."Vous gagnez ".round(abs($J2_reputation) / 10)." $\n";
    $J1_argent += round(abs($J2_reputation) / 10);
  }
  else  {
    if ($action == tir) $pourcentage = (($J1_level_TIR + $J1_level_PHY) / (($J2_level_TIR + $J2_level_PHY) * 20));
    else $pourcentage = (($J1_level_BGR + $J1_level_PHY) / (($J2_level_BGR + $J2_level_PHY) * 20));
    $J1bonusREP = -1 * round(abs($J1_reputation) * $pourcentage);
    $J2bonusREP = $J1bonusREP;
    if ($J1_reputation < 0) $J1bonusREP = 0;
    $logManager->message('Combat = '.$J1_level_PHY.', '.$J2_level_PHY.', '.$pourcentage.', '.$J1bonusREP.', '.$J2bonusREP);
  }
}
  if ($J1bonusREP != 0) $texteJ1 = $texteJ1."Votre Bonne rputation ".($J1bonusREP < 0 ? "diminue" : "augmente")." de ".abs($J1bonusREP)." points.\n";
  if ($vainqueur == "J1") {
    $texteJ1 = $texteJ1."\n\nLA MISSION EST UN SUCCES.\n";
    $texteNews = "Un bandit de moins ! $user_name a effectu un superbe coup, il a russi  maitriser $adv_name, nos rues seront dsormais plus sures.";
  }
  else {
    $texteJ1 = $texteJ1."\n\nLA MISSION EST UN ECHEC.\n";
    if ($texteNews == "") {
      $texteNews = "$user_name a tent d&#39;arrter $adv_name, malheureusement ce dernier avait un armement dmesur et notre pauvre hros ne pouvait rivaliser,  priori ses jours ne sont plus en danger.";
    }
  } 
  $dateNews = $dateManager->getCurrentDate();
  $newsingame = new Darkcity_newsingame;
  $newsingame->setAll(md5($dateNews.$user_name.$adv_name), $user_name, $adv_name, $texteNews, $dateNews);
  $logManager->message($newsingame->toString());
  $newsingameDao->create(&$datasource, $newsingame);
  $newsList = $newsingameDao->loadAll(&$datasource);
  if (sizeof($newsList) > 10) {
    $sql = "DELETE FROM darkcity_newsingame WHERE newsingame_date < ".$newsList[9]->getNewsingame_date();
  }
  $newsingameDao->databaseUpdate(&$datasource, $sql);

/**********************************************************************************************/
/* LES GAINS DU JOUEUR 2                                                                      */  
/**********************************************************************************************/
  $texteJ2 = "\n\n";
  if ($J2_xp_PIL >0) $texteJ2 = $texteJ2."Vous gagnez ".$J2_xp_PIL." points d'exprience en Poursuite\n";
  if ($J2_xp_PER >0) $texteJ2 = $texteJ2."Vous gagnez ".$J2_xp_PER." points d'exprience en Persuasion\n";
  if ($J2_xp_TIR >0) $texteJ2 = $texteJ2."Vous gagnez ".$J2_xp_TIR." points d'exprience en Tir\n";
  if ($J2_xp_BGR >0) $texteJ2 = $texteJ2."Vous gagnez ".$J2_xp_BGR." points d'exprience en Bagarre\n";
  if ($J2_xp_PHY >0) $texteJ2 = $texteJ2."Vous gagnez ".$J2_xp_PHY." points d'exprience en Physique\n";
  if ($J2bonusREP != 0) $texteJ2 = $texteJ2."Votre Mauvaise rputation ".($J2bonusREP < 0 ? "augmente" : "diminue")." de ".abs($J2bonusREP)." points.\n";
  
  // On sauvegarde les nouvelles comptences de J1
  $J1_competence->setCompetence_REC($J1_competence->getCompetence_REC()+$J1_xp_REC);
  $J1_competence->setCompetence_SEC($J1_competence->getCompetence_SEC()+$J1_xp_SEC);
  $J1_competence->setCompetence_PIL($J1_competence->getCompetence_PIL()+$J1_xp_PIL);
  $J1_competence->setCompetence_PER($J1_competence->getCompetence_PER()+$J1_xp_PER);
  $J1_competence->setCompetence_TIR($J1_competence->getCompetence_TIR()+$J1_xp_TIR);
  $J1_competence->setCompetence_BGR($J1_competence->getCompetence_BGR()+$J1_xp_BGR);
  $J1_competence->setCompetence_PHY($J1_competence->getCompetence_PHY()+$J1_xp_PHY);
  $J1_competence->setCompetence_VIE($J1_vie);
  $J1_competence->setCompetence_ARG($J1_argent);
  $J1_competence->setCompetence_REP($J1_reputation + $J1bonusREP);
  $competenceDao->save(&$datasource, $J1_competence);

  // On sauvegarde les nouvelles comptences de J2
  $J2_competence->setCompetence_PIL($J2_competence->getCompetence_PIL()+$J2_xp_PIL);
  $J2_competence->setCompetence_PER($J2_competence->getCompetence_PER()+$J2_xp_PER);
  $J2_competence->setCompetence_TIR($J2_competence->getCompetence_TIR()+$J2_xp_TIR);
  $J2_competence->setCompetence_BGR($J2_competence->getCompetence_BGR()+$J2_xp_BGR);
  $J2_competence->setCompetence_PHY($J2_competence->getCompetence_PHY()+$J2_xp_PHY);
  $J2_competence->setCompetence_VIE($J2_vie);
  $J2_competence->setCompetence_ARG($J2_argent);
  $J2_competence->setCompetence_REP($J2_reputation + $J2bonusREP);
  $competenceDao->save(&$datasource, $J2_competence);

  // On sauvegarde l'occupation de J1
  $J1_occupation->setOccupation_contrat($dateManager->getFutureDate($delai_contrat));
  $occupationDao->save(&$datasource, $J1_occupation);
  $J2_session = $sessionDao->getObject(&$datasource, $adv_name);
  if ($J2_session->getSession_sessionid() == "" || $J2_session->getSession_lastaction() < $dateManager->getPastDate(30*$MINUTE)) {
    $J2_occupation->setOccupation_attaque($dateManager->getFutureDate($DELAI_ATTAQUE));
  }
  else {
    $J2_occupation->setOccupation_attaque($dateManager->getFutureDate(30*$MINUTE));
  }
  $occupationDao->save(&$datasource, $J2_occupation);

  $messageManager->sendMessage('', $user_name, "Vous &ecirc;tes parti en chasse de ".$adv_name, htmlspecialchars(str_replace("&#39;","'",$texte.$texteJ1), ENT_QUOTES), $dateManager->getCurrentDate());

  $messageManager->sendMessage('', $adv_name, "Vous avez &eacute;t&eacute; pris en chasse par $user_name.", htmlspecialchars(str_replace("&#39;","'",$texte.$texteJ2), ENT_QUOTES), $dateManager->getCurrentDate());
  }  
  else {
    $infoManager->setMessage(htmlspecialchars("Vous avez trop tard, cette personne est parti  d'autres occupations...",ENT_QUOTES));
    $J1_occupation->setOccupation_bar($currentDate);
    $occupationDao->save(&$datasource, $J1_occupation);
  }
  }  
?>