<?php
/**
 * action_faire_reparer.php : partie mtier de faire rparer un objet chez un Marchand
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_faire_reparer : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");

  //rcupration de l'Id objet  faire rparer et du user Name
  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $user_name = $sessionManager->load("user_name");

  //rcupration de l'occupation
  $logManager->message("action_faire_reparer : charger occupation");
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);

  //rcupration des comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  //rcupration l'objet  rparer
  $logManager->message("action_faire_rparer : rcupre objet");
  $inventaireDao = new Darkcity_inventaireDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;
  $objet = $inventaireDao->getObject(&$datasource, $object_id);  
  $diff = "";
  $name = "";
  $cout = 0; 
  $diff = 10;
  $continuer = $TRUE;

  // Vehicules
  if ($objet->getInventaire_cmpname() == "PIL") {  
    $vehiculeDao = new Darkcity_vehiculeDao;
    $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    //on calcule le cot de la rparation, les dgats
    $cout = round(($vehicule->getVehicule_prix()) / 10);
    //* Calcul du la rparation 
    if (($vehicule->getVehicule_structure() - $objet->getInventaire_structure()) < 10) {
          $diff = $vehicule->getVehicule_structure() - $objet->getInventaire_structure(); 
    }
    $name = $vehicule->getVehicule_name();
  }
  // armes blanches
  if ($objet->getInventaire_cmpname() == "BGR") {  
    $arme_blancheDao = new Darkcity_arme_blancheDao;
    $arme_blanche = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    //on calcule le cot de la rparation, les dgats
    $cout = round(($arme_blanche->getAblanche_prix()) / 10);
    //* Calcul du la rparation 
    if (($arme_blanche->getAblanche_structure() - $objet->getInventaire_structure()) < 10) {
          $diff = $arme_blanche->getAblanche_structure() - $objet->getInventaire_structure(); 
    }
    $name = $arme_blanche->getAblanche_name();
  }
  // armes de tir
  if ($objet->getInventaire_cmpname() == "TIR") {  
    $armeDao = new Darkcity_armeDao;
    $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    //on calcule le cot de la rparation, les dgats
    $cout = round(($arme->getArme_prix()) / 10);
    //* Calcul du la rparation 
    if (($arme->getArme_structure() - $objet->getInventaire_structure()) < 10) {
          $diff = $arme->getArme_structure() - $objet->getInventaire_structure(); 
    }
    $name = $arme->getArme_name();
  }
  // armures
  if ($objet->getInventaire_cmpname() == "PHY") {  
    $armureDao = new Darkcity_armureDao;
    $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    //on calcule le cot de la rparation, les dgats
    $cout = round(($armure->getArmure_prix()) / 10);
    //* Calcul du la rparation 
    if (($armure->getArmure_structure() - $objet->getInventaire_structure()) < 10) {
          $diff = $armure->getArmure_structure() - $objet->getInventaire_structure(); 
    }
    $name = $armure->getArmure_name();
  }
  
  //Traitement de rparation
  $logManager->message("action_faire_rparer : cout=".$cout."$");  

  if  ($cout > $competence->getCompetence_ARG()) {
    $infoManager->setMessage("Vous devez avoir au moins ".$cout." $ pour faire rparer votre ".$name.".");
    $continuer = $FALSE;
  }
  else {
    //On degr la totalit des dgats 
    $resultat = $diff;

    $logManager->message("action_faire_reparer : mise a jour");
    // On sauvegarde l'objet en tables cpy
    $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
    $objet_cpy = new Darkcity_inventaire_cpy;
    $objet_cpy->setInventaire_id($objet->getInventaire_id());
    $objet_cpy->setInventaire_cmpname($objet->getInventaire_cmpname());
    $objet_cpy->setInventaire_user($objet->getInventaire_user());
    $objet_cpy->setInventaire_objid($objet->getInventaire_objid());
    $objet_cpy->setInventaire_structure($objet->getInventaire_structure() + $resultat);
    $objet_cpy->setInventaire_actif($objet->getInventaire_actif());
    $inventaire_cpyDao->create(&$datasource, $objet_cpy);
    
    //Mise a jour des comptences en table cpy
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = new Darkcity_competence_cpy;
    $competence_cpy->setCompetence_user($competence->getCompetence_user());
    $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR());
    $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR());
    $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY());
    $competence_cpy->setCompetence_REC($competence->getCompetence_REC());
    $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC());
    $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR());
    $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL());
    $competence_cpy->setCompetence_MED($competence->getCompetence_MED());
    $competence_cpy->setCompetence_PER($competence->getCompetence_PER());
    $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
    $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE());
    $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG() - $cout);
    $logManager->message("action_faire_reparer : ".$competence_cpy->toString());
    $competence_cpyDao->create(&$datasource, $competence_cpy);

    // On occupe le joueur
    $occupation->setOccupation_occupation("Vous tes en train faire rparer votre ".$name." de ".$resultat." points de structure.");
    $delai = (5/2 * $MINUTE);
    $date = $dateManager->getFutureDate($delai);
    $occupation->setOccupation_datefin($date);    
    $occupationDao->save(&$datasource, $occupation);
   
    // On envoie un message au joueur
    $title = htmlspecialchars("Vous avez fait rparer ", ENT_QUOTES).$name." de ".$resultat.htmlspecialchars(" points de structure", ENT_QUOTES);
    $content = htmlspecialchars('Vous dcidez de faire rparer votre ',ENT_QUOTES).$name.htmlspecialchars(', pour cela vous dpensez ', ENT_QUOTES).$cout." $.".htmlspecialchars(' '.$resultat.' points de structures sont regagns suite  cela', ENT_QUOTES).".";
    $messageManager->sendMessage('', $user_name, $title, $content, $date);
  
  }
  
  $logManager->message("action_faire_reparer : fin");
?>