<?php
/**
 * action_reparer.php : partie mtier de reparation d'un objet
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_reparer : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");

  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  $inventaireDao = new Darkcity_inventaireDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'RPR' AND inventaire_actif = '1';";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("action_soigner : charger occupation");
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);

  if (sizeof($inventaireList) == 0) {
    $infoManager->setMessage("Vous devez avoir au moins une caisse  outils active dans votre inventaire pour rparer un objet.");
  }
  else {
    $armeDao = new Darkcity_armeDao;
    $arme_blancheDao = new Darkcity_arme_blancheDao;
    $armureDao = new Darkcity_armureDao;
    $vehiculeDao = new Darkcity_vehiculeDao;
    $objetDao = new Darkcity_objetDao;
    $objet = $inventaireDao->getObject(&$datasource, $object_id);
    $diff = "";
    $name = "";
    // Armes  feux
    if ($objet->getInventaire_cmpname() == "TIR") {
      $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $diff = $arme->getArme_structure() - $objet->getInventaire_structure(); 
      $name = $arme->getArme_name();
    }
    // Armes blanches
    else if ($objet->getInventaire_cmpname() == "BGR") {
      $arme = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $diff = $arme->getAblanche_structure() - $objet->getInventaire_structure(); 
      $name = $arme->getAblanche_name();
    }
    // Armures
    else if ($objet->getInventaire_cmpname() == "PHY") {
      $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $diff = $armure->getArmure_structure() - $objet->getInventaire_structure(); 
      $name = $armure->getArmure_name();
    }
    // Vehicules
    else if ($objet->getInventaire_cmpname() == "PIL") {
      $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $diff = $vehicule->getVehicule_structure() - $objet->getInventaire_structure(); 
      $name = $vehicule->getVehicule_name();
    }
    $obj = $objetDao->getObject(&$datasource, $inventaireList[0]->getInventaire_objid());
    $bonus = $obj->getObjet_bonus();
    
    $xptableDao = new Darkcity_xptableDao;
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_RPR()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    
    // jet d'oposition
    $logManager->message("action_soigner : jet");
    $resultat = $systemeDes->jeterDifficulte($level, $bonus, 0, $diff);
    $logManager->message("action_reparer : ".$resultat.", ".$diff);
    if ($resultat > $diff) $resultat = $diff;
    $xp = $systemeDes->calculeXP($resultat, $level, $diff);
    
    if ($resultat > 0) {
      $logManager->message("action_reparer : jet reussis");
      $cmpnameDao = new Darkcity_competence_nameDao;
      $cmpname = $cmpnameDao->getObject(&$datasource, "RPR");
      // On sauvegarde les objets et competence dans les tables cpy
      $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
      $objet_cpy = new Darkcity_inventaire_cpy;
      $objet_cpy->setInventaire_id($inventaireList[0]->getInventaire_id());
      $objet_cpy->setInventaire_cmpname($inventaireList[0]->getInventaire_cmpname());
      $objet_cpy->setInventaire_user($inventaireList[0]->getInventaire_user());
      $objet_cpy->setInventaire_objid($inventaireList[0]->getInventaire_objid());
      $objet_cpy->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
      $objet_cpy->setInventaire_actif(($objet_cpy->getInventaire_structure() == 0 ? $FALSE : $TRUE));
      $inventaire_cpyDao->create(&$datasource, $objet_cpy);
      $objet_cpy = new Darkcity_inventaire_cpy;
      $objet_cpy->setInventaire_id($objet->getInventaire_id());
      $objet_cpy->setInventaire_cmpname($objet->getInventaire_cmpname());
      $objet_cpy->setInventaire_user($objet->getInventaire_user());
      $objet_cpy->setInventaire_objid($objet->getInventaire_objid());
      $objet_cpy->setInventaire_structure($objet->getInventaire_structure() + $resultat);
      $objet_cpy->setInventaire_actif($objet->getInventaire_actif());
      $inventaire_cpyDao->create(&$datasource, $objet_cpy);
      $competence_cpyDao = new Darkcity_competence_cpyDao;
      $competence_cpy = new Darkcity_competence_cpy;
      $competence_cpy->setCompetence_user($competence->getCompetence_user());
      $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR());
      $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR());
      $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY());
      $competence_cpy->setCompetence_REC($competence->getCompetence_REC());
      $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC());
      $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR() + $xp);
      $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL());
      $competence_cpy->setCompetence_MED($competence->getCompetence_MED());
      $competence_cpy->setCompetence_PER($competence->getCompetence_PER());
      $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
      $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE());
      $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG());
      $logManager->message("action_reparer : ".$competence_cpy->toString());
      $competence_cpyDao->create(&$datasource, $competence_cpy);
      // On occupe le joueur
      $occupation->setOccupation_occupation("Vous tes en train de rparer ".$name);
      
      $tm = round($level / 10);
      if ($tm == 0) $tm = 0.5;
      $delai = round(($resultat / $tm) * $MINUTE);
      $date = $dateManager->getFutureDate($delai);
      $occupation->setOccupation_datefin($dateManager->getFutureDate($delai));
      $occupationDao->save(&$datasource, $occupation);
      
      // On envoie un message au joueur
      $title = htmlspecialchars("Vous avez rpar ", ENT_QUOTES).$name." de ".$resultat.htmlspecialchars(" points de structure", ENT_QUOTES);
      $content = htmlspecialchars('Vous dcidez de rparer ',ENT_QUOTES).$name.htmlspecialchars(', pour cela vous utilisez ', ENT_QUOTES).$obj->getObjet_name().".".
        htmlspecialchars(' Les dgts ne vous semblent pas trop grave, et vous russissez  rparer '.$resultat.' points de structures', ENT_QUOTES).".".
        htmlspecialchars(' Vous gagnez de plus '.$xp." points d'exprience en ", ENT_QUOTES).$cmpname->getCmpname_title().".";
      $messageManager->sendMessage('', $user_name, $title, $content, $date);
    }
    else {
      $logManager->message("action_reparer : jet rate");
      $inventaireList[0]->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
      if ($inventaireList[0]->getInventaire_structure() == 0) {
      	$inventaireList[0]->setInventaire_actif($FALSE);
      }
      $inventaireDao->save(&$datasource, $inventaireList[0]);

      // On envoie le message d'echec
      $title = htmlspecialchars("Vous chouez dans votre tentative de rparation", ENT_QUOTES);
      $content = htmlspecialchars('Vous dcidez de rparer ',ENT_QUOTES).$name.htmlspecialchars(', pour cela vous utilisez ', ENT_QUOTES).$obj->getObjet_name().".".
      (abs($resultat) > $level ?
        htmlspecialchars(' Les dgts ne vous semblent pas trop grave, cependant vous chouez dans votre tentative.', ENT_QUOTES) :
        htmlspecialchars(' Les dgts vous semblent peut tre au dela de vos comptences, et effectivement vous chouez dans votre tentative.', ENT_QUOTES)
       );
      $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    }    
  }
  
  $logManager->message("action_reparer : fin");
?>