 <?php 
/**
 * action_scenario_rue.php : partie mtier d'une mini aventure
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  
  $logManager->message("action_scenario_rue : debut");
  
  include_once("dao/accesseurs/Darkcity_eventDao.php");
  include_once("dao/objets/Darkcity_event.php");
  include_once("dao/accesseurs/Darkcity_event_actionDao.php");
  include_once("dao/objets/Darkcity_event_action.php");
  include_once("dao/accesseurs/Darkcity_action_effectDao.php");
  include_once("dao/objets/Darkcity_action_effect.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("databean/ScenarioRueDataBean.php");

  $event_key = (isset($_POST["event_key"])?$_POST["event_key"]:"");
  $action_key = (isset($_POST["action_key"])?$_POST["action_key"]:"");

  $user_name = $sessionManager->load("user_name");
  $scenarioRueDataBean = new ScenarioRueDataBean;
  
  $eventDao = new Darkcity_eventDao;
  $actionDao = new Darkcity_event_actionDao;
  $effectDao = new Darkcity_action_effectDao;
  $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $occupationDao = new Darkcity_occupationDao;
  $inventaireDao = new Darkcity_inventaireDao;
  $armeDao = new Darkcity_armeDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;

  // On rcupre le scnario
  $logManager->message("action_scenario_rue : event ".$event_key);
  $event = $eventDao->getObject(&$datasource, $event_key);
  $scenarioRueDataBean->setEvent($event);
  
  // On rcupre l'action
  $logManager->message("action_scenario_rue : action ".$action_key);
  $action = $actionDao->getObject(&$datasource, $action_key);
  $scenarioRueDataBean->resetActionList();
  $scenarioRueDataBean->addAction($action);

  $competence = $competenceDao->getObject(&$datasource, $user_name);
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  // On met  jour la comptence
  $competence_cpyDao = new Darkcity_competence_cpyDao;
  $competence_cpy = new Darkcity_competence_cpy;
  $competence_cpy->setCompetence_user($competence->getCompetence_user());
  $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR());
  $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR());
  $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY());
  $competence_cpy->setCompetence_REC($competence->getCompetence_REC());
  $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC());
  $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR());
  $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL());
  $competence_cpy->setCompetence_MED($competence->getCompetence_MED());
  $competence_cpy->setCompetence_PER($competence->getCompetence_PER());
  $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
  $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE());
  $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG());
  $competence_cpyDao->create(&$datasource, $competence_cpy);
  
  // On rcupre les gains
  $sql = "SELECT * FROM darkcity_action_effect WHERE effect_action_key = ".$action_key.";";
  $effectList = $effectDao->listQuery(&$datasource, $sql);
  $scenarioRueDataBean->resetEffectList();
  for ($i = 0; $i < sizeof($effectList); $i++) {
    $effect = $effectList[$i];
    $xp = 0;
    $cmpname = $cmpnameDao->getObject(&$datasource, $effect->getEffect_cmpname());
    $xptitle = " points d&#39exp&eacute;riences en ";
    $logManager->message("action_scenario_rue : ".$effect->getEffect_cmpname()." ".$effect->getEffect_bonus());
    // UN OBJET
    if ($effect->getEffect_obj() == $TRUE) {
      // Arme
      if ($effect->getEffect_cmpname() == "TIR") {
        $arme = $armeDao->getObject(&$datasource, $effect->getEffect_bonus());
        $xptitle = " un(e) ".$arme->getArme_name();
        $objet = new Darkcity_inventaire;
        $objet->setInventaire_cmpname("TIR");
        $objet->setInventaire_user($user_name);
        $objet->setInventaire_objid($effect->getEffect_bonus());
        $objet->setInventaire_structure($arme->getArme_structure());
        $objet->setInventaire_actif($FALSE);
        $inventaireDao->create(&$datasource, $objet);        
        $inventaire_cpyDao->create(&$datasource, $objet);        
        $inventaireDao->delete(&$datasource, $objet);        
      }
      // Arme Blanche
      else if ($effect->getEffect_cmpname() == "BGR") {
        $arme = $arme_blancheDao->getObject(&$datasource, $effect->getEffect_bonus());
        $xptitle = " un(e) ".$arme->getAblanche_name();
        $objet = new Darkcity_inventaire;
        $objet->setInventaire_cmpname("BGR");
        $objet->setInventaire_user($user_name);
        $objet->setInventaire_objid($effect->getEffect_bonus());
        $objet->setInventaire_structure($arme->getAblanche_structure());
        $objet->setInventaire_actif($FALSE);
        $inventaireDao->create(&$datasource, $objet);        
        $inventaire_cpyDao->create(&$datasource, $objet);        
        $inventaireDao->delete(&$datasource, $objet);        
      }
      // Armure
      else if ($effect->getEffect_cmpname() == "PHY") {
        $armure = $armureDao->getObject(&$datasource, $effect->getEffect_bonus());
        $xptitle = " un(e) ".$armure->getArmure_name();
        $objet = new Darkcity_inventaire;
        $objet->setInventaire_cmpname("PHY");
        $objet->setInventaire_user($user_name);
        $objet->setInventaire_objid($effect->getEffect_bonus());
        $objet->setInventaire_structure($armure->getArmure_structure());
        $objet->setInventaire_actif($FALSE);
        $inventaireDao->create(&$datasource, $objet);        
        $inventaire_cpyDao->create(&$datasource, $objet);        
        $inventaireDao->delete(&$datasource, $objet);        
      }
      // Vehicule
      else if ($effect->getEffect_cmpname() == "PIL") {
        $vehicule = $vehiculeDao->getObject(&$datasource, $effect->getEffect_bonus());
        $xptitle = " un(e) ".$vehicule->getVehicule_name();
        $objet = new Darkcity_inventaire;
        $objet->setInventaire_cmpname("PIL");
        $objet->setInventaire_user($user_name);
        $objet->setInventaire_objid($effect->getEffect_bonus());
        $objet->setInventaire_structure($armure->getVehicule_structure());
        $objet->setInventaire_actif($FALSE);
        $inventaireDao->create(&$datasource, $objet);        
        $inventaire_cpyDao->create(&$datasource, $objet);        
        $inventaireDao->delete(&$datasource, $objet);        
      }
      // Divers
      else {
        $object = $objetDao->getObject(&$datasource, $effect->getEffect_bonus());
        $xptitle = " un(e) ".$object->getObjet_name();
        $logManager->message($xptitle);
        $objet = new Darkcity_inventaire;
        $objet->setInventaire_cmpname($effect->getEffect_cmpname());
        $objet->setInventaire_user($user_name);
        $objet->setInventaire_objid($effect->getEffect_bonus());
        $objet->setInventaire_structure($object->getObjet_utilisations());
        $objet->setInventaire_actif($FALSE);
        $inventaireDao->create(&$datasource, $objet);        
        $inventaire_cpyDao->create(&$datasource, $objet);        
        $inventaireDao->delete(&$datasource, $objet);        
      }
    }
    // LA REPUTATION
    else if ($effect->getEffect_cmpname() == "REP") {
      $xptitle = " points de ";
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($competence->getCompetence_REP())."' ORDER BY xptable_level DESC;";
        $logManager->message("action_scenario_rue : ".$sql);
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $logManager->message("action_scenario_rue : ".$levelList[0]->getXptable_level()." ".$XP_MULTIPLIEUR);
        $xp = $effect->getEffect_bonus() * ($levelList[0]->getXptable_level() < $XP_MULTIPLIEUR ? $XP_MULTIPLIEUR : $levelList[0]->getXptable_level());
    }
    // L'ARGENT
    else if ($effect->getEffect_cmpname() == "ARG") {
      $xptitle = " $";
      $xp = $effect->getEffect_bonus();
    }
    // LES AUTRES XP = bonus * level
    else {
      $xp = $effect->getEffect_bonus;
      $exp = 0;
      if ($effect->getEffect_cmpname() == "TIR") $exp = $competence_cpy->getCompetence_TIR(); 
      if ($effect->getEffect_cmpname() == "BGR") $exp = $competence_cpy->getCompetence_BGR(); 
      if ($effect->getEffect_cmpname() == "PHY") $exp = $competence_cpy->getCompetence_PHY(); 
      if ($effect->getEffect_cmpname() == "PIL") $exp = $competence_cpy->getCompetence_PIL(); 
      if ($effect->getEffect_cmpname() == "MED") $exp = $competence_cpy->getCompetence_MED(); 
      if ($effect->getEffect_cmpname() == "SEC") $exp = $competence_cpy->getCompetence_SEC(); 
      if ($effect->getEffect_cmpname() == "REC") $exp = $competence_cpy->getCompetence_REC(); 
      if ($effect->getEffect_cmpname() == "RPR") $exp = $competence_cpy->getCompetence_RPR(); 
      if ($effect->getEffect_cmpname() == "PER") $exp = $competence_cpy->getCompetence_PER();
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$exp."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $xp = $effect->getEffect_bonus() * ($levelList[0]->getXptable_level() < $XP_MULITPLIEUR ? $XP_MULITPLIEUR : $levelList[0]->getXptable_level());
    }
    if ($effect->getEffect_obj() == $TRUE) {
      $scenarioRueDataBean->addEffect($xptitle);
    }
    else {
      $scenarioRueDataBean->addEffect($xp.$xptitle.($effect->getEffect_cmpname() == "ARG" ? "" : $cmpname->getCmpname_title()));
      if ($effect->getEffect_cmpname() == "TIR") $competence_cpy->setCompetence_TIR($competence_cpy->getCompetence_TIR()+$xp); 
      if ($effect->getEffect_cmpname() == "BGR") $competence_cpy->setCompetence_BGR($competence_cpy->getCompetence_BGR()+$xp); 
      if ($effect->getEffect_cmpname() == "PHY") $competence_cpy->setCompetence_PHY($competence_cpy->getCompetence_PHY()+$xp); 
      if ($effect->getEffect_cmpname() == "PIL") $competence_cpy->setCompetence_PIL($competence_cpy->getCompetence_PIL()+$xp); 
      if ($effect->getEffect_cmpname() == "MED") $competence_cpy->setCompetence_MED($competence_cpy->getCompetence_MED()+$xp); 
      if ($effect->getEffect_cmpname() == "SEC") $competence_cpy->setCompetence_SEC($competence_cpy->getCompetence_SEC()+$xp); 
      if ($effect->getEffect_cmpname() == "REC") $competence_cpy->setCompetence_REC($competence_cpy->getCompetence_REC()+$xp); 
      if ($effect->getEffect_cmpname() == "RPR") $competence_cpy->setCompetence_RPR($competence_cpy->getCompetence_RPR()+$xp); 
      if ($effect->getEffect_cmpname() == "PER") $competence_cpy->setCompetence_PER($competence_cpy->getCompetence_PER()+$xp); 
      if ($effect->getEffect_cmpname() == "REP") $competence_cpy->setCompetence_REP($competence_cpy->getCompetence_REP()+$xp); 
      if ($effect->getEffect_cmpname() == "ARG") $competence_cpy->setCompetence_ARG($competence_cpy->getCompetence_ARG()+$xp); 
    }
  }
  $logManager->message(htmlspecialchars("\n",ENT_QUOTES).$competence->toString());
  $competence_cpyDao->save(&$datasource,$competence_cpy);
  
  $texte = $event->getEvent_text()."\n\n".$action->getAction_text()."\n\n".$action->getAction_result()."\n\nVous gagnez :";
  
  for ($i = 0; $i < $scenarioRueDataBean->getNbEffects(); $i++) {
    $texte = $texte.htmlspecialchars("\n",ENT_QUOTES).$scenarioRueDataBean->getEffectAt($i);
  }
//  $occupation->setOccupation_occupation("Vous tes occup dans les rues de DarkCity");
  $occupation->setOccupation_rue($dateManager->getFutureDate($DELAI_RUE));
  $occupationDao->save(&$datasource, $occupation);
  
  $logManager->message(htmlspecialchars("\n",ENT_QUOTES).$texte);
  $messageManager->sendMessage('',$user_name,"Il vous est arriv&eacute; une aventure",$texte,$dateManager->getCurrentDate());  
  $logManager->message("action_scenario_rue : fin");
?>