 <?php 
/**
 * action_soins_hopital.php : partie mtier de soins  l'hopital
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
 
  $logManager->message("action_soins_hopital : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");

  // Rcupration des variables
  $user_name = $sessionManager->load("user_name");
  $soins = (isset($_POST["soins"])?$_POST["soins"]:"");

  // On rcupre les comptences
  $logManager->message("action_soins_hopital : charger competence");
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);
      
  //*peut on demander des soins ?
  $logManager->message("action_soins_hopital : charger occupation");
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  //* contle du niveau de vie
  if ($competence->getCompetence_VIE() == 100) {
    $infoManager->setMessage("Vous n'avez aucune blessure  soigner.");
    $continuer = $FALSE;
  }
  //* contrle de l'occupation
  else if ($occupation->getOccupation_soins() > $dateManager->getCurrentDate()) {
    $infoManager->setMessage("Vous avez dja reu des soins.<br/>Vous pourrez vous refaire soigner ".$dateManager->dateToString($occupation->getOccupation_soins()).".");
    $continuer = $FALSE;
  }
  else {
      //* on prpare la mise a jour
      $logManager->message("action_soins_Hopital : on va soigner de ".$soins);
      $cmpnameDao = new Darkcity_competence_nameDao;
      $cmpname = $cmpnameDao->getObject(&$datasource, "VIE"); 
      $cmpname2 = $cmpnameDao->getObject(&$datasource, "ARG"); 
	if ($soins == 10) {
        //* les soins cotent 100 $ 
        $Argent = 100;
        //* Calcule le gain de points de vie 
        if ($competence->getCompetence_VIE() > 90) {
            $resultat = 100 - $competence->getCompetence_VIE();
        }
        else {
           $resultat = 10;
        }
        // On occupe le joueur
        $occupation->setOccupation_occupation("Vous tes en train de vous faire soigner de ".$resultat." points de sant");
        $delai = (5/2 * $MINUTE);
        $date = $dateManager->getFutureDate($delai);
        $occupation->setOccupation_datefin($dateManager->getFutureDate($delai));
      }
      else if ($soins == 25) {
        //* les soins cotent 375 $ 
        $Argent = 375;
        //* Calcule le gain de points de vie 
        if ($competence->getCompetence_VIE() > 75) {
            $resultat = 100 - $competence->getCompetence_VIE();
        }
        else {
           $resultat = 25;
        }
        // On occupe le joueur
        $occupation->setOccupation_occupation("Vous tes en train de vous faire soigner de ".$resultat." points de sant");
        $delai = (5 * $MINUTE);
        $date = $dateManager->getFutureDate($delai);
        $occupation->setOccupation_datefin($dateManager->getFutureDate($delai));
      }

      else if ($soins == 50) {
        //* les soins cotent 1000 $ 
        $Argent = 1000;
        //* Calcule le gain de points de vie 
        if ($competence->getCompetence_VIE() > 50) {
            $resultat = 100 - $competence->getCompetence_VIE();
        }
        else {
           $resultat = 50;
        }
        // On occupe le joueur
        $occupation->setOccupation_occupation("Vous tes en train de vous faire soigner de ".$resultat." points de Vie");
        $delai = (6 * $MINUTE);
        $date = $dateManager->getFutureDate($delai);
        $occupation->setOccupation_datefin($date);
      }
   
    //* contrle du niveau du portefeuille
     if ($competence->getCompetence_ARG() < $Argent) {
         $infoManager->setMessage("Vous devez avoir au moins ".$Argent." $ en poche.");
         $continuer = $FALSE;
     } 
     else {

      //Mise a jour des comptences en table cpy
       $logManager->message("action_soins_hopital : update competence");
       $competence_cpyDao = new Darkcity_competence_cpyDao;
       $competence_cpy = new Darkcity_competence_cpy;
       $competence_cpy->setCompetence_user($competence->getCompetence_user());
       $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR());
       $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR());
       $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY());
       $competence_cpy->setCompetence_REC($competence->getCompetence_REC());
       $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC());
       $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR());
       $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL());
       $competence_cpy->setCompetence_MED($competence->getCompetence_MED());
       $competence_cpy->setCompetence_PER($competence->getCompetence_PER());
       $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
       $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE() + $resultat);
       $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG() - $Argent);
       $competence_cpyDao->create(&$datasource, $competence_cpy);
      
      // Mise a jour des occupations
       $logManager->message("action_soins_hopital : update occupation => ".$occupation->toString());              
       $occupation->setOccupation_soins($dateManager->getFutureDate($DELAI_SOINS));
       $occupationDao->save(&$datasource, $occupation);
       
      // On envoie le message de soins
       $logManager->message("action_soins_hopital : mies a jour argent =".$Argent);
       $title = htmlspecialchars("Vous avez reu des soins de ".$resultat." points de ", ENT_QUOTES).$cmpname->getCmpname_title();
       $content = htmlspecialchars('Vous avez demand  recevoir des soins, pour cela vous utilisez '.$Argent." $ .", ENT_QUOTES);
       $messageManager->sendMessage('', $user_name, $title, $content, $date);
       
     }
   } 
  
  $logManager->message("action_soins_hopital : fin");
   
?>