<?php
/**
 * action_voyage.php : partie mtier de dpart en voyage
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_loisir : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");

  $voyage = (isset($_POST["voyage"])?$_POST["voyage"]:"");
  $user_name = $sessionManager->load("user_name");

  $continuer = $TRUE;

  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  if (($voyage == 1 && $competence->getCompetence_ARG() < 2000) ||
      ($voyage == 2 && $competence->getCompetence_ARG() < 5000) ||
      ($voyage == 3 && $competence->getCompetence_ARG() < 10000)) {
    $infoManager->setMessage("Dsol mais vous n'avez pas assez d'argent pour vous payer ce voyage");
    $continuer = $FALSE;
  }
  else {
    $competence->setCompetence_ARG($competence->getCompetence_ARG() - ($voyage == 1 ? 2000 : ($voyage == 2 ? 5000 : 10000)));
    $competenceDao->save(&$datasource, $competence);
    $occupation->setOccupation_occupation("Vous tes actuellement en vacances.");
    $delai = $JOUR * ($voyage == 1 ? 2 : ($voyage == 2 ? 7 : 15));
    $date = $dateManager->getFutureDate($delai);
    $occupation->setOccupation_datefin($dateManager->getFutureDate($delai));
    $occupationDao->save(&$datasource, $occupation);
    $title = htmlspecialchars("Vous tes parti en vacance pendant ".($voyage == 1 ? 2 : ($voyage == 2 ? 7 : 15))." jours", ENT_QUOTES);
    $content = htmlspecialchars("Vous tes parti en vacance pendant ".($voyage == 1 ? 2 : ($voyage == 2 ? 7 : 15))." jours pour la modique somme de ".($voyage == 1 ? 2000 : ($voyage == 2 ? 5000 : 10000))." $",ENT_QUOTES).".\n".
      htmlspecialchars('Vous revenez  la dure ralit dansle froid et le gris de la ville ', ENT_QUOTES)."\n";
    $messageManager->sendMessage('', $user_name, $title, $content, $date);
  }
  
  $logManager->message("action_travailler : fin");
?>