<?php
/**
 * aug_confort.php : partie mtier d'augmentation du confort de la planque
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("aug_confort : debut");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_quartierDao.php");
  include_once("dao/objets/Darkcity_quartier.php");

  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $occupationDao = new Darkcity_occupationDao;
  $planqueDao = new Darkcity_planqueDao;
  $quartierDao = new Darkcity_quartierDao;

  // On rcupre la comptence scurit
  $logManager->message("On rcupre l'argent");
  $competence = $competenceDao->getObject(&$datasource, $user_name);
 
  // Les infos de la planque
  $logManager->message("Les infos de la planque");
  $planque = $planqueDao->getObject(&$datasource, $user_name);

  $OK = $FALSE;
  // On verifie qu'il a assez
  $mult = $planque->getPlanque_quartier();
  if ($mult == 1) $mult = 1;
  if ($mult == 2) $mult = 1.5;
  if ($mult == 3) $mult = 2;
  if ($mult == 4) $mult = 3;
  $somme = $mult*1000*($planque->getPlanque_confort()+1);
  if ($competence->getCompetence_ARG() >= $somme) {
    $competence->setCompetence_ARG($competence->getCompetence_ARG() - $somme);
    $competenceDao->save(&$datasource, $competence);
    $planque->setPlanque_confort($planque->getPlanque_confort()+1);
    $planqueDao->save(&$datasource, $planque);
    $title = htmlspecialchars("Vous avez augment le confort de votre appartement", ENT_QUOTES);
    $content = htmlspecialchars('Vous avez augment le confort de votre appartement',ENT_QUOTES).htmlspecialchars(', pour cela vous dpensez ', ENT_QUOTES).$somme." $.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $OK = $TRUE;
  }
  else {
    $infoManager->setMessage("Vous n'avez pas assez d'argent pour augmenter votre confort.");
  }
  
  $logManager->message("init_planque : fin");
  

?>