<?php
/**
 * boire_bar.php : partie mtier de boire un verre au bar
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("metier boire_bar : debut");

  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");

  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);

  if ($competence->getCompetence_ARG() < 5) {
    $infoManager->setMessage("Vous n'avez pas assez d'argent pour prendre un verre");	
    $continuer = $FALSE;
  } 
  else {
    $competence->setCompetence_ARG($competence->getCompetence_ARG()-5);	
    $competenceDao->save(&$datasource, $competence);
    $bonusDao = new Darkcity_bonusDao;
    $bonus = $bonusDao->getObject(&$datasource, $user_name, "REC");
    $title = "";
    $content = "";
    if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin() > $dateManager->getCurrentDate()) {
      $title = htmlspecialchars("Vous buvez une bire au Totentaz", ENT_QUOTES);
      $content = htmlspecialchars("Vous commandez une bire bien fraiche, vous en profitez pour discuter un petit peu avec le barman. ".
        "Celui-ci vous apprend les dernires rumeurs de DarkCity. Vous n'apprenez malheureusement rien que vous ne sachiez dj, cependant la bire est bonne.", ENT_QUOTES);
    }
    else {
      $title = htmlspecialchars("Vous obtenez un bonus de +1 en Recherche pour 5 minutes", ENT_QUOTES);
      $content = htmlspecialchars("Vous commandez une bire bien fraiche, vous en profitez pour discuter un petit peu avec le barman. ".
        "Celui-ci vous apprends les dernires rumeurs de DarkCity. Vous en apprenez un peu plus sur cette ville, ".
        "cela vous procure un bonus de +1 en Recherche pour les 5 prochaines minutes.", ENT_QUOTES);
      $creer = ($bonus->getBonus_datefin() == "" || $bonus->getBonus_datefin() == 0);
      $bonus->setBonus_bonus(1);
      $bonus->setBonus_datefin($dateManager->getFutureDate($DELAI_BONUS));
      if ($creer) {
      	$bonusDao->create(&$datasource, $bonus);
      }
      else {
      	$bonusDao->save(&$datasource, $bonus);
      }
    }    
    //$infoManager->setMessage($title);	
    $messageManager->sendMessage('',$user_name, $title, $content, $dateManager->getCurrentDate());
  }
  $logManager->message("metier boire_bar : fin");
?>