<?php
/**
 * connecter.php : partie mtier de connection du joueur
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("connecter : debut");

  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");

  // Une action est elle demande
  $nom = (isset($_POST["nom"])?$_POST["nom"]:"");
  $pwd = (isset($_POST["pwd"])?$_POST["pwd"]:"");
  
   if ($nom == "") {
     $logManager->message("connecter : pas de nom saisie");
     $errorManager->setMessage("Veuillez vous identifier.");
   }
   else {
        // On cree l'accesseur userDao
        $userDao = new Darkcity_userDao;
        $joueur = $userDao->getObject(&$datasource, $nom);
        if ($joueur->getUser_password() == "") {
          $logManager->message("connecter : user non trouve");
          $errorManager->setMessage("Pseudonyme incorrect.");
        }
        else if ($joueur->getUser_actif() == 0) {
          $logManager->message("connecter : user non actif");
          $errorManager->setMessage("Votre compte n'a pas encore t activ.");
        }
        else if ($joueur->getUser_bloque() == 1) {
          $logManager->message("connecter : user bloqu");
          $errorManager->setMessage("Votre compte a t bloqu.");
        }
        else if (!$userManager->connect($pwd, $joueur->getUser_password(), $sessionManager)) {
          $logManager->message("connecter : mot de passe incorrect");
          $errorManager->setMessage("Mot de passe inccorect.");
        }
        else {
          $nom = $joueur->getUser_name();
          $logManager->message("connecter : controles ok, user=".$nom);
          $sessionManager->save("user_name", $nom);
        }
   }

  $logManager->message("connecter : fin");
  
?>