<?php
/**
 * create_message.php : partie mtier de cration d'un message 
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("metier create_message : debut");

  include_once("dao/accesseurs/Darkcity_messageDao.php");
  include_once("dao/objets/Darkcity_message.php");
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("databean/MessagesDataBean.php");
  include("metier/init_messages.php");

  $to = htmlspecialchars($_POST["to"],ENT_QUOTES);
  $title = htmlspecialchars($_POST["title"],ENT_QUOTES);
  $content = htmlspecialchars($_POST["content"],ENT_QUOTES);
  $user_name = $sessionManager->load("user_name");

  $logManager->message("metier create_message : controles");
  $messagesDataBean->setEdit($TRUE);
  if ($to == "") {
    $errorManager->setMessage("Vous devez spcifier un destinataire");
  }
  else if ($title == "") {
    $errorManager->setMessage("Vous devez spcifier un titre");
  }
  else {
    $userDao = new Darkcity_userDao;
    $joueur = $userDao->getObject(&$datasource, $to);
    if ($joueur->getUser_password() == "") {
      $errorManager->setMessage("Joueur non trouv : ".$to);
    }
    else {
      $messageManager->sendMessage($user_name, $to, $title, $content, $dateManager->getCurrentDate());
      $messagesDataBean->setEdit($FALSE);
      $infoManager->setMessage("Message envoy.");
    }
  }
  
  $logManager->message("metier create_message : fin");
?>