<?php
/**
 * enregistrer_user.php : partie mtier de creation de personnage
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  include("dao/accesseurs/Darkcity_userDao.php");
  include("dao/objets/Darkcity_user.php");
  include("dao/accesseurs/Darkcity_competenceDao.php");
  include("dao/objets/Darkcity_competence.php");
  include("dao/accesseurs/Darkcity_xptableDao.php");
  include("dao/objets/Darkcity_xptable.php");
  include("dao/accesseurs/Darkcity_planqueDao.php");
  include("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_activateDao.php");
  include_once("dao/objets/Darkcity_activate.php");
  
  // Rcupration des variables
  $nom = (isset($_POST["nom"])?$_POST["nom"]:"");
  $pwd = (isset($_POST["password"])?$_POST["password"]:"");
  $pwd2 = (isset($_POST["password2"])?$_POST["password2"]:"");
  $email = (isset($_POST["email"])?$_POST["email"]:"");
  $avatar = (isset($_POST["avatar"])?$_POST["avatar"]:"");
  $description = (isset($_POST["description"])?$_POST["description"]:"");
  $avertissement = (isset($_POST["avertissement"])?$_POST["avertissement"]:"");
  // Controles
   if ($nom == "") {
     $errorManager->setMessage("Veuillez entrer un pseudonyme.");
   }
   else {
        $logManager->message('['.$avertissement.'] '.strstr($email, "@msn").' '.strstr($email, "@hotmail"));
        // On vrifie que le nom n'est pas deja utilis
        $userDao = new Darkcity_userDao;
        $joueur = $userDao->getObject(&$datasource, $nom);
        if ($joueur->getUser_email() != "") {
                $errorManager->setMessage("Pseudonyme dj utilis.");
        }
        else if (strlen($nom) < 4) {
                $errorManager->setMessage("Votre nom doit faire au moins quatre caractres.");   
        }
        // Le mot de passe est il saisi 
        else if ($pwd == "") {
                $errorManager->setMessage("Veuillez entrer mot de passe.");   
        }
        // Verification de l'egalit entre le password et la confirmation
        else if ($pwd != $pwd2) {
                $errorManager->setMessage("Veuillez confirmer votre mot de passe.");   
        }
        // L'email est obligatoire
        else if ($email == "") {
                $errorManager->setMessage("Veuillez entrer votre email.");   
        }
        else if (!eregi("^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$", $email)) {
                $errorManager->setMessage("Email invalide.");   
        }      
        else if ($avertissement == "" && (strstr($email, "@msn") || strstr($email, "@hotmail") || strstr($email, "@live"))) {
                $errorManager->setMessage("Les serveurs Live Messenger Hotmail rejettent souvent les mails automatiques, votre inscription risque de ne pas fonctionner.");   
                $avertissement = "O";
        }
        else {
           $sexe = "H";
           if (strstr($avatar, 'girl')) $sexe = "F";
                // On cree un nouveau Darkcity_user
                $joueur = new Darkcity_user;
                $joueur->setAll(htmlspecialchars($nom, ENT_QUOTES),
                                md5($pwd),
                                $email,
                                htmlspecialchars($description, ENT_QUOTES),
                                $avatar,
                                0,
                                0,
                                $sexe);
                $userDao = new Darkcity_userDao;
                $userDao->create(&$datasource, $joueur);
                // On va crer un personnage de levl 5
                $xptableDao = new Darkcity_xptableDao;
                $xp = $xptableDao->getObject(&$datasource, 1);
                // On cree les comptences
                $competence = new Darkcity_competence;
                $competence->setAll($nom,
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                $xp->getXptable_xp(),
                                0,
                                100,
                                2000);
                $competenceDao = new Darkcity_competenceDao;
                $competenceDao->create(&$datasource, $competence);
                // On cree la planque
                $planque = new Darkcity_planque;
                $planque->setAll($nom,
                                1,
                                0,
                                0,
                                "COMBAT",
                                "BGR");
                $planqueDao = new Darkcity_planqueDao;
                $planqueDao->create(&$datasource, $planque);
                // On cree la occupation
                $occupation = new Darkcity_occupation;
                $occupation->setAll($nom,
                                0,
                                "",
                                0,
                                0,
                                0,
                                0,
                                0,
                                0,
                                0,
                                0,
                                0);
                $occupationDao = new Darkcity_occupationDao;
                $occupationDao->create(&$datasource, $occupation);
                // La table d'activation
                $activate = new Darkcity_activate;
                $key = md5($joueur->getUser_name()."-".$joueur->getUser_email());
                $activate->setAll($key, $joueur->getUser_name());
                $logManager->message("controlleur : ".$activate->toString());
                $activateDao = new Darkcity_activateDao;
                $activateDao->create(&$datasource, $activate);
                
                $message="Bonjour,\nMerci de vous tre enregistr au jeu DarkCity, vous utilisez le compte : ".$joueur->getUser_name().".\n\nPour activer ce compte merci de bein vouloir suivre le lien ci-dessous :\n".$SITE."?action=activate&key=".$key."\n\nBon jeu et  bientt.\n\n--\nL'quipe de DarkCity.";
                $subject = 'DarkCity : Activation de votre compte.';
                $headers = 'From: '.$WEBMASTER."\r\n";
                mail($joueur->getUser_email(), $subject, $message, $headers);                
                
                /*
                // On connecte le user
                $userManager->connect($pwd, $joueur->getUser_password(), $sessionManager);
                $sessionManager->save("user_name", $nom);
                */
                $infoManager->setMessage("Votre compte est cr, un email vous a t envoy, pour activer ce compte veuillez consulter votre messagerie.");
        }
   }
  
?>