 <?php 
/**
 * init_armurier_tir.php : partie mtier de l'armurier (armes de melees)
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_armurier : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/ArmurierDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $armurierDataBean = new armurierDataBean;
  
  $logManager->message("init_armurier : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $armurierDataBean->setName($joueur->getUser_name());
    
  $logManager->message("init_armurier : table occupation");
  // on rcupre son occupation
  $marchandage = $FALSE;
  $bonus = 0;
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= time()) {
    //$armurierDataBean->setMsgInfo("Vous n'&ecirc;tes actuellement pas occup&eacute;, vous vous reposez dans votre planque.");
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
    if ($occupation->getOccupation_marchandage() <= $dateManager->getCurrentDate()) {
      $marchandage = $TRUE;
     // On rcupre les bonus en PERsuasion
     $logManager->message("Recherche Bonus");
     $inventaireDao = new Darkcity_inventaireDao;
     $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
     $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 
     $logManager->message("Bonus trouv ? ".sizeof($inventaireList));
     if (sizeof($inventaireList) > 0) {
       $objetDao = new Darkcity_objetDao;
       $obj = $objetDao->getObject(&$datasource, $inventaireList[0]->getInventaire_objid());
       $bonus = $obj->getObjet_bonus();
     }
    }
  }
  else {
    $armurierDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $armurierDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  $logManager->message("Bonus= ".$bonus);
  
  $logManager->message("init_armurier : rcupre competence");
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  

  //on stocke le niveau d argent
  $armurierDataBean->setPortefeuille($competence->getCompetence_ARG());
   
  // On recupre les levels 
  $xptableDao = new Darkcity_xptableDao;
  // BGR
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_BGR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_BGR = ($levelList[0]->getXptable_level());
 
  $lvl_PER = 1;
  if ($marchandage == $TRUE) {
    // level pour la comptence persuasion  
    $xptableDao = new Darkcity_xptableDao;
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql);  
    $lvl_PER = $levelList[0]->getXptable_level();
    $resultat_user = $systemeDes->jeter($lvl_PER, $bonus, 0);
  }
    
  // On rcupre les armes blanches *********************************************
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $sql = "SELECT * FROM darkcity_arme_blanche WHERE ablanche_level <= '".$lvl_BGR."' ORDER BY ablanche_level ASC, ablanche_prix ASC;";
  $armeList = $arme_blancheDao->listQuery(&$datasource, $sql); 
 
  $logManager->message("init_armurier : preparation liste couteau");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $objetDao = new Darkcity_objetDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "BGR");  
  $xp = 0;
  for ($i = 0; $i < sizeof($armeList); $i++) {
    $arme = $armeList[$i];
    $logManager->message("init_armurier : boucle armeB n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($arme->getAblanche_key());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setName($arme->getAblanche_name());
    $inventaireDataBean->setDescription($arme->getAblanche_description());
    $inventaireDataBean->setImage($arme->getAblanche_image());
    $inventaireDataBean->setBonus($arme->getAblanche_precision());
    $degats = $arme->getAblanche_nombre().'D'.$arme->getAblanche_degats().($arme->getAblanche_bonus() > 0 ? '+'.$arme->getAblanche_bonus() : ($arme->getAblanche_bonus() < 0 ? $arme->getAblanche_bonus() : ''));
    $inventaireDataBean->setDegats($degats);
    $inventaireDataBean->setFiabilite($arme->getAblanche_fiabilite());      
    $inventaireDataBean->setPds($arme->getAblanche_structure());
    $inventaireDataBean->setPdsMax($arme->getAblanche_structure());
    $inventaireDataBean->setPrix($arme->getAblanche_prix());
    $Prix_achat = $arme->getAblanche_prix();
   // Calcule Marchandage
    $xp_tmp = 0;
    if ($marchandage == $TRUE) {      
      $resultat = $resultat_user - $systemeDes->jeter($arme->getAblanche_level(), 0, 0);
      $logManager->message("init_armurier_tir : marchander - rsultat=".$resultat);
      if ($resultat > 0) {
        $Prix_achat = $arme->getAblanche_prix() - round($arme->getAblanche_prix() * 0.1);
        $xp_tmp = $systemeDes->calculeXP($resultat, $lvl_PER, $arme->getAblanche_level());
      }
      if ($xp_tmp > $xp) {
        $xp = $xp_tmp; 
      }
    }
    $inventaireDataBean->setPrix_achat($Prix_achat); 
    //mise a jour des infos
    $logManager->message("init_armurier : maj liste");
    $armurierDataBean->addCouteau($inventaireDataBean);
  } 
  
  //Message + Sauvagerde nouvelle Xp 
  if ($xp > 0) {
    $title = htmlspecialchars("Vous reussissez  marchander les prix avec l'armurier", ENT_QUOTES);
    $content = htmlspecialchars("Vous reussissez  marchander les prix des armes de mle avec l'armurier\n\nVous gagnez ", ENT_QUOTES).$xp." points d&#39;exprience en Persuasion.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $infoManager->setMessage($title);
    //sauvegarde xp
    $competence->setCompetence_PER($competence->getCompetence_PER() + $xp);
    $competenceDao->save(&$datasource, $competence);  
    //Mise a jour de l'objet PER
    if (sizeof($inventaireList) > 0) {
       $logManager->message("action_marchandage : update inventaire");
       $inventaireList[0]->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
       if ($inventaireList[0]->getInventaire_structure() == 0) {
       	$inventaireList[0]->setInventaire_actif($FALSE);
       }
      $inventaireDao->save(&$datasource, $inventaireList[0]);
    }  
    //sauvegarde occupation
    $occupation->setOccupation_marchandage($dateManager->getFutureDate($DELAI_MARCHANDAGE));
    $occupation->setOccupation_occupation("marchandage");
    $logManager->message("init_armurier_tir : update occupation => ".$occupation->toString());
    $occupationDao->save(&$datasource, $occupation);
  }
  
  $logManager->message("init_armurier : fin");
?>