 <?php 
/**
 * init_centreLoisir.php : partie mtier des listes d'activits au centre de loisir
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  $logManager->message("init_centreLoisir : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_activiteDao.php");
  include_once("dao/objets/Darkcity_activite.php");
  include_once("databean/ActivitesDataBean.php");

  $user_name = $sessionManager->load("user_name");
  
  // dclarer les Dao
  $logManager->message("init_centreLoisir : dclarer les Dao");
  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $activiteDao = new Darkcity_activiteDao;
  
  // Declarer le databean
  $logManager->message("init_centreLoisir : Declarer le databean");
  $activitesDataBean = $sessionManager->load("activiteList");
  if (!isset($activitesDataBean) ||$activitesDataBean == "") {
    $activitesDataBean = new activitesDataBean;
  }

    // charger les comptences
    $logManager->message("init_centreLoisir : charger les comptences");
    $competence = $competenceDao->getObject(&$datasource, $user_name);
  
    // La liste des formations
    $activitesDataBean->resetactivites();
    // TIR
    $logManager->message("init_centreLoisir : xptable TIR");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_TIR()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_centreLoisir : activite TIR");
    $sql = "SELECT * FROM darkcity_activite WHERE xptable_level <= '".$level."' AND cmpname_name ='TIR' ORDER BY xptable_level DESC;";
    $activiteList = $activiteDao->listQuery(&$datasource, $sql); 
    $activite = $activiteList[0];
    $logManager->message("init_centreLoisir : ".$activite->getXptable_level()." => ".$activite->getactivite_libelle());
    $activitesDataBean->addactivite($activite);
    
    // BGR
    $logManager->message("init_centreLoisir : xptable BGR");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_centreLoisir : activite BGR");
    $sql = "SELECT * FROM darkcity_activite WHERE xptable_level <= '".$level."' AND cmpname_name ='BGR' ORDER BY xptable_level DESC;";
    $activiteList = $activiteDao->listQuery(&$datasource, $sql); 
    $activite = $activiteList[0];
    $logManager->message("init_centreLoisir : ".$activite->getXptable_level()." => ".$activite->getactivite_libelle());
    $activitesDataBean->addactivite($activite);
  
    // PHY
    $logManager->message("init_centreLoisir : xptable PHY");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_centreLoisir : activite PHY");
    $sql = "SELECT * FROM darkcity_activite WHERE xptable_level <= '".$level."' AND cmpname_name ='PHY' ORDER BY xptable_level DESC;";
    $activiteList = $activiteDao->listQuery(&$datasource, $sql); 
    $activite = $activiteList[0];
    $logManager->message("init_centreLoisir : ".$activite->getXptable_level()." => ".$activite->getactivite_libelle());
    $activitesDataBean->addactivite($activite);
  
    // on sauvegarde les activitees en session
    $logManager->message("init_centreLoisir : on sauvegarde les activitees en session");
    $sessionManager->save("activiteList",$activitesDataBean);
  
  $logManager->message("init_centreLoisir : fin");
?>