 <?php 
/**
 * init_concessionnaire.php : partie mtier du conscessionnaire
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  $logManager->message("init_concessionnaire : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/concessionnaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $concessionnaireDataBean = new concessionnaireDataBean;
  
  $logManager->message("init_concessionnaire : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $concessionnaireDataBean->setName($joueur->getUser_name());

  $logManager->message("init_concessionnaire : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= time()) {
    //$concessionnaireDataBean->setMsgInfo("Vous n'&ecirc;tes actuellement pas occup&eacute;, vous vous reposez dans votre planque.");
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
  }
  else {
    $concessionnaireDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $concessionnaireDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  
  $logManager->message("init_concessionnaire : table competence");
  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $user_name); 
    if ($competence_cpy->getCompetence_PIL() != "" && $competence_cpy->getCompetence_PIL() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  

  // On recupre le level 
  $xptableDao = new Darkcity_xptableDao;
  // PIL
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("PIL");  
  $comp->setXp($competence->getCompetence_PIL());
  $logManager->message("init_concessionnaire : XP pilotage ".$comp->getXP().".");
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $logManager->message("init_concessionnaire : level pilotage ".$levelList[0]->getXptable_level());
  
  // On rcupre les vhicules en ventes *********************************************
  $vehiculeDao = new Darkcity_vehiculeDao;
  $sql = "SELECT * FROM darkcity_vehicule WHERE vehicule_level <= '".$levelList[0]->getXptable_level()."' ORDER BY vehicule_level ASC, vehicule_prix ASC;";
  $vehiculeList = $vehiculeDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_concessionnaire : preparation liste vente");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "PIL");
  $xp = 0;
  //Rcupration du level d'XP
  $xptableDao = new Darkcity_xptableDao;
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $level = $levelList[0]->getXptable_level();
  for ($i = 0; $i < sizeof($vehiculeList); $i++) {
    $vehicule = $vehiculeList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($vehicule->getVehicule_key());
    $inventaireDataBean->setPds($vehicule->getVehicule_structure());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setName($vehicule->getVehicule_name());
    $inventaireDataBean->setDescription($vehicule->getVehicule_description());
    $inventaireDataBean->setImage($vehicule->getVehicule_image());
    $inventaireDataBean->setBonus($vehicule->getVehicule_bonus());
    $inventaireDataBean->setAcceleration($vehicule->getVehicule_acceleration());
    $inventaireDataBean->setPdsMax($vehicule->getVehicule_structure());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setPrix($vehicule->getVehicule_prix());
    $Prix_achat = ($vehicule->getVehicule_prix());        
    // jet d'oposition
    $logManager->message("init_concessionnaire : marchander - lvl1=".$vehicule->getVehicule_level()." lvl2=".$level);
    $resultat = $systemeDes->jeterOpposition($level, 0, 0, $vehicule->getVehicule_level(), 0, 0);
    $logManager->message("init_concessionnaire : marchander - rsultat=".$resultat);
    if ($resultat > 0) {
      $Prix_achat = $vehicule->getVehicule_prix() - round($vehicule->getVehicule_prix() * 0.1);
    }
    if ($resultat > $xp) {
      $xp = $resultat; 
    }
    $inventaireDataBean->setPrix_achat($Prix_achat);
    //Mise a jour de la table mmoire
    $concessionnaireDataBean->addvehicule($inventaireDataBean);
  } 
  
  //Sauvagerde nouvelle Xp 
  if ($xp > 0) {
    $title = htmlspecialchars("Vous reussissez  marchander les prix avec le marchand", ENT_QUOTES);
    $content = htmlspecialchars("Vous reussissez  marchander les prix avec le marchand\n\nVous gagnez", ENT_QUOTES).$xp." poinds d&#39;expriences en Pesuasion.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $infoManager->setMessage($title);
  }
  $competence->setCompetence_PER($competence->getCompetence_PER() + $xp);
  $competenceDao->save(&$datasource, $competence);  
    
  // On rcupre l'inventeire pour la comptence Pilotage *****************************************
  $inventaireDao = new Darkcity_inventaireDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PIL' ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_concessionnaire : preparation inventaire");
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  for ($i = 0; $i < sizeof($inventaireList); $i++) {
    $objet = $inventaireList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getInventaire_id());
    $inventaireDataBean->setPds($objet->getInventaire_structure());
    $inventaireDataBean->setActif($objet->getInventaire_actif());
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getInventaire_cmpname()); 
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
  
    // Vehicules
    if ($objet->getInventaire_cmpname() == "PIL") {
    $logManager->message("init_concessionnaire : inventaire pilotage");
      $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($vehicule->getVehicule_name());
      $inventaireDataBean->setDescription($vehicule->getVehicule_description());
      $inventaireDataBean->setImage($vehicule->getVehicule_image());
      $inventaireDataBean->setBonus($vehicule->getVehicule_bonus());
      $inventaireDataBean->setAcceleration($vehicule->getVehicule_acceleration());
      $inventaireDataBean->setPdsMax($vehicule->getVehicule_structure());
      $inventaireDataBean->setCmp($cmpname->getCmpname_name());
      $inventaireDataBean->setPrix($vehicule->getVehicule_prix());
      //calcule cout de rparation 
      $Prix_repare = round($inventaireDataBean->getPrix() * 0.1);
      //calcule prix de vente
      $Prix_vente = 0;
      if (($inventaireDataBean->getPds() / $inventaireDataBean->getPdsMax()) >= 0.5) {
                     $Prix_vente = round($inventaireDataBean->getPrix() * 0.2);
      }
      if (($inventaireDataBean->getPds() / $inventaireDataBean->getPdsMax()) >= 0.75) {
                     $Prix_vente = round($inventaireDataBean->getPrix() * 0.3);
      }
      if ($inventaireDataBean->getPds() == $inventaireDataBean->getPdsMax()) {
                     $Prix_vente = round($inventaireDataBean->getPrix() * 0.5);
      }
      //mise a jour du data bean
      $inventaireDataBean->setPrix_repare($Prix_repare);
      $inventaireDataBean->setPrix_vente($Prix_vente);
    }
    $concessionnaireDataBean->addInventaire($inventaireDataBean);
  }

  $logManager->message("init_concessionnaire : fin");
?>