 <?php 
/**
 * init_login.php : partie mtier de la page login
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  
  $logManager->message("init_highscore : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_sessionDao.php");
  include_once("dao/objets/Darkcity_session.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/HighscoreDataBean.php");
  include_once("databean/UserlistDataBean.php");
    
  $user_name = $sessionManager->load("user_name");
  $highscoreDataBean = new highscoreDataBean;
  
  $logManager->message("init_highscore : table user");  
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;

  // On rcupre toutes les session ouverte (Nb user conncet)
  $sessionDao = new Darkcity_sessionDao;
  $date = $dateManager->getPastDate(30*$MINUTE);
  $sql = "SELECT * FROM darkcity_session WHERE session_lastaction >= ".$date.";" ;
  $sessionlist = $sessionDao->listQuery(&$datasource, $sql);
  $highscoreDataBean->setNb_connectes(sizeof($sessionlist));
  $logManager->message("init_highsore : nb connects :".$highscoreDataBean->getNb_connectes());

  // On rcupre les judticiers *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 ORDER BY competence_REP DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  //nombre de user total
  $highscoreDataBean->setNb_users(sizeof($competenceList));

  // On rcupre les judticiers *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REP > 0 ORDER BY competence_REP DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste justicier");
  
  //nombre total de justiciers
  $highscoreDataBean->setNb_justicier(sizeof($competenceList));

  // On rcupre les gangsters *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REP < 0 ORDER BY competence_REP ASC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste gangster");
  
  //nombre total de gangster
  $highscoreDataBean->setNb_gangster(sizeof($competenceList));
  
  // Calucl de la rputation de la ville
  $logManager->message("init_highscore : Rputation ville");
  $sql = "SELECT SUM(competence_REP) FROM darkcity_competence, darkcity_user WHERE user_name = competence_user AND user_actif = 1;";
  $logManager->message("init_highscore : ".$sql);
  $result = $datasource->execute($sql);
  $logManager->message("init_highscore : ".$result);
  $row = $datasource->nextRow($result);
  $logManager->message("init_highscore : ".$row[0]);
  $highscoreDataBean->setVilleRep($row[0]);
?>