 <?php 
/**
 * init_marchand_envente.php : partie mtier du manrchand (objets en ventes)
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  
  $logManager->message("init_marchand : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/MarchandDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $marchandDataBean = new marchandDataBean;
  
  $logManager->message("init_marchand : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $marchandDataBean->setName($joueur->getUser_name());
    
  $logManager->message("init_marchand : table occupation");
  // on rcupre son occupation
  $marchandage = $FALSE;
  $bonus = 0;
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= $dateManager->getCurrentDate()) {
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
    if ($occupation->getOccupation_marchandage() <= $dateManager->getCurrentDate()) {
      $marchandage = $TRUE;
     // On rcupre les bonus en PERsuasion
     $logManager->message("Recherche Bonus");
     $inventaireDao = new Darkcity_inventaireDao;
     $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
     $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 
     $logManager->message("Bonus trouv ? ".sizeof($inventaireList));
     if (sizeof($inventaireList) > 0) {
       $objetDao = new Darkcity_objetDao;
       $obj = $objetDao->getObject(&$datasource, $inventaireList[0]->getInventaire_objid());
       $bonus = $obj->getObjet_bonus();
     }
    }
  }
  else {
    $armurierDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $armurierDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  $logManager->message("Bonus= ".$bonus);
    
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  
  
  //on stocke le niveau d argent
  $marchandDataBean->setPortefeuille($competence->getCompetence_ARG());

  // On recupre les levels 
  $xptableDao = new Darkcity_xptableDao;
  // MED
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_MED());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_MED = ($levelList[0]->getXptable_level());
  $logManager->message("init_marchand : level medecine ".$lvl_MED);
  // REC
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_REC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_REC = ($levelList[0]->getXptable_level());
  // RPR
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_RPR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_RPR = ($levelList[0]->getXptable_level());
  // PER
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_PER());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_PER = ($levelList[0]->getXptable_level());
  // SEC
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_SEC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_SEC = ($levelList[0]->getXptable_level());
  
  if ($marchandage == $TRUE) {
    // level pour la comptence persuasion  
    $lvl_marchandage = $lvl_PER + $bonus;
    $resultat_user = $systemeDes->jeter($lvl_PER, $bonus, 0);
  }
  $logManager->message("init_marchand : marchandage =".$resultat_user); 

  // On rcupre les objet en ventes *********************************************
  $objetDao = new Darkcity_objetDao;
  $sql = "SELECT * FROM darkcity_objet WHERE (objet_level <= '".$lvl_MED."' AND objet_competence = 'MED') OR (objet_level <= '".$lvl_REC."' AND objet_competence = 'REC') OR (objet_level <= '".$lvl_RPR."' AND objet_competence = 'RPR') OR (objet_level <= '".$lvl_PER."' AND objet_competence = 'PER') OR (objet_level <= '".$lvl_SEC."' AND objet_competence = 'SEC') ORDER BY objet_competence  ASC, objet_level ASC;";
  $objetList = $objetDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_marchand : preparation liste vente");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $objetDao = new Darkcity_objetDao;
  $xp = 0;
  for ($i = 0; $i < sizeof($objetList); $i++) {
    $objet = $objetList[$i];
    $logManager->message("init_marchand : boucle objet n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getObjet_key());
    $inventaireDataBean->setActif($FALSE);    
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getObjet_competence());  
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setName($objet->getObjet_name());
    $inventaireDataBean->setDescription($objet->getObjet_description());
    $inventaireDataBean->setPds($objet->getObjet_utilisations());
    $inventaireDataBean->setImage($objet->getObjet_image());
    $inventaireDataBean->setBonus($objet->getObjet_bonus());
    $inventaireDataBean->setlevel($objet->getObjet_level());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setPrix($objet->getObjet_prix());
    $Prix_achat = $objet->getObjet_prix();
   // Calcule Marchandage
    $xp_tmp = 0;
    if ($marchandage == $TRUE) {      
      $resultat = $resultat_user - $systemeDes->jeter($objet->getObjet_level(), 0, 0);
      $logManager->message("init_machand : marchander - rsultat=".$resultat);
      if ($resultat > 0) {
        $Prix_achat = $objet->getObjet_prix() - round($objet->getObjet_prix() * 0.1);
        $xp_tmp = $systemeDes->calculeXP($resultat, $lvl_PER, $objet->getObjet_level());
      }
      if ($xp_tmp > $xp) {
        $xp = $xp_tmp; 
      }
    }
    $inventaireDataBean->setPrix_achat($Prix_achat); 
    //mise a jour des infos
    $logManager->message("init_marchand : maj liste");
    $marchandDataBean->addMarchand($inventaireDataBean);
  } 
  
  //Message + Sauvagerde nouvelle Xp 
  if ($xp > 0) {
    $title = htmlspecialchars("Vous reussissez  marchander les prix avec le marchand", ENT_QUOTES);
    $content = htmlspecialchars("Vous reussissez  marchander les prix des armures avec le marchand\n\nVous gagnez ", ENT_QUOTES).$xp." points d&#39;exprience en Persuasion.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $infoManager->setMessage($title);
    //sauvegarde xp
    $competence->setCompetence_PER($competence->getCompetence_PER() + $xp);
    $competenceDao->save(&$datasource, $competence);
    //Mise a jour de l'objet PER
    if (sizeof($inventaireList) > 0) {
       $logManager->message("action_marchandage : update inventaire");
       $inventaireList[0]->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
       if ($inventaireList[0]->getInventaire_structure() == 0) {
       	$inventaireList[0]->setInventaire_actif($FALSE);
       }
      $inventaireDao->save(&$datasource, $inventaireList[0]);
    }  
    //sauvegarde occupation
    $occupation->setOccupation_marchandage($dateManager->getFutureDate($DELAI_MARCHANDAGE));
    $occupation->setOccupation_occupation("marchandage");
    $logManager->message("init_armurier_armure : update occupation => ".$occupation->toString());
    $occupationDao->save(&$datasource, $occupation);
  }
 
  $logManager->message("init_marchand : fin");
?>