 <?php 
/**
 * init_police.php : partie mtier du poste de police
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */      
  $logManager->message("init_fichePerso : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/PostePoliceDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $postePoliceDataBean = new PostePoliceDataBean;

  $logManager->message("init_fichePerso : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);

  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  // S'il sagit d'un bandit et qu'une ammende n'a pas te paye, on bloque l'acces au Wanted
  if ($competence->getCompetence_REP() < 0 && $occupation->getOccupation_amende() <= $dateManager->getCurrentDate()) {
    $xptableDao = new Darkcity_xptableDao;
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($competence->getCompetence_REP())."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();	
    $amende = $level * 100; 
    $postePoliceDataBean->setAmende($amende);
  }
  $logManager->message("init_fichePerso : fin");
?>