 <?php 
/**
 * init_scenario_rue.php : partie mtier slection d'un scenario
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_scenario_rue : debut");
  
  include_once("dao/accesseurs/Darkcity_eventDao.php");
  include_once("dao/objets/Darkcity_event.php");
  include_once("dao/accesseurs/Darkcity_event_actionDao.php");
  include_once("dao/objets/Darkcity_event_action.php");
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("databean/ScenarioRueDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $scenarioRueDataBean = new ScenarioRueDataBean;
  
  $eventDao = new Darkcity_eventDao;
  $actionDao = new Darkcity_event_actionDao;
  $userDao = new Darkcity_userDao;

  // On rcupre les scnarios correspondant au sexe du joueur
  $user = $userDao->getObject(&$datasource, $user_name);  
  $sex =  $user->getUser_sex();
  $sql = "SELECT * FROM darkcity_event WHERE event_sex ='N' OR event_sex = '$sex';";
  $eventList = $eventDao->listQuery(&$datasource, $sql);
  $nbEvents = sizeof($eventList);
  
  // On choisi un scnario au hazard
  $scenarioKey = $systemeDes->jeterN(1,$nbEvents) - 1;
  $scenarioRueDataBean->setEvent($eventList[$scenarioKey]);
  
  // On rcupre les actions
  $sql = "SELECT * FROM darkcity_event_action WHERE action_event_key = ".$eventList[$scenarioKey]->getEvent_key().";";
  $actionList = $actionDao->listQuery(&$datasource, $sql);
  $scenarioRueDataBean->setActionList($actionList);
  
  $logManager->message("init_scenario_rue : fin");
?>