 <?php 
/**
 * liste_avis.php : partie mtier de liste des contrats de la police
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */      
  $logManager->message("rechercheCombat : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/FicheAdversaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");

  $user_name = $sessionManager->load("user_name");
  
  $continuer = $TRUE;
 
  $planqueDao = new Darkcity_planqueDao;
  $occupationDao = new Darkcity_occupationDao;
  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;

  $logManager->message("comptences");
  $competence_J1 = $competenceDao->getObject(&$datasource, $user_name);
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".($competence_J1->getCompetence_REC() < abs($competence_J1->getCompetence_REP()) ? abs($competence_J1->getCompetence_REP()) : $competence_J1->getCompetence_REC())."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $level = $xptableDao->getObject(&$datasource, $levelList[0]->getXptable_level()+2);
  if ($level->getXptable_level() > 99) {
    $level = $xptableDao->getObject(&$datasource, 99);
  } 
  $levelREC = $level;
  
  $logManager->message("occupation");
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_contrat() > $dateManager->getCurrentDate()) {
    $continuer=$FALSE;
    $infoManager->setMessage(htmlspecialchars("Vous avez dja effectu un contrat, vous pourrez accepter le prochain ",ENT_QUOTES).$dateManager->dateToString($occupation->getOccupation_contrat()));
  }
  else {
  $logManager->message("lister");
  // Evolution Liste d'avis
  $floorREP = floor(($competence_J1->getCompetence_REC() < abs($competence_J1->getCompetence_REP()) ? abs($competence_J1->getCompetence_REP()) : $competence_J1->getCompetence_REC()) * 0.25);
  $moy = round(($competence_J1->getCompetence_TIR() + $competence_J1->getCompetence_BGR() + $competence_J1->getCompetence_PHY()) / 3);
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$moy."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvlMin = floor($levelList[0]->getXptable_level() * 0.7);
  if ($levelList[0]->getXptable_level() < 5) $lvlMin = 1;
  if ($lvlMin < 1) $lvlMin = 1;
  $level = $xptableDao->getObject(&$datasource, $lvlMin); 
  $floorCBT = $level->getXptable_xp();
    
  // On rcupre les comptences
  $logManager->message("requete");
  $SQL = "SELECT * FROM `darkcity_competence`, `darkcity_occupation`, `darkcity_user` WHERE user_name = competence_user AND user_actif = 1 AND user_bloque = 0  AND competence_REP >= ".(-1*$levelREC->getXptable_xp())." AND (competence_REP < ".(-1*$floorREP)."  OR (competence_REP < 0 AND (competence_TIR >= $floorCBT OR competence_BGR >= $floorCBT OR competence_PHY >= $floorCBT))) AND competence_user = occupation_user AND competence_user <> '".$user_name."' AND occupation_datefin < ".$dateManager->getCurrentDate()." AND occupation_attaque < ".$dateManager->getCurrentDate()." AND (competence_VIE > 24 OR occupation_lastaction > occupation_attaque) ORDER BY competence_REP ASC;"; 
  $logManager->message("rechercheCombat : ".$SQL);
  $competenceList = $competenceDao->listQuery(&$datasource, $SQL);

  $logManager->message("qui");
  // On trouve quelqu'un ?
  $nbtrouve = sizeof($competenceList);
  if ($nbtrouve == 0) {
    // on a trouv personne
    $continuer=$FALSE;
    $infoManager->setMessage(htmlspecialchars("Il n'y a aucun avis de recherche qui pourrait vous interresser.",ENT_QUOTES));
  }
  else {
    $menuDataBean->desactiveTous();
    $menuDataBean->desactiveQuitter();
    $menuDataBean->setOccupe($FALSE);
    
    $logManager->message("rechercheCombat : selection");
    if ($autre_recherche) {
      $selectionne = $systemeDes->jeterN(1, $nbtrouve) - 1;	
    }
    else {
      $selectionne = 0;	
    }
    $competenceAdv = $competenceList[$selectionne];
    $adv = $competenceAdv->getCompetence_user();
    $logManager->message("rechercheCombat : save");
    $sessionManager->save("adversaire", $adv);
    
   // $infoManager->setMessage(htmlspecialchars("Vous avez trouvs $nbtrouve personnes avec qui vous bagarrer, votre choix se porte sur le numro $selectionne.",ENT_QUOTES));

    $logManager->message("rechercheCombat : create");
    $ficheAdvDataBean = new FicheAdversaireDataBean;

    $logManager->message("rechercheCombat : chargement user $adv");
    // On recupre toutes les infos du User 
    $userDao = new Darkcity_userDao;
    $joueur = $userDao->getObject(&$datasource, $adv);
    $planque = $planqueDao->getObject(&$datasource, $adv);
    $ficheAdvDataBean->setName($joueur->getUser_name());
    $ficheAdvDataBean->setAvatar($joueur->getUser_avatar());
    $ficheAdvDataBean->setDescription($joueur->getUser_description());

    $ficheAdvDataBean->setReputation($competenceAdv->getCompetence_REP());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($competenceAdv->getCompetence_REP())."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $ficheAdvDataBean->setReputationLvl($levelList[0]->getXptable_level());
    $ficheAdvDataBean->setAttitude($planque->getPlanque_attitude());

    $logManager->message("rechercheCombat : chargement competence TIR");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("TIR");
    $comp->setXp($competenceAdv->getCompetence_TIR());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $logManager->message("rechercheCombat : chargement competence TIR Effectu");
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    $logManager->message("rechercheCombat : chargement Jet des");
    if ($systemeDes->jeterOpposition($levelREC->getXptable_level(),0,$comp->getLevel(), 0) > 0) {
      $logManager->message("rechercheCombat : chargement Stock");
      $comp->setAffiche(1);
    }
    $logManager->message("rechercheCombat : fin");
    $ficheAdvDataBean->addCompetence($comp);

    $logManager->message("rechercheCombat : chargement competence BGR");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("BGR");
    $comp->setXp($competenceAdv->getCompetence_BGR());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    if ($systemeDes->jeterOpposition($levelREC->getXptable_level(),0,$comp->getLevel(), 0) > 0) {
      $comp->setAffiche(1);
    }
    $ficheAdvDataBean->addCompetence($comp);

    $logManager->message("rechercheCombat : chargement competence PHY");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("PHY");
    $comp->setXp($competenceAdv->getCompetence_PHY());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    if ($systemeDes->jeterOpposition($levelREC->getXptable_level(),0,$comp->getLevel(), 0) > 0) {
      $comp->setAffiche(1);
    }
    $ficheAdvDataBean->addCompetence($comp);

    $logManager->message("rechercheCombat : chargement competence PIL");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("PIL");
    $comp->setXp($competenceAdv->getCompetence_PIL());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    if ($systemeDes->jeterOpposition($levelREC->getXptable_level(),0,$comp->getLevel(), 0) > 0) {
      $comp->setAffiche(1);
    }
    $ficheAdvDataBean->addCompetence($comp);

    $logManager->message("rechercheCombat : chargement competence PER");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("PER");
    $comp->setXp($competenceAdv->getCompetence_PER());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    if ($systemeDes->jeterOpposition($levelREC->getXptable_level(),0,$comp->getLevel(), 0) > 0) {
      $comp->setAffiche(1);
    }
    $ficheAdvDataBean->addCompetence($comp);
    
  }
  }
  $logManager->message("recherche_bar : fin");
?>