 <?php 
/**
 * modifier_joueur.php : partie mtier de modification du joueur
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  
  $logManager->message("modif_joueur : debut");
  
  // Dclaration des accesseurs
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  
  // Rcupration des variables
  $type = (isset($_POST["type"])?$_POST["type"]:"");
  $user_name = $sessionManager->load("user_name");
  $pwd = (isset($_POST["password"])?$_POST["password"]:"");
  $pwd2 = (isset($_POST["password2"])?$_POST["password2"]:"");
  $email = (isset($_POST["email"])?$_POST["email"]:"");
  $avatar = (isset($_POST["avatar"])?$_POST["avatar"]:"");

  $logManager->message("modif_joueur : type=".$type);
  $logManager->message("modif_joueur : email=".$email);

  //On rcupre le joueur avant modif
  $userDao = new Darkcity_userDao;  
  $user = $userDao->getObject(&$datasource, $user_name);

  // Contrle et mise  jour du password
   if ($type == "pwd") {
        // Le mot de passe est il saisi 
        if ($pwd == "") {
                $errorManager->setMessage("Veuillez entrer votre nouveau mot de passe.");   
        }
        // Verification de l'egalit entre le password et la confirmation
        else if ($pwd != $pwd2) {
                $errorManager->setMessage("Veuillez confirmer votre mot de passe.");   
        }
        else {
              // On met  jour le Darkcity_user
              $user->setUser_password(md5($pwd));
              $userDao->save(&$datasource, $user);
              $infoManager->setMessage("Vous venez de changer votre mot de passe.");
        }
   }

   else if ($type == "mail") {
        // L'email est obligatoire
        if ($email == "") {
                $errorManager->setMessage("Veuillez entrer un email.");   
        }
        else if (!eregi("^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$", $email)) {
                $errorManager->setMessage("Email invalide.");   
        }        
        else {
              // On met  jour le Darkcity_user
              $user->setUser_email($email);
              $userDao->save(&$datasource, $user);
              $infoManager->setMessage("Vous venez de changer votre adresse mail.");
        }
   }
   
   else if ($type == "avatar") {
        $competenceDao = new Darkcity_competenceDao;
        $competence = $competenceDao->getObject(&$datasource, $user_name);
        if ($competence->getCompetence_ARG() < 2000) {
          $infoManager->setMessage("Vous n&#39;avez pas suffisament d&#39;argent pour que je vous opre.");
          $continuer = $FALSE;
        }
        else {
          // le nom de l'avatar dtermine le sexe
          $sexe="H";
          if (strstr($avatar, 'girl')) $sexe = "F";
          // On met  jour le Darkcity_user
          $user->setUser_avatar($avatar);
          $user->setUser_sex($sexe);
          $userDao->save(&$datasource, $user);
          $competence->setCompetence_ARG($competence->getCompetence_ARG() - 2000);
          $perte_REP = round($competence->getCompetence_REP() * 0.2);
          $competence->setCompetence_REP($competence->getCompetence_REP() - $perte_REP);

          $xptableDao = new Darkcity_xptableDao;
          $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($perte_REP)."' ORDER BY xptable_level DESC;";
          $levelList = $xptableDao->listQuery(&$datasource, $sql); 
          $bonus_REP = $levelList[0]->getXptable_level();
          if ($bonus_REP < 5) $bonus_REP = 5;
          $bonusDao = new Darkcity_bonusDao;
          $bonus = $bonusDao->getObject(&$datasource, $user_name, "REP");
          
          $creer = ($bonus->getBonus_datefin() == "" || $bonus->getBonus_datefin() == 0);
          $bonus->setBonus_bonus($bonus_REP);
          $bonus->setBonus_datefin($dateManager->getFutureDate(72*$HEURE));
          if ($creer) {
      	    $bonusDao->create(&$datasource, $bonus);
          }
          else {
      	    $bonusDao->save(&$datasource, $bonus);
          }
          
          $competenceDao->save(&$datasource, $competence);
          $messageManager->sendMessage('', $user_name, "Vous venez de subir une opration pour modifier votre visage", htmlspecialchars(str_replace("&#39;","'","Vous tes dsormais beaucoup moins identifiabe...\n Vous gagnez un bonus de +$bonus_REP pendant 72 heures, lorsqu'on vous recherche.\n Vous perdez ".abs($perte_REP)." de rputation.\nL'opration vous a cout 2000 $."), ENT_QUOTES), $dateManager->getCurrentDate());
          
          $infoManager->setMessage("Vous venez de subir une opration pour modifier votre visage.");
          $continuer = $TRUE;
        }
   }
  
//  $logManager->message(htmlspecialchars("\n",ENT_QUOTES).$texte);
//  $messageManager->sendMessage('',$user_name,"Vous venez de mettre a jour vos donne administratives");  
  $logManager->message("Modif_joueur : fin");
?>