<?php 
/**
 * mairie.php : vue correspondant  la page mairie
 *
 * Date    : 21/03/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

  $logManager->message("page mairie : debut"); 
  include("vue/header.php");
?>
      <div class="main">

        <?php
          if ($errorManager->isError()) {
            echo "<div class=\"error\">";
            echo $errorManager->getMessage();
            echo "</div>";
          }
        ?>
        
        <div class="box">
            <?php
              echo "<form style=\"margin: 0; padding: 0;\" action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
            ?>  
              <div style="text-align: left;">
              <input type="hidden" name="pageCourante" value="mairie" />
              <input name="action" class="onglet" type="submit" value="Administratif" />
              <input name="action" class="onglet_disabled" type="submit" value="Contacts" disabled="disabled" />
              </div>
            </form>
          <div class="titlebox">La mairie</div>
          <div class="messages-box" style="text-align: left;">
            <img class="image" src="images/lieux/mairie_in.gif" alt="[Mairie]" title="" /><br/>
            Le maire est un homme trs respect dans cette ville.
            <br/>
            Malgrs sont agenda surcharg, il fera son possible pous vous accorder toutes son attention. 
            <br/>
            <br/>
	          "Bonjour, laissez mois vous prsenter les divers moyen de communications qu'il y a autour du jeu..."
            <br/>
	          <br/>
	        </div>
        </div>  

  <div class="box">
    <div class="titlebox">La messagerie interne</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/mail.gif" alt="[Messagerie]" title=""/><br/>Vous avez  votre disposition une messagerie interne au jeu.<br/>
      Celle-ci vous permet de converser avec un autre joueur, cette discussion est prive et n'est pas visible par les autres joueurs. Merci de restez courtois lorsque vous vous adressez  une autre personne et de respecter la "Netiquette".<br/>
    </div>
  </div>  

  <div class="box">
    <div class="titlebox">Le tchat</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/itchat.gif" alt="[Tchat]" title=""/><br/>Vous avez galement  votre disposition un tchat.<br/>
      Cela vous permet d'avoir des discussions avec l'ensemble des joueurs connects, tout ce que vous dites est alors visible pendant une heure par tous les autres joueurs. Merci de restez courtois lorsque vous vous exprimez sur le tchat et de respecter la "Netiquette".<br/>
    </div>
  </div>  
  
  <div class="box">
    <div class="titlebox">Le site du projet</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/site.gif" alt="[Site]" title=""/><br/><strong>DarkCity</strong> est un projet Libre, il possde donc un sie Web.<br/>
      Vous pourrez y trouver diverses informations telles que : une prsentation du projet, les travaux en cours, divers petits utilitaires.
      Son adresse : <a href="http://darken33.free.fr/index.php?cat=8&rub=35" target="_blank">http://darken33.free.fr/</a><br/>
    </div>
  </div>  

  <div class="box">
    <div class="titlebox">Rapporter un bug, faire une demande d'volution</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/bug.gif" alt="[Bug]" title=""/><br/>Vous avez trouv un bug ? Vous avez une proposition d'volution  faire ?<br/>
      N'hsitez pas a aller faire un tour sur notre Bugtracker "Flyspray", vous n'tes pas oblig de vous inscrire pour effectuer une demande ou vous tenir inform sur les incidents ou volutions dj enregistrs.<br/>
      Son adresse : <a href="http://darken33.free.fr/Flyspray/" target="_blank">http://darken33.free.fr/Flyspray/</a><br/>
    </div>
  </div>  

  <div class="box">
    <div class="titlebox">Participer aux discussions sur le futur de DarkCity</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/mailing_list.gif" alt="[Mailing List]" title=""/><br/>Vous dsirez participer aux discussions sur les futures evolutions du jeu ?<br/>
      Vous avez pour cela la possibilit de vous inscrire sur notre mailing list. Vous serez alors inform, et vous pourrez participer aux dbats concerant le jeu.<br/>
      Pour s'inscrire : <a href="mailto:darkcitygame-request@ml.free.fr?subject=subscribe" target="_blank">darkcitygame-request@ml.free.fr?subject=subscribe</a><br/>
    </div>
  </div>  
  
  <div class="box">
    <div class="titlebox">DarkCity sur Facebook</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/facebook.gif" alt="[Site]" title=""/><br/>Un groupe <strong>DarkCity</strong> existe sur facebook.<br/> 
      Vous pouvez rejoindre ce groupe et participer ainsi  la promotion du jeu, et nous contacter au travers de cet outil.<br/>
      L'adresse du groupe : <a href="http://www.facebook.com/group.php?gid=50177858187" target="_blank">http://www.facebook.com/group.php?gid=50177858187</a><br/>
    </div>
  </div>    
    
  <div class="box">
    <div class="titlebox">darkcitygame@free.fr</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/mail.gif" alt="[Contact]" title=""/><br/>Vous avez une question ? vous dsirez une information particulire ?.<br/>
      Vous pouvez contacter l'quipe qui gre et dveloppe <strong>DarkCity</strong> par email  l'adresse <a href="mailto:darkcitygame@free.fr">darkcitygame@free.fr</a>. Nous vous rpondrons dans les meilleurs dlais.<br/>
    </div>
  </div>  

      <hr />
   </div>
<?php 
include("vue/footer.php");
$logManager->message("page mairie : fin"); 
?>