<?php 
/**
 * marchand_inventaire.php : vue correspondant  la page inventaire chez le marchand
 *
 * Date    : 21/03/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

 $logManager->message("page marchand_inventaire : debut"); 
  include("vue/header.php");
?>
      <div class="main">

<?php 
  include("vue/marchand.php");
?>

        <br/>
       <!-- Votre portefeuille -->
        <div style="margin-left: 50px; margin-right: 50px; float: left;">
          <table style="width: 350px">
            <?php 
              echo '<tr  class="tab"><th class="titlebox" >Vous portefeuille contient actuellement '.$marchandDataBean->getPortefeuille().' $</th></tr>'."\n";
		?>
          </table>	
        </div>
        <br/>

        <!-- Vos objets -->
        <div class="box" style="margin-left: 50px;">
          <table style="width: 700px">
            <tr  class="tab"><th class="titlebox" colspan="3" style="text-align: left;">
            <?php
              echo "<form style=\"margin: 0; padding: 0;\" action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
            ?>  
              <div>
              <input type="hidden" name="pageCourante" value="marchand" />
              <input name="action" class="onglet_disabled" type="submit" value="Vos objets" disabled="disabled" />
              <input name="action" class="onglet" type="submit" value="Objets en vente" />
              </div>
            </form>
            </th></tr>
            <?php 
              if ($marchandDataBean->getNbInventaire() == 0) {
              	echo "<tr class=\"tab\"><td class=\"tab\" colspan=\"3\">Vous ne possdez aucun objets suceptible d'intresser ce marchand</td></tr>";
              }
              else {
              	for ($i = 0; $i < $marchandDataBean->getNbInventaire(); $i++) {
              	  $objet = $marchandDataBean->getInventaireAt($i);
                  echo '<tr  class="tab">'."\n";
                  echo '  <td  class="tab" style="text-align: center;">'."\n";
                  echo '    <span class="object">'.$objet->getName().'</span><br/>'."\n";
                  echo '    <img class="object" src="images/'.$objet->getImage().'" alt="'.$objet->getDescription().'" title="'.$objet->getDescription().'" /><br/>'."\n";
                  if ($objet->hasPdsMax()) {
                    echo '    <span class="state-'.($objet->getPds() == 0 ? 'broken' : ($objet->getPds() == $objet->getPdsMax() ? 'good' : 'bad')).'">['.$objet->getPds().']</span><br/>'."\n";
                  }
                  else {
                    echo '    <span class="state-good">['.$objet->getPds().']</span><br/>'."\n";
                  }
                  echo '    <span class="active">'.($objet->isActif() ? '' : 'in').'actif</span>'."\n";
                  echo '  </td>'."\n";
                  echo '  <td class="tab" style="vertical-align: top">'."\n";
                  echo '    '.$objet->getDescription().' associ&eacute;(e) &agrave; la comp&eacute;tence '.$objet->getCompetence().'<br/>	'."\n";
                  echo '    Bonus : '.($objet->getBonus() >= 0 ? '+' : '').$objet->getBonus().'<br/>'."\n";
                  if ($objet->getPrix_vente() > 0) { 
                     echo '    Prix de vente : '.$objet->getPrix_vente().' $<br/>'."\n";
                  }
                  else {
                     echo '    L objet est deja utilise et ne peut etre vendu';
                  }
                  echo '  </td>'."\n";
                  echo '  <td class="tab" style="text-align: center; vertical-align: top">'."\n";
                  echo '    <form action="'.$sessionManager->parseURL("index.php", "").'" method="post">';   
                  echo '      <div>'."\n";
                  echo '        <input name="pageCourante" type="hidden" value="marchand" />'."\n";
                  echo '        <input name="object_id" type="hidden" value="'.$objet->getId().'" /><br/>'."\n";
                  if ((!$objet->isActif()) and ($objet->getPrix_vente() > 0)) {
                     echo '        <input name="action" class="action'.($menuDataBean->isOccupe() ? '_disabled' : '').'" type="submit" value="Vendre" '.($menuDataBean->isOccupe() ? 'disabled="disabled"' : '').' /><br/><br/>'."\n";
                  }
                  echo '      </div>  '."\n";
                  echo '    </form>'."\n";
                  echo '  </td>'."\n";
                  echo '</tr>'."\n";
              	}
              }
            ?>
          </table>
        </div>
       
      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  
       
       <!-- Bloc on sort du marchand -->
        <div class="box">
          <div class="titlebox">Retourner en ville</div>
          <input type="hidden" name="pageCourante" value="marchand" />
          <div class="action-box" style="text-align: left;">
            <img class="image" src="images/lieux/porte.gif" alt="[Sortir]" title=""/>Vous ne trouvez pas utile de vous attarder plus longtemps et prfrez sortir de chez ce marchand.<br/>
          </div>
          <div class="actions-right">
            <input name="action" class="action" type="submit" value="Sortir" /> 
          </div>  
        </div> 
      </form>
    </div>
      
<?php 
  include("vue/footer.php");
  $logManager->message("page marchand_inventaire : fin"); 
?>