<?php 
/**
 * messages.php : vue correspondant  la page de gestion des messages
 *
 * Date    : 18/03/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

  $logManager->message("page messages : debut"); 
  include("vue/header.php");
?>
      <div class="main">
<p/>
<?php
  if ($errorManager->isError()) {
    echo "        <div class=\"error\">".$errorManager->getMessage()."</div>";
  }
  if ($infoManager->isInfo()) {
    echo '        <div style="margin: 50px; margin-top: 20px;" >'."\n";
    echo '          <table style="width: 700px">'."\n";
    echo "            <tr  class=\"tab\"><th class=\"titlebox\">Messages d'information</th></tr>"."\n";
    echo '            <tr class="tab"><td class="tab">'."\n";
    echo '        '.$infoManager->getMessage()."\n";
    echo '            </td></tr>'."\n";
    echo '          </table>'."\n";  
    echo '        </div>'."\n";
  }

  echo "        <form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
    $message_courant = new Darkcity_message;
?>  
        <div class="box">
          <div class="titlebox">Messages</div>
          <div class="messages-box">
            <table style="width:680px;" cellspacing="0" cellpadding="0">
<?php 
  if ( $messagesDataBean->getNbMessages() == 0) {
    echo "              <tr class=\"tab\"><td class=\"tab\">Vous n'avez pas de message.</td></tr>\n";
  }
  else {
    for ($i = 0; $i < $messagesDataBean->getNbMessages(); $i++) {
      $message = $messagesDataBean->getMessageAt($i);
      $etat = ($messagesDataBean->getIdListe() != "" && $messagesDataBean->getIdListe() == $message->getMessage_id() ? "courant" : ($message->getMessage_lu() ? "lu" : "non-lu"));
      echo '              <tr class="'.($message->getMessage_from() != "" ? 'perso_' : 'action_').$etat.'"><td>'.($message->getMessage_from() != "" ? $message->getMessage_from()."&gt;" : "&lt;Action&gt;").'</td><td style="text-align: left;">'.($etat != "courant" ? '<a class="message'.($message->getMessage_from() != "" ? '_perso' : '').'" href="'.$sessionManager->parseURL("index.php", "action=lire&amp;id_message=".$message->getMessage_id()."&amp;pageCourante=messages").'">' : '').$message->getMessage_titre().($etat != "courant" ? '</a>' : '').'</td><td>'.$dateManager->dateToString($message->getMessage_validite()).'</td></tr>'."\n";
      if ($etat == "courant") {
        $message_courant = $message;
      }
    }
  }
?>
            </table>
          </div>
          <div class="actions-left">
<?php 
  echo '            <input type="hidden" name="id_message" value="'.$messagesDataBean->getIdListe().'" />'."\n"; 
?> 
            <input type="hidden" name="pageCourante" value="messages" />
<?php
  if ($messagesDataBean->isEdit()) {
    echo '            <input name="action" class="action" type="submit" value="envoyer" />&nbsp;'."\n";
  }
?>
            <input name="action" class="action" type="submit" value="nouveau" /> 
<?php 
  if ($messagesDataBean->getIdListe() != "") { 
    if ($message_courant->getMessage_from() != "") {
      echo '&nbsp;<input name="action" class="action" type="submit" value="r&eacute;pondre" />&nbsp;'."\n";
    }
    echo '&nbsp;<input name="action" class="action" type="submit" value="supprimer" />&nbsp;'."\n"; 
  } 
  if ($messagesDataBean->getNbMessages() > 0) {
    echo '&nbsp;<input type="hidden" name="date" value="'.$dateManager->getCurrentDate().'" /><input name="action" class="action" type="submit" value="vider" />'."\n";
  }
?>  
            &nbsp;<input name="action" class="action" type="submit" value="tchatter" /> 
          </div>  
        </div>  
        <hr />

<?php
  if ($messagesDataBean->getIdListe() != "") {
    echo '        <div style="margin-top: 30px; padding-left: 50px; text-align: left;">'."\n";
    if ($message_courant->getMessage_from() != "") {
      echo '          Expditeur<br/>'."\n";
      echo '          <input name="to" title="Expditeur" class="text" type="text" maxlength="255" value="'.$message_courant->getMessage_from().'" style="width: 150px;" readonly="readonly"/><br/>'."\n";
    }
    echo '          <br/>'."\n";
    echo '          Titre du message<br/>'."\n";
    echo '          <input name="title" title="Titre du message" class="text" type="text" maxlength="255" value="'.$message_courant->getMessage_titre().'" style="width: 550px;" readonly="readonly"/><br/>'."\n";
    echo '          <br/>'."\n";
    echo '          Contenu du message<br/>'."\n";
    echo '          <textarea name="content" title="Contenu du message" class="textarea" style="overflow: scroll;" cols="100" rows="20" readonly="readonly">'.$message_courant->getMessage_contenu().'</textarea><br/>'."\n";
    echo '        </div>'."\n";        
  }
  else if ($messagesDataBean->isEdit()) {
    echo '        <div style="margin-top: 30px; padding-left: 50px; text-align: left;">';
    echo '          Destinataire<br/>'."\n";
    echo '          <input name="to" title="Destinataire" class="text" type="text" maxlength="255" value="'.$to.'" style="width: 150px;" /><br/>'."\n";
    echo '          <br/>'."\n";
    echo '          Titre du message<br/>'."\n";
    echo '          <input name="title" title="Titre du message" class="text" type="text" maxlength="255" value="'.$title.'" style="width: 550px;" /><br/>'."\n";
    echo '          <br/>'."\n";
    echo '          Contenu du message<br/>'."\n";
    echo '          <textarea name="content" title="Contenu du message" class="textarea" style="overflow: scroll;" cols="100" rows="20">'.$content.'</textarea><br/>'."\n";
    echo '        </div>'."\n";        
  }
?>
        </form>
      </div>
<?php 
  include("vue/footer.php");
  $logManager->message("page messages : fin"); 
?>