<?php 
/**
 * zoneAffaires.php : vue correspondant  la page de la zone d'affaires
 *
 * Date    : 21/03/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

 $logManager->message("page zoneAffaires : debut"); 
  include("vue/header.php");
?>
  <div class="main">

      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  

        <?php
          if ($infoManager->isInfo()) {
            echo '<div style="margin: 50px; margin-top: 20px;" >';
            echo '  <table style="width: 700px">';
            echo "    <tr class=\"tab\"><th class=\"titlebox\">Messages d'information</th></tr>";
            echo '    <tr class="tab"><td class="tab">';
            echo $infoManager->getMessage();
            echo '    </td></tr>';
            echo '  </table>';  
            echo '</div>';
          }
        ?>

    <div class="box">
      <input type="hidden" name="pageCourante" value="zoneAffaires" />
      <div class="titlebox">La Zone d'Affaires</div>
      <div class="messages-box" style="text-align: left;">
        <img class="image" src="images/lieux/zoneaffaire_in.gif" alt="[Zone Affaires]" title="" /><br/>
          Vous entrez dans l'agence d'intrim de la zonne d'affaire, l une jeune femme assise devant son ordinateur vous accueille.<br/>
          <br/>
          "Bonjour je m'appelle Alicia, vous recherchez du travail ? Bien, que savez vous faire au juste ?"<br/>
          <br/>
          "Bien, bien, trs interresant, voyons voir ce que nous pouvons trouver..."<br/>
          <br />
          Elle tapotte sur son clavier et vous tend une liste des offres d'emplois disponibles.
        </div>
      </div>  

  <div class="box">
    <div class="titlebox">Les offres d&#39;emploi disponibles</div>
    <div class="scenario-box" style="text-align: left;">
    <?php
      if ($metiersDataBean->getDateMetier2() > $dateManager->getCurrentDate()) {
        echo "Vous avez dja travaill, vous devez respecter les pauses syndicales, revenez me voir ".$dateManager->dateToString($metiersDataBean->getDateMetier2()).".<br/></br>";
      }
      else if ($metiersDataBean->getNbMetier() > 0) {
        echo '<br/><div style="padding-left: 20px;">Voici la liste des emplois qui semblent correspondre  votre profil.</div><br/>';
        $nbMetiers = $metiersDataBean->getNbMetier();
        $logManager->message("test ".$nbMetiers);
        for ($i = 0; $i < $metiersDataBean->getNbMetier(); $i++) {
          $logManager->message("test ".$i);
          $metier = $metiersDataBean->getMetierAt($i);
          $cmp = "";
          if ($metier->getCmpname_name() == "REC") $cmp = "Recherche";
          if ($metier->getCmpname_name() == "PIL") $cmp = "Poursuite";
          if ($metier->getCmpname_name() == "PER") $cmp = "Persuasion";
          if ($metier->getCmpname_name() == "MED") $cmp = "Mdecine";
          if ($metier->getCmpname_name() == "SEC") $cmp = "Scurit";
          if ($metier->getCmpname_name() == "RPR") $cmp = "Rparation";
          $logManager->message("test metier recupr : ".$metier->getIndice()." ".$metier->getMetier_libelle());
          $bonusSal = round($metier->getXptable_level() / 10) * 15;
          echo '<div style="padding-left: 20px;"><input class="text" type="radio" name="metierKey" value="'.$metier->getIndice().'" '.($i == 0 ? 'checked="checked"' : '').'/> '.$metier->getMetier_libelle(). ' ('.$cmp.','.($bonusSal+$SALAIRE).'$/heure)'.'</div>'."\n";
        }
        echo '<br />';
        echo '<div style="padding-left: 20px;">';
        echo 'Dcidez maintenant la dure de votre travail :&nbsp;';
        echo '<select class="text" name="duree">';
        echo '  <option value="1">1 heure</option>';
        echo '  <option value="2">2 heures</option>';
        echo '  <option value="3">3 heures</option>';
        echo '  <option value="4">4 heures</option>';
        echo '  <option value="5">5 heures</option>';
        echo '  <option value="6">6 heures</option>';
        echo '  <option value="7">7 heures</option>';
        echo '  <option value="8">8 heures</option>';
        echo '</select>';
        echo '</div>';
      }
      else {
        echo "Malheureusement nous n&#39;avons aucune offre, pouvant vous correspondre. revenez plus tard, nous auront peut tre quelque chose  vous proposer.<br/></br>";
      }
    ?>
      <br/>
    </div>
    <?php
      if ($metiersDataBean->getNbMetier() > 0 && $metiersDataBean->getDateMetier2() <= $dateManager->getCurrentDate()) {
        echo '     <div class="actions-right">';
        echo '       <input name="action" class="action" type="submit" value="travailler" />';
        echo '     </div>';  
      }
    ?>  
  </div>  
      
      <div class="box">
        <div class="titlebox">Retourner en ville</div>
        <div class="action-box" style="text-align: left;">
          <img class="image" src="images/lieux/porte.gif" alt="[Sortir]" title=""/><br/>Vous ne trouvez aucun travail qui vous intresse, vous dcidez de retourner en ville, et de revenir plus tard.<br/>
        </div>
        <div class="actions-right">
          <input name="action" class="action" type="submit" value="Sortir" /> 
        </div>  
      </div> 
    </form>
  </div>  
<?php
  include("vue/footer.php");
  $logManager->message("page zoneAffaires : fin"); 
?>