<?php
/**
 * ActivitesDaaBean.php : DataBean pour la page de centre de loisir
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class ActivitesDataBean {
  
  /** Activite */
  var $activitesList = array();
  
  function ActivitesDataBean() {
  }
  function getActiviteAt($index) {
    return $this->activitesList[$index];
  }
  function resetActivites() {
    $this->activitesList = array();
  }
  function getNbActivite() {
    return sizeof($this->activitesList);
  }
  function addActivite($activite) {
    array_push($this->activitesList, $activite);
  }
  function setActiviteAt($index, $activite) {
    $this->activitesList[$index] = $activite;
  }
}
?>