<?php
/**
 * FichePersoDataBean.php : DataBean utilis pour reprsenter le joueur
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class FichePersoDataBean {
  
  /** Message d'information */
  var $msgInfo = "";
  var $dateFin = "";
  /** Identite */
  var $name = "";
  var $avatar = "";
  var $reputation = "";
  var $reputation_lvl = "";
  var $argent = "";
  var $combat = "";
  var $carractere = "";
  /** comptences */
  var $competences = array();
  /** sant */
  var $sante = "";
  /** description */
  var $description = "";
  /** invetaires */
  var $inventaires = array();
  
  function FichePersoDataBean() {
  }
  
  function setMsgInfo($msgInfo) {
    $this->msgInfo = $msgInfo;	
  }
  function getMsgInfo() {
    return $this->msgInfo;	
  }

  function setDateFin($dateFin) {
    $this->dateFin = $dateFin;	
  }
  function getDateFin() {
    return $this->dateFin;	
  }

  function setName($name) {
    $this->name = $name;	
  }
  function getName() {
    return $this->name;	
  }

  function setAvatar($avatar) {
    $this->avatar = $avatar;	
  }
  function getAvatar() {
    return $this->avatar;	
  }

  function setReputation($reputation) {
    $this->reputation = $reputation;	
  }
  function getReputation() {
    return $this->reputation;	
  }

  function setReputationLvl($reputation_lvl) {
    $this->reputation_lvl = $reputation_lvl;	
  }
  function getReputationLvl() {
    return $this->reputation_lvl;	
  }

  function setArgent($argent) {
    $this->argent = $argent;	
  }
  function getArgent() {
    return $this->argent;	
  }

  function setCombat($combat) {
    $this->combat = $combat;	
  }
  function getCombat() {
    return $this->combat;	
  }

  function setCarractere($carractere) {
    $this->carractere = $carractere;	
  }
  function getCarractere() {
    return $this->carractere;	
  }

  function getCompetenceAt($index) {
    return $this->competences[$index];
  }
  function getNbCompetence() {
    return sizeof($this->competences);
  }
  function addCompetence($competence) {
    array_push($this->competences, $competence);
  }
  function setCompetenceAt($index, $competence) {
    $this->competences[$index] = $competence;
  }

  function setSante($sante) {
    $this->sante = $sante;	
  }
  function getSante() {
    return $this->sante;	
  }

  function setDescription($description) {
    $this->description = $description;	
  }
  function getDescription() {
    return $this->description;	
  }

  function getInventaireAt($index) {
    return $this->inventaires[$index];
  }
  function getNbInventaire() {
    return sizeof($this->inventaires);
  }
  function addInventaire($inventaire) {
    array_push($this->inventaires, $inventaire);
  }
  function setInventaireAt($index, $inventaire) {
    $this->inventaires[$index] = $inventaire;
  }

}
?>