<?php
/**
 * highscoreDataBean.php : DataBean utilis pour la page HighScore
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class highscoreDataBean {
  
  /** Identite */
  var $name = "";
  /** justiciers */
  var $justicier = array();
  /** user justicier */
  var $user_justicier = "";
  /** user justicier */
  var $user_justicier_b = "";
  /** gansters */
  var $gangster = array();
  /** user gangster */
  var $user_gangster = "";
  /** user gangster */
  var $user_gangster_b = "";
  /** Tirreurs */
  var $tir = array();
  /** user Tirreur */
  var $user_tir = "";
  /** user Tirreur */
  var $user_tir_b = "";
  /** Bagarre */
  var $bagarre = array();
  /** user bagarre */
  var $user_bagarre = "";
  /** user bagarre */
  var $user_bagarre_b = "";
  /** physique */
  var $physique = array();
  /** user physique */
  var $user_physique = "";
  /** user physique */
  var $user_physique_b = "";
  /** recherche */
  var $recherche = array();
  /** user recherche*/
  var $user_recherche = "";
  /** user recherche*/
  var $user_recherche_b = "";
  /** securite */
  var $securite = array();
  /** user securite */
  var $user_securite = "";
  /** user securite */
  var $user_securite_b = "";
  /** reparation */
  var $reparation = array();
  /** user reparation */
  var $user_reparation = "";
  /** user reparation */
  var $user_reparation_b = "";
  /** Pilotage */
  var $pilotage = array();
  /** user pilotage */
  var $user_pilotage = "";  
  /** user pilotage */
  var $user_pilotage_b = "";  
  /** medecine */
  var $medecine = array();
  /** user medecine */
  var $user_medecine = "";  
  /** user medecine */
  var $user_medecine_b = "";  
  /** persuasion */
  var $persuasion = array();
  /** user persuasion */
  var $user_persuasion = "";  
  /** user persuasion */
  var $user_persuasion_b = "";  
  /** Nombre user connects */
  var $nb_connectes = "";  
  /** Nombre gangster */
  var $nb_gangster = "";  
  /** Nombre justicier */
  var $nb_justicier = "";  
  /** Nombre users total */
  var $nb_users = "";  
  /** Reputation de la ville */
  var $villeRep = 0;  
  /** Connects */
  var $enligne = array();
  
  function highscoreDataBean() {
  }  
  function setName($name) {
    $this->name = $name;	
  }
  function getName() {
    return $this->name;	
  }
  /* Les justicier */
  function getJusticierAt($index) {
    return $this->justicier[$index];
  }
  function getNbjusticier() {
    return sizeof($this->justicier);
  }
  function addJusticier($liste) {
    array_push($this->justicier, $liste);
  }
  function setJusticierAt($index, $liste) {
    $this->justicier[$index] = $liste;
  }
  function setUser_justicier($liste) {
    $this->user_justicier = $liste;	
  }
  function getUser_justicier() {
    return $this->user_justicier;	
  }
  function setUser_justicier_b($liste) {
    $this->user_justicier_b = $liste;	
  }
  function getUser_justicier_b() {
    return $this->user_justicier_b;	
  }
  /* Les gangsters */
  function getGangsterAt($index) {
    return $this->gangster[$index];
  }
  function getNbgangster() {
    return sizeof($this->gangster);
  }
  function addGangster($liste) {
    array_push($this->gangster, $liste);
  }
  function setGangsterAt($index, $liste) {
    $this->gangster[$index] = $liste;
  }
  function setUser_gangster($liste) {
    $this->user_gangster = $liste;	
  }
  function getUser_gangster() {
    return $this->user_gangster;	
  }
  function setUser_gangster_b($liste) {
    $this->user_gangster_b = $liste;	
  }
  function getUser_gangster_b() {
    return $this->user_gangster_b;	
  }
  /* Les Tirreurs */
  function getTirAt($index) {
    return $this->tir[$index];
  }
  function getNbtir() {
    return sizeof($this->tir);
  }
  function addTir($liste) {
    array_push($this->tir, $liste);
  }
  function setTirAt($index, $liste) {
    $this->tir[$index] = $liste;
  }
  function setUser_tir($liste) {
    $this->user_tir = $liste;	
  }
  function getUser_tir() {
    return $this->user_tir;	
  }
  function setUser_tir_b($liste) {
    $this->user_tir_b = $liste;	
  }
  function getUser_tir_b() {
    return $this->user_tir_b;	
  }
  /* Les Bagarreurs */
  function getBagarreAt($index) {
    return $this->bagarre[$index];
  }
  function getNbbagarre() {
    return sizeof($this->bagarre);
  }
  function addBagarre($liste) {
    array_push($this->bagarre, $liste);
  }
  function setBagarreAt($index, $liste) {
    $this->bagarre[$index] = $liste;
  }
  function setUser_bagarre($liste) {
    $this->user_bagarre = $liste;	
  }
  function getUser_bagarre() {
    return $this->user_bagarre;	
  }
  function setUser_bagarre_b($liste) {
    $this->user_bagarre_b = $liste;	
  }
  function getUser_bagarre_b() {
    return $this->user_bagarre_b;	
  }
  /* Les Costauds */
  function getPhysiqueAt($index) {
    return $this->physique[$index];
  }
  function getNbphysique() {
    return sizeof($this->physique);
  }
  function addPhysique($liste) {
    array_push($this->physique, $liste);
  }
  function setPhysiqueAt($index, $liste) {
    $this->physique[$index] = $liste;
  }
  function setUser_physique($liste) {
    $this->user_physique = $liste;	
  }
  function getUser_physique() {
    return $this->user_physique;	
  }
  function setUser_physique_b($liste) {
    $this->user_physique_b = $liste;	
  }
  function getUser_physique_b() {
    return $this->user_physique_b;	
  }
  /* Les dtectives */
  function getRechercheAt($index) {
    return $this->recherche[$index];
  }
  function getNbrecherche() {
    return sizeof($this->recherche);
  }
  function addRecherche($liste) {
    array_push($this->recherche, $liste);
  }
  function setRechercheAt($index, $liste) {
    $this->recherche[$index] = $liste;
  }
  function setUser_recherche($liste) {
    $this->user_recherche = $liste;	
  }
  function getUser_recherche() {
    return $this->user_recherche;	
  }
  function setUser_recherche_b($liste) {
    $this->user_recherche_b = $liste;	
  }
  function getUser_recherche_b() {
    return $this->user_recherche_b;	
  }
  /* Les srurriers */
  function getSecuriteAt($index) {
    return $this->securite[$index];
  }
  function getNbsecurite() {
    return sizeof($this->securite);
  }
  function addSecurite($liste) {
    array_push($this->securite, $liste);
  }
  function setSecuriteAt($index, $liste) {
    $this->securite[$index] = $liste;
  }
  function setUser_securite($liste) {
    $this->user_securite = $liste;	
  }
  function getUser_securite() {
    return $this->user_securite;	
  }
  function setUser_securite_b($liste) {
    $this->user_securite_b = $liste;	
  }
  function getUser_securite_b() {
    return $this->user_securite_b;	
  }
  /* Les rparateurs */
  function getReparationAt($index) {
    return $this->reparation[$index];
  }
  function getNbreparation() {
    return sizeof($this->reparation);
  }
  function addReparation($liste) {
    array_push($this->reparation, $liste);
  }
  function setReparationAt($index, $liste) {
    $this->reparation[$index] = $liste;
  }
  function setUser_reparation($liste) {
    $this->user_reparation = $liste;	
  }
  function getUser_reparation() {
    return $this->user_reparation;	
  }
  function setUser_reparation_b($liste) {
    $this->user_reparation_b = $liste;	
  }
  function getUser_reparation_b() {
    return $this->user_reparation_b;	
  }
  /* Les pilotes */
  function getPilotageAt($index) {
    return $this->pilotage[$index];
  }
  function getNbpilotage() {
    return sizeof($this->pilotage);
  }
  function addPilotage($liste) {
    array_push($this->pilotage, $liste);
  }
  function setPilotageAt($index, $liste) {
    $this->pilotage[$index] = $liste;
  }
  function setUser_pilotage($liste) {
    $this->user_pilotage = $liste;	
  }
  function getUser_pilotage() {
    return $this->user_pilotage;	
  }
  function setUser_pilotage_b($liste) {
    $this->user_pilotage_b = $liste;	
  }
  function getUser_pilotage_b() {
    return $this->user_pilotage_b;	
  }
  /* Les mdecins */
  function getMedecineAt($index) {
    return $this->medecine[$index];
  }
  function getNbmedecine() {
    return sizeof($this->medecine);
  }
  function addMedecine($liste) {
    array_push($this->medecine, $liste);
  }
  function setMedecineAt($index, $liste) {
    $this->medecine[$index] = $liste;
  }
  function setUser_medecine($liste) {
    $this->user_medecine = $liste;	
  }
  function getUser_medecine() {
    return $this->user_medecine;	
  }
  function setUser_medecine_b($liste) {
    $this->user_medecine_b = $liste;	
  }
  function getUser_medecine_b() {
    return $this->user_medecine_b;	
  }
  /* Les Commerciaux */
  function getPersuasionAt($index) {
    return $this->persuasion[$index];
  }
  function getNbpersuasion() {
    return sizeof($this->persuasion);
  }
  function addPersuasion($liste) {
    array_push($this->persuasion, $liste);
  }
  function setPersuasionAt($index, $liste) {
    $this->persuasion[$index] = $liste;
  }
  function setUser_persuasion($liste) {
    $this->user_persuasion = $liste;	
  }
  function getUser_persuasion() {
    return $this->user_persuasion;	
  }
  function setUser_persuasion_b($liste) {
    $this->user_persuasion_b = $liste;	
  }
  function getUser_persuasion_b() {
    return $this->user_persuasion_b;	
  }
  /*les connectes */
  function setNb_connectes($nb_connectes) {
    $this->nb_connectes = $nb_connectes;	
  }
  function getNb_connectes() {
    return $this->nb_connectes;	
  }
  function getEnligneAt($index) {
    return $this->enligne[$index];
  }
  function addEnligne($liste) {
    array_push($this->enligne, $liste);
  }
  function setEnligneAt($index, $liste) {
    $this->enligne[$index] = $liste;
  }
  /*les Nbr gansters */
  function setNb_gangster($nb_gangster) {
    $this->nb_gangster = $nb_gangster;	
  }
  function getNb_gangster() {
    return $this->nb_gangster;	
  }
  /*les Nbr justiciers */
  function setNb_justicier($nb_justicier) {
    $this->nb_justicier = $nb_justicier;	
  }
  function getNb_justicier() {
    return $this->nb_justicier;	
  }
  /*les Nbr users total */
  function setNb_users($nb_users) {
    $this->nb_users = $nb_users;	
  }
  function getNb_users() {
    return $this->nb_users;	
  }
  /*la rputation de la Ville */
  function setVilleRep($villeRep) {
    $this->villeRep = $villeRep;	
  }
  function getVilleRep() {
    return $this->villeRep;	
  }

}
?>