<?php
/**
 * MarchandDataBean.php : DataBean utilis dans la page Marchand
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class marchandDataBean {
  
  /** Message d'information */
  var $msgInfo = "";
  var $dateFin = "";
  /** Identite */
  var $name = "";
  /** objet en ventes */
  var $marchand = array();
  /** invetaires */
  var $inventaires = array();
  /** Portefeuille */
  var $portefeuille = "";
  
  function marchandDataBean() {
  }  
  function setMsgInfo($msgInfo) {
    $this->msgInfo = $msgInfo;	
  }
  function getMsgInfo() {
    return $this->msgInfo;	
  }
  function setName($name) {
    $this->name = $name;	
  }
  function getName() {
    return $this->name;	
  }
  function setDateFin($dateFin) {
    $this->dateFin = $dateFin;	
  }
  function getDateFin() {
    return $this->dateFin;	
  }
  function getMarchandAt($index) {
    return $this->marchand[$index];
  }
  function getNbmarchand() {
    return sizeof($this->marchand);
  }
  function addMarchand($inventaire) {
    array_push($this->marchand, $inventaire);
  }
  function setMarchandAt($index, $inventaire) {
    $this->marchand[$index] = $inventaire;
  }
  function getInventaireAt($index) {
    return $this->inventaires[$index];
  }
  function getNbInventaire() {
    return sizeof($this->inventaires);
  }
  function addInventaire($inventaire) {
    array_push($this->inventaires, $inventaire);
  }
  function setInventaireAt($index, $inventaire) {
    $this->inventaires[$index] = $inventaire;
  }
  function setPortefeuille($portefeuille) {
    $this->portefeuille = $portefeuille;	
  }
  function getPortefeuille() {
    return $this->portefeuille;	
  }
}
?>