<?php
/**
 * MenuDataBean.php : DataBean utilis pour afficher le menu
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class MenuDataBean {
  
  /** La competence */
  var $bouton_fiche = 1;
  var $bouton_messages = 1;
  var $bouton_ville = 1;
  var $bouton_planque = 1;
  var $bouton_highscore = 1;
  var $bouton_quitter = 1;
  var $occupe = 0;
   
  function MenuDataBean() {
  }

  function isBoutonFicheActif() {
    return $this->bouton_fiche;
  }
  function isBoutonMessagesActif() {
    return $this->bouton_messages;
  }
  function isBoutonVilleActif() {
    return $this->bouton_ville;
  }
  function isBoutonPlanqueActif() {
    return $this->bouton_planque;
  }
  function isBoutonHighScoreActif() {
    return $this->bouton_highscore;
  }
  function isBoutonQuitterActif() {
    return $this->bouton_quitter;
  }
  function isOccupe() {
    return $this->occupe;
  }
  function setOccupe($occupe) {
    $this->occupe = $occupe;
  }
  function activeTous() {
    $this->bouton_fiche = 1;
    $this->bouton_messages = 1;
    $this->bouton_ville = 1;
    $this->bouton_planque = 1;
    $this->bouton_highscore = 1;
    $this->bouton_quitter = 1;
  }
  function desactiveTous() {
    $this->bouton_fiche = 0;
    $this->bouton_messages = 0;
    $this->bouton_ville = 0;
    $this->bouton_planque = 0;
    $this->bouton_highscore = 0;
  }    
  function desactiveQuitter() {
    $this->bouton_quitter = 0;
  }    
  function desactiveOccupe() {
    $this->bouton_ville = 0;
  }    

}

?>