<?php
/**
 * MiniFicheDataBean.php : DataBean utilis pour la mini fiche
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

class MiniFicheDataBean {
  
  var $reputation = "";
  var $argent = "";
  var $competences = array();
  var $sante = "";

  function MiniFicheDataBean() {
  }
  
  function getDate() {
    return date("d/m/Y H:i");	
  }

  function setReputation($reputation) {
    $this->reputation = $reputation;	
  }
  function getReputation() {
    return $this->reputation;	
  }

  function setArgent($argent) {
    $this->argent = $argent;	
  }
  function getArgent() {
    return $this->argent;	
  }

  function getCompetenceAt($index) {
    return $this->competences[$index];
  }
  function getNbCompetence() {
    return sizeof($this->competences);
  }
  function addCompetence($competence) {
    array_push($this->competences, $competence);
  }
  function setCompetenceAt($index, $competence) {
    $this->competences[$index] = $competence;
  }

  function setSante($sante) {
    $this->sante = $sante;	
  }
  function getSante() {
    return $this->sante;	
  }

}
?>