 <?php 
/**
 * abandon_cbt_bar.php : partie mtier d'abandon d'un comabt dans le bar
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  
  $logManager->message("rechercheCombat : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");

  $user_name = $sessionManager->load("user_name");
  $adv = $sessionManager->load("adversaire");
  
  // On rcupre les comptences
  $occupationDao = new Darkcity_occupationDao;
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);
  
  $cmp = $competence->getCompetence_REP();
  
  $xptableDao = new Darkcity_xptableDao;
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($cmp)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $xp = ($levelList[0]->getXptable_level());

  $titre = htmlspecialchars("Vous vous excusez auprs de ".$adv." et vitez le combat. Votre rputation diminue.", ENT_QUOTES);
  $texte = htmlspecialchars("Vous vous excusez auprs de ".$adv." et vitez le combat, votre mauvaise action a cependant t remarque, votre ".($cmp < 0 ? "Mauvaise" : "Bonne"). " rputation diminue de ".$xp." points.", ENT_QUOTES);
  
  $competence->setCompetence_REP($cmp < 0 ? $cmp + $xp : $cmp - $xp);
  $competenceDao->save(&$datasource, $competence);
    
  $messageManager->sendMessage('', $user_name, $titre, $texte, $dateManager->getCurrentDate());
  $J1_occupation = $occupationDao->getObject(&$datasource, $user_name);
  $J1_occupation->setOccupation_bar($dateManager->getFutureDate($DELAI_BAR));
  $occupationDao->save(&$datasource, $J1_occupation);

  $logManager->message("recherche_bar : fin");
?>