<?php
/**
 * action_acheter.php : partie mtier d'achat d'un objet chez un marchand
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_acheter : debut");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");

  //rcupration de l'Id objet  faire rparer et du user Name
  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $cmp = (isset($_POST["competence"])?$_POST["competence"]:"");
  $Prix_achat = (isset($_POST["prix_achat"])?$_POST["prix_achat"]:"");
  $user_name = $sessionManager->load("user_name");

  //rcupration des comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 
  $logManager->message("action_acheter : comptence=".$cmp);
              
  //init des variables
  $logManager->message("action_acheter : rcupre objet");
  $inventaireDao = new Darkcity_inventaireDao;
  $objetDao = new Darkcity_objetDao;
  $continuer = $TRUE;
  $pds = 0;
  $name = "";  
  $prix = 0;  
  
  // Vehicules
  if ($cmp == "PIL") {  
    $vehiculeDao = new Darkcity_vehiculeDao;  
    $vehicule = $vehiculeDao->getObject(&$datasource, $object_id); 
    //marchadage dj fait dans l'init du concessionnaire
    $prix = ($Prix_achat);    
    $pds = ($vehicule->getVehicule_structure());
    $name = ($vehicule->getVehicule_name());
  }
  // Objet en tout genre
  if (($cmp == "REC") or ($cmp == "MED") or ($cmp == "RPR") or ($cmp == "PER") or ($cmp == "SEC")) {  
    $objetDao = new Darkcity_objetDao;  
    $objet = $objetDao->getObject(&$datasource, $object_id); 
    $prix = ($Prix_achat);    
    $pds = ($objet->getObjet_utilisations());
    $name = ($objet->getObjet_name());
  }
  // Armes blanches
  if ($cmp == "BGR") {  
    $arme_blancheDao = new Darkcity_arme_blancheDao;  
    $arme = $arme_blancheDao->getObject(&$datasource, $object_id); 
    $prix = ($Prix_achat);    
    $pds = ($arme->getAblanche_structure());
    $name = ($arme->getAblanche_name());
  }
  // Armes de tir
  if ($cmp == "TIR") {  
    $armeDao = new Darkcity_armeDao;  
    $arme = $armeDao->getObject(&$datasource, $object_id); 
    $prix = ($Prix_achat);    
    $pds = ($arme->getArme_structure());
    $name = ($arme->getArme_name());
  }
  // Armures
  if ($cmp == "PHY") {  
    $armureDao = new Darkcity_armureDao;  
    $armure = $armureDao->getObject(&$datasource, $object_id); 
    $prix = ($Prix_achat);    
    $pds = ($armure->getArmure_structure());
    $name = ($armure->getArmure_name());
  }
  
 if  ($prix > $competence->getCompetence_ARG()) {
    $infoManager->setMessage("Vous devez avoir au moins ".$prix." $ pour acheter ".$name.".");
    $continuer = $FALSE;
  }
  else {
    $logManager->message("action_acheter : mise a jour");
    // On sauvegarde l'objet en tables
    $inventaireDao = new Darkcity_inventaireDao;
    $objet_cpy = new Darkcity_inventaire_cpy;
    $objet_cpy->setInventaire_cmpname($cmp);
    $objet_cpy->setInventaire_user($user_name);
    $objet_cpy->setInventaire_objid($object_id);
    $objet_cpy->setInventaire_structure($pds);
    $objet_cpy->setInventaire_actif($FALSE);
    $logManager->message("action_acheter : ".$objet_cpy->toString());
    $inventaireDao->create(&$datasource, $objet_cpy);
    
    //Mise a jour des comptences 
    $logManager->message("action_acheter : maj argent -".$prix);
    $competence->setCompetence_ARG($competence->getCompetence_ARG() - $prix);
    $logManager->message("action_acheter : ".$competence->toString());
    $competenceDao->save(&$datasource, $competence);
       
    // On envoie un message au joueur
    $title = htmlspecialchars("Vous avez achet ", ENT_QUOTES).$name." pour la somme de ".$prix.htmlspecialchars(" $", ENT_QUOTES);
    $content = htmlspecialchars("Vous dcidez d'acheter ",ENT_QUOTES).$name.htmlspecialchars(', pour cela vous dpensez ', ENT_QUOTES).$prix." $.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
  
  }
  
  $logManager->message("action_acheter : fin");
?>