<?php
/**
 * action_chat.php : partie mtier du Tchat
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_chat : debut");
  include_once("dao/accesseurs/Darkcity_chatDao.php");
  include_once("dao/objets/Darkcity_chat.php");
  include_once("dao/accesseurs/Darkcity_sessionDao.php");
  include_once("dao/objets/Darkcity_session.php");
  include_once("databean/UserlistDataBean.php");
  include_once("databean/ChatDataBean.php");
  
  $chatDao = new Darkcity_chatDao;
  $chatDataBean = new ChatDataBean;
  
  $logManager->message("action_chat : recup");
  // on rcupre les infos
  $texte = htmlspecialchars((isset($_POST["texte"])?$_POST["texte"]: ""), ENT_QUOTES);
  $user_name = $sessionManager->load("user_name");
  $date = $dateManager->getCurrentDate();
  $key = md5($user_name.$date);
  $color = "";
  
  $chatDataBean->setName($user_name);
  
  // si envoyer
  if ($action =="envoyer" && $texte != "") {
    $logManager->message("action_chat : envoi");
    $chat = new Darkcity_chat;
    $chat->setAll($key,
                  $user_name,
                  $texte,
                  $color,
                  $date);
    $chatDao->create(&$datasource, $chat);
  }
  $logManager->message("action_chat : nettoyage");
  // on supprime les message de plus de 60 mins
  $dateh = $date - (60*$MINUTE);
  $sql = "DELETE FROM darkcity_chat WHERE chat_date < $dateh;";
  $chatDao->databaseUpdate(&$datasource, $sql);
  
  // Lire l'ensemble des messages
  $logManager->message("action_chat : lecture");
  $sql = "SELECT * FROM darkcity_chat ORDER BY chat_date DESC;";
  $listMessages = $chatDao->listQuery(&$datasource, $sql);
  if (sizeof($listMessages)>0) $chatDataBean->setMessages($listMessages);
  
  $logManager->message("init_planque : fin");

  // On rcupre toutes les session ouverte (Nb user conncet)
  $logManager->message("action_chat : sessions");
  $sessionDao = new Darkcity_sessionDao;
  $date = $dateManager->getPastDate(30*$MINUTE);
  $sql = "SELECT * FROM darkcity_session WHERE session_lastaction >= ".$date.";" ;
  $logManager->message("action_chat : $sql");
  $sessionlist = $sessionDao->listQuery(&$datasource, $sql);

  for ($i = 0; $i < sizeof($sessionlist); $i++) {
    $logManager->message("action_chat : $i");
    $session = $sessionlist[$i];
    $userlistDataBean = new UserlistDataBean;
    $userlistDataBean->setPosition($i+1);
    $logManager->message("action_chat : ".$session->getSession_user());
    $userlistDataBean->setList_user($session->getSession_user());    
    $chatDataBean->addEnligne($userlistDataBean);
  }  

  $logManager->message("action_chat : fin");
?>