<?php
/**
 * action_desinscrire.php : partie mtier de dsinscription du jeu
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  include("dao/accesseurs/Darkcity_userDao.php");
  include("dao/objets/Darkcity_user.php");
  include("dao/accesseurs/Darkcity_desinscriptionDao.php");
  include("dao/objets/Darkcity_desinscription.php");
  
  // Rcupration des variables
  $nom = (isset($_POST["nom"])?$_POST["nom"]:"");
  $pwd = (isset($_POST["pwd"])?$_POST["pwd"]:"");
  $email = (isset($_POST["email"])?$_POST["email"]:"");
  
   $continuer = $FALSE;
   // On cree l'accesseur userDao
   $userDao = new Darkcity_userDao;
   $joueur = $userDao->getObject(&$datasource, $nom);
   if ($joueur->getUser_password() == "") {
       $logManager->message("connecter : user non trouve");
       $errorManager->setMessage("Pseudonyme incorrect.");
   }
   else if ($joueur->getUser_actif() == 0) {
       $logManager->message("connecter : user non actif");
       $errorManager->setMessage("Votre compte n'est pas actif.");
   }
   else if ($joueur->getUser_email() != $email) {
       $logManager->message("connecter : email incorrect.");
       $errorManager->setMessage("Email incorrect.");
   }
   else if (!$userManager->connect($pwd, $joueur->getUser_password(), $sessionManager)) {
       $logManager->message("connecter : mot de passe incorrect");
       $errorManager->setMessage("Mot de passe incorrect.");
   }
   else {
       $joueur->setUser_actif($FALSE);
       $userDao->save(&$datasource, $joueur);
       $desinscription = new Darkcity_desinscription;
       $desinscription->setDesinscription_user($nom);
       $desinscription->setDesinscription_date($dateManager->getCurrentDate());
       $desinscriptionDao = new Darkcity_desinscriptionDao;
       $desinscriptionDao->create(&$datasource, $desinscription);
       $infoManager->setMessage("Votre personnage $nom a bien t dsinscrit de DarkCity.");
       $continuer = $TRUE;
   }
?>