<?php
/**
 * action_tir_pnj.php : partie mtier de combat au tir contre un pnj
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_tir_pnj : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("databean/FicheAdversaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");

  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");

  $logManager->message("action_tir_pnj : debut 2");
  $pnj = $sessionManager->load("pnj");
  $logManager->message("action_tir_pnj : debut 3");
  $adv_name = $pnj->getName();
  $logManager->message($adv_name);

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $inventaireDao = new Darkcity_inventaireDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armeDao = new Darkcity_armeDao;
  $armureDao = new Darkcity_armureDao;
  $bonusDao = new Darkcity_bonusDao;
  $occupationDao = new Darkcity_occupationDao;

  // Joueur 1 Level PHY / BGR
  $logManager->message("action_tir_pnj : Joueur 1 Level PHY / TIR");
  $J1_competence = $competenceDao->getObject(&$datasource, $user_name);
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_TIR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_TIR = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_PHY = $levelList[0]->getXptable_level();
  $J1_vie = $J1_competence->getCompetence_VIE();
  $J1_argent = $J1_competence->getCompetence_ARG();
  $J1_reputation = $J1_competence->getCompetence_REP();
  // Joueur 1 Occupation
  $J1_occupation = $occupationDao->getObject(&$datasource, $user_name);
  // Joueur 1 Bonus PHY / BGR
  $logManager->message("action_tir_pnj : Joueur 1 Bonus PHY / TIR");
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'PHY' OR inventaire_cmpname = 'TIR') AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_idxArmure = -1;
  $J1_idxArme = -1;
  for ($i = 0; $i < sizeof($J1_inventaire); $i++) {
    if ($J1_inventaire[$i]->getInventaire_cmpname() == 'TIR') $J1_idxArme = $i;
    if ($J1_inventaire[$i]->getInventaire_cmpname() == 'PHY') $J1_idxArmure = $i;
  }
  $J1_arme = "";
  $J1_arme_precision = 0;
  $J1_arme_nombre = 0;
  $J1_arme_degats = 0;
  $J1_arme_bonus = 0;
  $J1_arme_pds = 0;
  $J1_arme_type = 'P';
  $J1_arme_fiabilite = "";
  if ($J1_idxArme > -1) {
    $arme = $armeDao->getObject(&$datasource, $J1_inventaire[$J1_idxArme]->getInventaire_objid());
    $J1_arme = $arme->getArme_name();
    $J1_arme_precision = $arme->getArme_precision();
    $J1_arme_nombre = $arme->getArme_nombre();
    $J1_arme_degats = $arme->getArme_degats();
    $J1_arme_bonus = $arme->getArme_bonus();
    $J1_arme_type = $arme->getArme_type();
    $J1_arme_pds = $J1_inventaire[$J1_idxArme]->getInventaire_structure();
    $J1_arme_fiabilite = $arme->getArme_fiabilite();
  }
  else {
    $continuer = $FALSE;
    $infoManager->setMessage("Vous devez poss&eacute;der une arme  feu active");
    $ficheAdvDataBean = $pnj;
  }
  if ($continuer) {
    $J1_armure = "";
    $J1_armure_bonus = 0;
    $J1_armure_pds = 0;
    if ($J1_idxArmure > -1) {
      $armure = $armureDao->getObject(&$datasource, $J1_inventaire[$J1_idxArmure]->getInventaire_objid());
      $J1_armure = $armure->getArmure_name();
      $J1_armure_bonus = $armure->getArmure_bonus();
      $J1_armure_pds = $J1_inventaire[$J1_idxArmure]->getInventaire_structure();
    }
  
    // joueur 1 bonus supplementaire
    $logManager->message("action_tir_pnj : joueur 1 bonus supplementaire");
    $J1_bonus_TIR = 0;
    $bonus = $bonusDao->getObject(&$datasource, $user_name, "TIR");  
    if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
      $J1_bonus_TIR = $bonus->getBonus_bonus();
    }
    $J1_bonus_PHY = 0;
    $bonus = $bonusDao->getObject(&$datasource, $user_name, "PHY");  
    if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
      $J1_bonus_PHY = $bonus->getBonus_bonus();
    }

    // PNJ
    $logManager->message("action_tir_pnj : PNJ Level PHY / TIR");
    $cmp = $pnj->getCompetenceAt(1);
    $J2_level_BGR = $cmp->getLevel();
    $cmp = $pnj->getCompetenceAt(0);
    $J2_level_TIR = $cmp->getLevel();
    $cmp = $pnj->getCompetenceAt(2);
    $J2_level_PHY = $cmp->getLevel();
    $J2_vie = 100;
  
    // Joueur 2 Bonus PHY / BGR
    $logManager->message("action_tir_pnj : Joueur 2 Bonus PHY / TIR");
    $J2_idxArmure = -1;
    $J2_idxArme = -1;
    $J2_arme = "";
    $J2_arme_precision = 0;
    $J2_arme_nombre = 0;
    $J2_arme_degats = 0;
    $J2_arme_bonus = 0;
    $J2_arme_pds = 0;
    $J2_arme_fiabilite = "";
    $J2_arme_type = 'P';
    $sql = "SELECT * FROM darkcity_arme WHERE arme_level <= ".$J2_level_TIR." ORDER BY arme_level DESC;";
    $logManager->message("action_tir_pnj : ".$sql);
    $armeList = $armeDao->listQuery(&$datasource, $sql);
    if (sizeof($armeList) > 0) {
      $arme = $armeList[$systemeDes->jeterN(1,sizeof($armeList))-1];
      $J2_idxArme = 0;
      $J2_arme = $arme->getArme_name();
      $J2_arme_precision = $arme->getArme_precision();
      $J2_arme_nombre = $arme->getArme_nombre();
      $J2_arme_degats = $arme->getArme_degats();
      $J2_arme_bonus = $arme->getArme_bonus();
      $J2_arme_pds = $arme->getArme_structure();
      $J2_arme_type = $arme->getArme_type();
      $J2_arme_fiabilite = $arme->getArme_fiabilite();
    }
    $J2_armure = "";
    $J2_armure_bonus = 0;
    $J2_armure_pds = 0;
    /*
    if ($J2_idxArmure > -1) {
      $armure = $armureDao->getObject(&$datasource, $J2_inventaire[$J2_idxArmure]->getInventaire_objid());
      $J2_armure = $arme->getArme_name();
      $J2_armure_bonus = $arme->getArme_precision();
      $J2_armure_pds = $J2_inventaire[$J2_idxArmure]->getInventaire_structure();
    }
    */
    $J2_bonus_TIR = 0;
    $J2_bonus_PHY = 0;
 
    $logManager->message("action_tir_pnj : Texte d'intro");
    $texte="Un combat s'engage entre ".$user_name." et ".$pnj->getName()."\n\n";
    $texte=$texte."$user_name :\n";
    $texte=$texte."* Niveau de tir 1D".($J1_level_TIR+5)."+".($J1_arme_precision+$J1_bonus_TIR).".\n";
    $texte=$texte."* Niveau de physique 1D".($J1_level_PHY+5)."+".($J1_armure_bonus+$J1_bonus_PHY).".\n";
    $texte=$texte."* Il se bat avec ".$J1_arme." infligeant ".$J1_arme_nombre."D".$J1_arme_degats."+".$J1_arme_bonus." de dgts.\n";
    if ($J1_armure != "") {
      $texte=$texte."* Il porte galement ".$J1_armure." pour se protger.\n";
    }
    $texte=$texte."\n".$pnj->getName()." :\n";
    $texte=$texte."* Niveau de tir 1D".($J2_level_TIR+5)."+".($J2_arme_precision+$J2_bonus_TIR).".\n";
    $texte=$texte."* Niveau de physique 1D".($J2_level_PHY+5)."+".($J2_armure_bonus+$J2_bonus_PHY).".\n";
    $texte=$texte."* Il se bat avec ".$J2_arme." infligeant ".$J2_arme_nombre."D".$J2_arme_degats."+".$J2_arme_bonus." de dgts.\n";
    if ($J2_armure != "") {
      $texte=$texte."* Il porte galement ".$J2_armure." pour se protger.\n";
    }

    $J1_xp_TIR = 0;
    $J1_xp_PHY = 0;
    $J2_xp_TIR = 0;
    $J2_xp_PHY = 0;
    $J1_total_degats = 0;
    $J2_total_degats = 0;
    $round = 1;
    $continu_combat = $TRUE;

    // Le combat
    $abandon = "";
    while ($continu_combat) {  
      $logManager->message("action_tir_pnj : Round ".$round);
      $texte=$texte."\nRound ".$round." :\n";
      if ($J1_arme_pds >0) {
        $texte=$texte.$user_name." tire avec ".$J1_arme.", ";
        $attaqueJ1 = $systemeDes->jeterOpposition($J1_level_TIR, $J1_arme_precision+$J1_bonus_TIR, 0, $J2_level_PHY, $J2_armure_bonus+$J2_bonus_PHY, 0);
        $logManager->message("action_tir_pnj : ".$user_name.($attaqueJ1 > 0 ? " touche." : " rate")); 
        if ($attaqueJ1 > 0) {
          $degats = $systemeDes->jeterN($J1_arme_nombre, $J1_arme_degats) +  $J1_arme_bonus;
          $texte=$texte."il touche ".$adv_name." et lui inflige ".$degats." points de dgats.";
          $J2_vie -= $degats;
          $J1_total_degats += $degats;  
          $J1_xp_TIR += $systemeDes->calculeXP($attaqueJ1, $J1_level_TIR, $J2_level_PHY);
          $continu_combat = ($J2_vie >= 25);
          if ($J2_armure != "" && $J2_armure_pds > 0) {
            $J2_armure_pds -= 1;
            if ($J2_armure_pds <= 0) {
              $J2_armure_pds = 0;
              $J2_armure_bonus = 0;
              $texte=$texte." ".$J2_armure." de ".$adv_name." se casse et devient inefficace.";        
            }
          }
          if (!$continu_combat) {
            $abandon = "J2";
            if ($J2_vie < 1) $J2_vie = 1;
            $texte=$texte."\n".$adv_name." tombe vanouie, le combat est termin.";        
          }
        }
        else if ($J1_arme_type == 'FU' && abs($attaqueJ1) < round($J1_level_TIR/10)) {
          $degats = round(($systemeDes->jeterN($J1_arme_nombre, $J1_arme_degats) +  $J1_arme_bonus)/2);
          $texte=$texte."il rate ".$adv_name.", mais celui-ci est pris dans la gerbe de plombs, ce qui lui inflige ".$degats." points de dgats.";
          $J2_vie -= $degats;
          $J1_total_degats += $degats;  
          $continu_combat = ($J2_vie >= 25);
          if ($J2_armure != "" && $J2_armure_pds > 0) {
            $J2_armure_pds -= 1;
            if ($J2_armure_pds <= 0) {
              $J2_armure_pds = 0;
              $J2_armure_bonus = 0;
              $texte=$texte." ".$J2_armure." de ".$adv_name." se casse et devient inefficace.";        
            }
          }
          if (!$continu_combat) {
            $abandon = "J2";
            if ($J2_vie < 1) $J2_vie = 1;
            $texte=$texte."\n".$adv_name." tombe vanouie, le combat est termin.";        
          }
        }
        else {
          $texte=$texte."il rate ".$adv_name.".";
          $J2_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ1), $J2_level_PHY, $J1_level_TIR);
          if ($J1_arme != "" && $J1_arme_pds > 0) {
            if ($systemeDes->jeterN(1,($J1_arme_fiabilite == "F" ? 2 : ($J1_arme_fiabilite == "S" ? 4 : 6))) == 1) {
              $dg = $systemeDes->jeterN(1, 6);
              $texte=$texte." ".$J1_arme." de ".$user_name." s'enraye et perd $dg points de structure.";        
      	      $J1_arme_pds -= $dg;
              if ($J1_arme_pds <= 0) {
                $J1_arme_pds = 0;
                $J1_arme_precision = 0;
                $texte=$texte." ".$J1_arme." de ".$user_name." se casse et devient inefficace.";        
              }
            }
          }
        }
      }
      else {
        $texte=$texte.$user_name." ne peut tirer avec ".$J1_arme.", son arme est dtruite.";
      }  
    
      if ($continu_combat) {
        if ($J2_arme_pds >0) {
          $texte=$texte."\n".$adv_name." tire avec ".$J2_arme.", ";
          $attaqueJ2 = $systemeDes->jeterOpposition($J2_level_TIR, $J2_arme_precision+$J2_bonus_TIR, 0, $J1_level_PHY, $J1_armure_bonus+$J1_bonus_PHY, 0);
          $logManager->message("action_tir_pnj : ".$adv_name.($attaqueJ2 > 0 ? " touche." : " rate")); 
          if ($attaqueJ2 > 0) {
            $degats = $systemeDes->jeterN($J2_arme_nombre, $J2_arme_degats) +  $J2_arme_bonus;
            $texte=$texte."il touche ".$user_name." et lui inflige ".$degats." points de dgats.";
            $J1_vie -= $degats;
            $J2_total_degats += $degats;
            $J2_xp_TIR += $systemeDes->calculeXP($attaqueJ2, $J2_level_TIR, $J1_level_PHY);
            $continu_combat = ($J1_vie >= 25);
            if ($J1_armure != "" && $J1_armure_pds > 0) {
              $J1_armure_pds -= 1;
              if ($J1_armure_pds <= 0) {
                $J1_armure_pds = 0;
                $J1_armure_bonus = 0;
                $texte=$texte." ".$J1_armure." de ".$user_name." se casse et devient inefficace.";        
              }
            }
            if (!$continu_combat) {
              $abandon = "J1";
              if ($J1_vie < 1) $J1_vie = 1;
              $texte=$texte."\n".$user_name." tombe vanouie, le combat est termin.";        
            }
          }
          else if ($J2_arme_type == 'FU' && abs($attaqueJ2) < round($J2_level_TIR / 10)) {
            $degats = round(($systemeDes->jeterN($J2_arme_nombre, $J2_arme_degats) +  $J2_arme_bonus) / 2);
            $texte=$texte."il rate ".$user_name.", mais celui-ci est pris dans la gerbe de plombs, ce qui lui inflige ".$degats." points de dgats.";
            $J1_vie -= $degats;
            $J2_total_degats += $degats;
            $continu_combat = ($J1_vie >= 25);
            if ($J1_armure != "" && $J1_armure_pds > 0) {
              $J1_armure_pds -= 1;
              if ($J1_armure_pds <= 0) {
                $J1_armure_pds = 0;
                $J1_armure_bonus = 0;
                $texte=$texte." ".$J1_armure." de ".$user_name." se casse et devient inefficace.";        
              }
            }
            if (!$continu_combat) {
              $abandon = "J1";
              if ($J1_vie < 1) $J1_vie = 1;
              $texte=$texte."\n".$user_name." tombe vanouie, le combat est termin.";        
            }
          }
          else {
            $texte=$texte."il rate ".$user_name.".";
            $J1_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ2), $J1_level_PHY, $J2_level_TIR);
            if ($J2_arme != "" && $J2_arme_pds > 0) {
              if ($systemeDes->jeterN(1,($J2_arme_fiabilite == "F" ? 2 : ($J2_arme_fiabilite == "S" ? 4 : 6))) == 1) {
                $dg = $systemeDes->jeterN(1, 6);
                $texte=$texte." ".$J2_arme." de ".$adv_name." s'enraye et perd $dg points de structure.";        
                $J2_arme_pds -= $dg;
                if ($J2_arme_pds <= 0) {
                  $J2_arme_pds = 0;
                  $J2_arme_precision = 0;
                  $texte=$texte." ".$J2_arme." de ".$adv_name." se casse et devient inefficace.";        
                }
              }
            }
          }
        }  
        else {
          $texte=$texte.$adv_name." ne peut tirer avec ".$J2_arme.", son arme est dtruite.";
        }  
      }  
      $texte=$texte."\n";
      $continu_combat = ($continu_combat && $round < $NB_ROUNDS);
      $round++;
    }

    $logManager->message("action_tir_pnj : ".$sql);
    $texte=$texte."\nFin du combat :\n";
    $texte=$texte."Dgats infligs par ".$user_name." : ".$J1_total_degats."\n";
    $texte=$texte."Dgats infligs par ".$adv_name." : ".$J2_total_degats."\n";
    if ($J1_total_degats == $J2_total_degats && $abandon == "") {
      $texte=$texte."Egalit.\n";
      $gain = 0;
      $xp_reputation = $J2_level_TIR * $XP_MULTIPLIEUR;
    }
    else if (($J1_total_degats > $J2_total_degats && $abandon != "J1") || $abandon == "J2") {
      $texte=$texte."Vainqueur ".$user_name.".\n";
      $gain = 0;
      $gain =  50 + (round(($J2_level_BGR + $J2_level_TIR + $J2_level_PHY)/3) * 5);
      $J1_argent += $gain; 
      $xp_reputation = $J2_level_TIR * $XP_MULTIPLIEUR * 2;
    }
    else {
      $texte=$texte."Vainqueur ".$adv_name.".\n";
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J1_reputation)."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $xp_reputation = ($levelList[0]->getXptable_level() * $XP_MULTIPLIEUR);
      if (abs($J1_reputation) < $xp_reputation) $xp_reputation = $J1_reputation;
    }

    $logManager->message("action_tir_pnj : ".$sql);
    // Texte spcifique J1
    $texteJ1 = "\nVous gagnez ".$J1_xp_TIR." points d'expriences en Tir\n";
    $texteJ1 = $texteJ1."Vous gagnez ".$J1_xp_PHY." points d'expriences en Physique\n";
    if ($gain > 0) {
      if ($J1_reputation < 0) {
        $texteJ1 = $texteJ1."Vous faites les poches de votre victime et gagnez ".$gain."$\n";
      }
      else {
        $texteJ1 = $texteJ1."La police vous offre une prime pour avoir arrt ce bandit : ".$gain."$\n";
      }
    }
  if (($J1_total_degats < $J2_total_degats && $abandon != "J2") || $abandon == "J1") {
    $texteJ1 = $texteJ1."Votre dfaite fait diminuer votre ".($adv_name == "Policier" ? "Mauvaise" : "Bonne")." rputation de ".$xp_reputation." points.";
    $J1_reputation = ($adv_name == "Policier" ? $J1_reputation + $xp_reputation : $J1_reputation - $xp_reputation);
  }
  else if ($J1_total_degats > $J2_total_degats || $abandon == "J2") {
    $texteJ1 = $texteJ1."Votre victoire fait augmenter votre ".($adv_name == "Policier" ? "Mauvaise" : "Bonne")." rputation de ".$xp_reputation." points.";
    $J1_reputation = ($adv_name == "Policier" ? $J1_reputation - $xp_reputation : $J1_reputation + $xp_reputation);
  }
    else {
      $texteJ1 = $texteJ1."Cette galit n'affecte pas votre Rputation.";
    }
    // On sauvegarde les nouvelles comptences de J1
    $logManager->message("action_tir_pnj : ".$sql);
  // On met  jour la comptence
  $competence_cpyDao = new Darkcity_competence_cpyDao;
  $competence_cpy = new Darkcity_competence_cpy;
  $competence_cpy->setCompetence_user($J1_competence->getCompetence_user());
  $competence_cpy->setCompetence_TIR($J1_competence->getCompetence_TIR()+$J1_xp_TIR);
  $competence_cpy->setCompetence_BGR($J1_competence->getCompetence_BGR());
  $competence_cpy->setCompetence_PHY($J1_competence->getCompetence_PHY()+$J1_xp_PHY);
  $competence_cpy->setCompetence_REC($J1_competence->getCompetence_REC());
  $competence_cpy->setCompetence_SEC($J1_competence->getCompetence_SEC());
  $competence_cpy->setCompetence_RPR($J1_competence->getCompetence_RPR());
  $competence_cpy->setCompetence_PIL($J1_competence->getCompetence_PIL());
  $competence_cpy->setCompetence_MED($J1_competence->getCompetence_MED());
  $competence_cpy->setCompetence_PER($J1_competence->getCompetence_PER());
  $competence_cpy->setCompetence_REP($J1_reputation);
  $competence_cpy->setCompetence_VIE($J1_vie);
  $competence_cpy->setCompetence_ARG($J1_argent);
    $logManager->message("action_tir_pnj : ".$competence_cpy->toString());
  $competence_cpyDao->create(&$datasource, $competence_cpy);
/*  
    $J1_competence->setCompetence_TIR($J1_competence->getCompetence_TIR()+$J1_xp_TIR);
    $J1_competence->setCompetence_PHY($J1_competence->getCompetence_PHY()+$J1_xp_PHY);
    $J1_competence->setCompetence_VIE($J1_vie);
    $J1_competence->setCompetence_ARG($J1_argent);
    $J1_competence->setCompetence_REP($J1_reputation);
    $competenceDao->save(&$datasource, $J1_competence);
*/
    // On sauvegarde l'inventaire de J1
    $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
    if ($J1_idxArme > -1) {
      $objet = $J1_inventaire[$J1_idxArme];
      $objet_cpy = new Darkcity_inventaire_cpy;
      $objet_cpy->setInventaire_id($objet->getInventaire_id());
      $objet_cpy->setInventaire_cmpname($objet->getInventaire_cmpname());
      $objet_cpy->setInventaire_user($objet->getInventaire_user());
      $objet_cpy->setInventaire_objid($objet->getInventaire_objid());
      $objet_cpy->setInventaire_structure($J1_arme_pds);
      $objet_cpy->setInventaire_actif(($objet_cpy->getInventaire_structure() == 0 ? $FALSE : $TRUE));
      $inventaire_cpyDao->create(&$datasource, $objet_cpy);
    }
    if ($J1_idxArmure > -1) {
      $objet = $J1_inventaire[$J1_idxArmure];
      $objet_cpy = new Darkcity_inventaire_cpy;
      $objet_cpy->setInventaire_id($objet->getInventaire_id());
      $objet_cpy->setInventaire_cmpname($objet->getInventaire_cmpname());
      $objet_cpy->setInventaire_user($objet->getInventaire_user());
      $objet_cpy->setInventaire_objid($objet->getInventaire_objid());
      $objet_cpy->setInventaire_structure($J1_armure_pds);
      $objet_cpy->setInventaire_actif(($objet_cpy->getInventaire_structure() == 0 ? $FALSE : $TRUE));
      $inventaire_cpyDao->create(&$datasource, $objet_cpy);
    }
    // On sauvegarde l'occupation de J1
    //$J1_occupation->setOccupation_occupation("Vous tes occup dans les rues de DarkCity");
    $J1_occupation->setOccupation_rue($dateManager->getFutureDate($DELAI_RUE));
    $occupationDao->save(&$datasource, $J1_occupation);

    $messageManager->sendMessage('', $user_name, "Vous avez rencontr&eacute; un ".$adv_name.", il y a eu lutte.", htmlspecialchars($texte.$texteJ1, ENT_QUOTES), $dateManager->getCurrentDate());

    $logManager->message("action_tir_pnj : \n".$texte.$texteJ1); 
  }
  
  $logManager->message("action_tir_pnj : fin");
?>