 <?php 
/**
 * action_vendre_objet.php : partie mtier de vente d'un objet
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  
  $logManager->message("action_vendre_objet : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  
  
  // Rcupration des variables
  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $user_name = $sessionManager->load("user_name");
  
  // On rcupre les comptence (surtout l'argent)
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 
  
  // On rcupre l'objet dans l'inventaire
  $inventaireDao = new Darkcity_inventaireDao;
  $objet = $inventaireDao->getObject(&$datasource, $object_id); 
  
  if ($objet->getInventaire_actif()) {
    $infoManager->setMessage("Vous devez d&eacute;sactiver l'objet avant de le vendre.");
  }
  else {    
    $objet_name = ""; 
    $logManager->message($objet->getInventaire_cmpname());
    $objetDao = new Darkcity_objetDao;
    // Vehicules
    if ($objet->getInventaire_cmpname() == "PIL") {
      $vehiculeDao = new Darkcity_vehiculeDao; 
      $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $vehicule->getVehicule_name();      
      //Calcul du prix de vente d'une voiture
       if (($objet->getInventaire_structure() / $vehicule->getVehicule_structure()) >= 0.5) {
         $objet_prix = round($vehicule->getVehicule_prix() * 0.2);
       }
       if (($objet->getInventaire_structure() / $vehicule->getVehicule_structure()) >= 0.75) {
         $objet_prix = round($vehicule->getVehicule_prix() * 0.3);
       }
       if ($objet->getInventaire_structure() == $vehicule->getVehicule_structure()) {
         $objet_prix = round($vehicule->getVehicule_prix() * 0.5);
       }
    }
    
    // objet en tout genre
    if (($objet->getInventaire_cmpname() == "REC") or ($objet->getInventaire_cmpname() == "MED") or ($objet->getInventaire_cmpname() == "RPR") or ($objet->getInventaire_cmpname() == "PER") or ($objet->getInventaire_cmpname() == "SEC")) {
      $objet_bis = new Darkcity_objetDao;
      $objet_bis = $objetDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $objet_bis->getObjet_name();      
      //Calcul du prix de vente d'objet
       if ($objet->getInventaire_structure() == $objet_bis->getObjet_utilisations()) {
         $objet_prix = round($objet_bis->getObjet_prix() * 0.5);
       }
    }
    
    // Armes blanches
    if ($objet->getInventaire_cmpname() == "BGR") {
      $arme_blancheDao = new Darkcity_arme_blancheDao; 
      $arme_blanche = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $arme_blanche->getAblanche_name();      
      //Calcul du prix de vente d'une voiture
       if (($objet->getInventaire_structure() / $arme_blanche->getAblanche_structure()) >= 0.5) {
         $objet_prix = round($arme_blanche->getAblanche_prix() * 0.2);
       }
       if (($objet->getInventaire_structure() / $arme_blanche->getAblanche_structure()) >= 0.75) {
         $objet_prix = round($arme_blanche->getAblanche_prix() * 0.3);
       }
       if ($objet->getInventaire_structure() == $arme_blanche->getAblanche_structure()) {
         $objet_prix = round($arme_blanche->getAblanche_prix() * 0.5);
       }
    }

    // Armes de tir
    if ($objet->getInventaire_cmpname() == "TIR") {
      $armeDao = new Darkcity_armeDao; 
      $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $arme->getArme_name();      
      //Calcul du prix de vente d'une voiture
       if (($objet->getInventaire_structure() / $arme->getArme_structure()) >= 0.5) {
         $objet_prix = round($arme->getArme_prix() * 0.2);
       }
       if (($objet->getInventaire_structure() / $arme->getArme_structure()) >= 0.75) {
         $objet_prix = round($arme->getArme_prix() * 0.3);
       }
       if ($objet->getInventaire_structure() == $arme->getArme_structure()) {
         $objet_prix = round($arme->getArme_prix() * 0.5);
       }
    }

    // Armure de protection
    if ($objet->getInventaire_cmpname() == "PHY") {
      $armureDao = new Darkcity_armureDao; 
      $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $armure->getArmure_name();      
      //Calcul du prix de vente d'une voiture
       if (($objet->getInventaire_structure() / $armure->getArmure_structure()) >= 0.5) {
         $objet_prix = round($armure->getArmure_prix() * 0.2);
       }
       if (($objet->getInventaire_structure() / $armure->getArmure_structure()) >= 0.75) {
         $objet_prix = round($armure->getArmure_prix() * 0.3);
       }
       if ($objet->getInventaire_structure() == $armure->getArmure_structure()) {
         $objet_prix = round($armure->getArmure_prix() * 0.5);
       }
    }
    
    $logManager->message("action_vendre_objet : mise a jour");
    //Delete de l'objet dans l'inventaire
    $inventaireDao->delete(&$datasource, $objet);
    
    //mise a jour du portefeuille
    $competence->setCompetence_ARG($competence->getCompetence_ARG() + $objet_prix);
    $competenceDao->save(&$datasource, $competence);
   
    // On envoie un message au joueur
    $title = htmlspecialchars("Vous avez vendu ", ENT_QUOTES).$objet_name." pour la somme de ".$objet_prix.htmlspecialchars(" $.", ENT_QUOTES);
    $content = htmlspecialchars('Vous avez dcid de vendre votre ',ENT_QUOTES).$objet_name.htmlspecialchars(', grace  cela vous gagnez ', ENT_QUOTES).$objet_prix." $.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());

  }
   
  $logManager->message("action_vendre_objet : fin");
   
?>