 <?php 
/**
 * active_objet.php : partie mtier d'activation d'un objet
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */  
  $logManager->message("active_objet : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");

  // Rcupration des variables
  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $armeDao = new Darkcity_armeDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;

  // on rcupre les competence du joueur
  $competence = $competenceDao->getObject(&$datasource, $user_name);
  
  // On rcupre l'objet dans l'inventaire
  $inventaireDao = new Darkcity_inventaireDao;
  $objet = $inventaireDao->getObject(&$datasource, $object_id); 
  $logManager->message("active_objet : objet rcupr");
  // On vrifie que l'on a le niveu requis
  $levelRequis = 1;
  $levelJ1 = 1;
  // Arme
  if ($objet->getInventaire_cmpname() == "TIR") {
    $obj = $armeDao->getObject(&$datasource, $objet->getInventaire_objid());
    $levelRequis = $obj->getArme_level();
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_TIR()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $levelJ1 = $levelList[0]->getXptable_level();
  }
  // Arme blanche
  else if ($objet->getInventaire_cmpname() == "BGR") {
    $obj = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid());
    $levelRequis = $obj->getAblanche_level();
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $levelJ1 = $levelList[0]->getXptable_level();
  }
  // Armure 
  else if ($objet->getInventaire_cmpname() == "PHY") {
    $obj = $armureDao->getObject(&$datasource, $objet->getInventaire_objid());
    $levelRequis = $obj->getArmure_level();
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $levelJ1 = $levelList[0]->getXptable_level();
  }
  // Vehicule 
  else if ($objet->getInventaire_cmpname() == "PIL") {
    $obj = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid());
    $levelRequis = $obj->getVehicule_level();
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PIL()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $levelJ1 = $levelList[0]->getXptable_level();
  }
  // Objet Divers
  else {
    $obj = $objetDao->getObject(&$datasource, $objet->getInventaire_objid());
    $levelRequis = $obj->getObjet_level();
    if ($objet->getInventaire_cmpname() == "REC") $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_REC()."' ORDER BY xptable_level DESC;";
    else if ($objet->getInventaire_cmpname() == "SEC") $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_SEC()."' ORDER BY xptable_level DESC;";
    else if ($objet->getInventaire_cmpname() == "MED") $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_MED()."' ORDER BY xptable_level DESC;";
    else if ($objet->getInventaire_cmpname() == "RPR") $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_RPR()."' ORDER BY xptable_level DESC;";
    else if ($objet->getInventaire_cmpname() == "PER") $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $levelJ1 = $levelList[0]->getXptable_level();
  }
  $continuer = $TRUE;
  if ($levelJ1 < $levelRequis) {
    $infoManager->setMessage("Vous n&#39avez pas le niveau requis (".$levelRequis.") pour activer cet objet.");
    $continuer = $FALSE;
  }
  
  if ($continuer) {
    // On desactive tous les objets du meme type
    $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = '".$objet->getInventaire_cmpname()."' AND inventaire_actif = '1';";
    $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 
    $logManager->message("active_objet : liste rcupr");
    for ($i = 0; $i < sizeof($inventaireList); $i++) {
      $objTemp = $inventaireList[$i];
      $objTemp->setInventaire_actif($FALSE);
      $inventaireDao->save(&$datasource, $objTemp);
    }    	
    $logManager->message("active_objet : liste desactivee");

    // On active l'objet
    $objet->setInventaire_actif($TRUE);
    $logManager->message("active_objet : objet active");
    $inventaireDao->save(&$datasource, $objet);
    $logManager->message("active_objet : objet active");

    $objet_name = ""; 
    $logManager->message($objet->getInventaire_cmpname());
  
    // Armes  feux
    if ($objet->getInventaire_cmpname() == "TIR") {
      $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $arme->getArme_name();
    }
    // Armes blanches
    else if ($objet->getInventaire_cmpname() == "BGR") {
      $arme = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $arme->getAblanche_name();
    }
    // Armures
    else if ($objet->getInventaire_cmpname() == "PHY") {
      $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $armure->getArmure_name();
    }
    // Vehicules
    else if ($objet->getInventaire_cmpname() == "PIL") {
      $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $vehicule->getVehicule_name();
    }
    // Divers
    else {
      $obj = $objetDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $objet_name = $obj->getObjet_name();
    }
    $logManager->message("active_objet : nom recupere");

    $infoManager->setMessage("Vous avez activ&eacute; ".$objet_name.".");
  }  
  $logManager->message("active_objet : fin");
?>