<?php
/**
 * activer.php : partie mtier d'activation du compte
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("connecter : debut");

  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_activateDao.php");
  include_once("dao/objets/Darkcity_activate.php");

  // Une action est elle demande
  $key = (isset($_GET["key"])?$_GET["key"]:"");
  
  $activateDao = new Darkcity_activateDao;
  $userDao = new Darkcity_userDao;

  $activate = $activateDao->getObject(&$datasource, $key);
   
   if ($activate->getActivate_user() == "") {
     $errorManager->setMessage("Compte inexistant ou dja activ");
     $continuer=$FALSE;
   }
   else {
     $nom = $activate->getActivate_user();
     $joueur = $userDao->getObject(&$datasource, $nom);
     $joueur->setUser_actif($TRUE);
     $userDao->save(&$datasource, $joueur);
     $activateDao->delete(&$datasource, $activate);
     // On connecte le user
     $userManager->forceConnect($sessionManager);
     $sessionManager->save("user_name", $nom);
     $continuer=$TRUE;
     $message = "DarkCity est une ville des annes 2020, o la criminalit est un vrai problme, les forces de police sont dbordes et donc inefficaces, elles dcident ainsi de faire appel  des chasseurs de primes comme dans le Far West de l'poque afin de faire baisser la criminalit. De l'autre cot, la mafia s'organise et lance  son tour des contrats sur les ttes de ces nouveaux justiciers.\n\n".
                "Vous, vous dbarquez juste dans cette ville chaotique,  vous de choisir quel cot vous allez servir. La Justice ou la Criminalit...\n\n".
                "La Gestion du personnage\n".
                "------------------------\n".
                "Votre personnage possde neuf comptences pour pouvoir se dbrouiller dans cette ville :\n".
                "* TIR : Comptence reprsentant votre matrise des armes  feux lors d'un combat, pour utiliser cette comptence vous devez avoir une arme  feu.\n".
                "* BAGARRE : Comptence reprsentant votre matrise du combat au corps  corps\n".
                "* PHYSIQUE : Comptence reprsentant votre condition physique, plus elle est leve et plus vous tes difficile  toucher en combat.\n.".
                "* POURSUITE : Comptence reprsentant votre matrise de conduite des vhicules, utile lorsque vous faites des courses poursuites, pour enclencher des courses poursuites, vous devez avoir un Vhicule.\n".
                "* RECHERCHE : Comptence reprsentant votre niveau d'enquteur, plus vous serez fort dans celle-ci plus vous aurez de chance de trouver votre cible lors de vos missions pour la Police ou la Mafia.\n".
                "* SECURITE : Comptence indiquant votre capacit  djouer les systmes de scurit, utile notamment pour attaquer une personne non connecte (dans ce cas-l, elle se trouve dans sa planque et il faut l'en dloger).\n".
                "* REPARTION : Comptence indiquant votre capacit  rparer vos armes ou vhicules, car ceux-ci s'usent. Pour utiliser cette comptence vous devez avoir une trousse  outil\n".
                "* MEDECINE : Cette comptence vous permet de vous appliquer vous-mme des soins sans pour autant aller  l'Hpital, vous devez cependant avoir une trousse de premiers soins.\n".
                "* PERSUASION : Cette comptence indique votre niveau empathique, utile notamment pour le marchandage.\n\n".
                "La ville\n".
                "--------\n".
                "DarkCity est une grande ville, vous trouverez donc un certain nombre de lieux intressants...\n".
                "* L'Hpital : C'est l'endroit o vous devez aller pour recevoir des soins si vous n'arrivez pas  vous soigner vous-mme, vous recevrez des soins contre de l'argent. Cela peut vous remettre d'aplomb si vous n'tes pas bon en mdecine.\n".
                "* Le Bar : C'est un endroit o on peut boire un verre pour obtenir des informations sur la ville, C'est l'endroit aussi o vous pourrez chercher la bagarre avec d'autres personnages.\n".
                "* L'Armurier : C'est ici que vous pourrez acheter ou vendre des armes et armures, vous pourrez galement faire rparer celles-ci.\n".
                "* Le Concessionnaire : C'est ici que vous pourrez acheter ou vendre un vhicule, vous pourrez galement faire rparer celui-ci.\n".
                "* Le Magasin : Vous pourrez ici trouver tous les autres objets, dont vous pourrez avoir besoin. Par exemple un ordinateur pour vous aider dans vos recherches, ou une trousse  outil pour rparer vos armes ou vhicules.\n".
                "* La Zone d'Affaires : Si vous cherchez du boulot c'est ici qu'il faut vous rendre, on peut si l'on considre que vous vallez le coup vous proposer un boulot adapt  l'une de vos comptences, vous choisissez alors le nombre d'heures que vous voulez travailler et vous gagnerez de l'exprience et un salaire.\n".
                "* Le Centre de Loisirs : Ici vous pouvez venir vous entrainer en Tir, Bagarre, ou amliorer votre condition Physique, bien entendu ce n'est pas gratuit, mais il faut savoir ce que l'on veut, progresser ou pas.\n".
                "* Le Poste de Police : Si vous dsirez partir  la chasse au criminel, c'est le point de dpart  privilgier. C'est ici que se trouvent les avis de recherches. Chaque mission propose est bien entendu paye, si vous la russissez\n".
                "* Le QG de la Mafia : C'est ici que se trouvent les contrats sur le honntes gens, si vous voulez progresser au sein des criminels, le meilleur moyen est d'honorer les contrats proposs, en plus de votre prime pour le contrat, vous pourrez galement faire les poches de votre victime.\n".
                "* La Rue : Dans la rue vous pourrez faire diverses rencontres, que ce soit des PNJ qui vont vous entrainer dans des mini aventures, ou qui vont engager un combat avec vous. Vous pouvez galement rencontrer par hasard d'autres joueurs. C'est dans la rue qu'on se forge une rputation et qu'on apprend  survivre.\n\n".
                "L'quipe de DarkCity vous souhaite de passer un agrable moment avec ce jeu...";
      $messageManager->sendMessage('', $nom, "Bienvenue dans la ville de DarkCity", htmlspecialchars($message, ENT_QUOTES), $dateManager->getCurrentDate());
   }
  $logManager->message("connecter : fin");
?>