<?php
/**
 * change_quartier.php : partie mtier de changement de quartier
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("aug_confort : debut");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_quartierDao.php");
  include_once("dao/objets/Darkcity_quartier.php");

  $currentDate = $dateManager->getCurrentDate(); 
  $quartier_id = (isset($_POST["quartier"])?$_POST["quartier"]:"");
  $logManager->message("quartier : ".$quartier_id);

  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $occupationDao = new Darkcity_occupationDao;
  $planqueDao = new Darkcity_planqueDao;
  $quartierDao = new Darkcity_quartierDao;

  // On rcupre la comptence scurit
  $logManager->message("On rcupre l'argent");
  $competence = $competenceDao->getObject(&$datasource, $user_name);
 
  // Les infos de la planque
  $logManager->message("Les infos de la planque");
  $planque = $planqueDao->getObject(&$datasource, $user_name);

  $OK = $FALSE;
  // On verifie qu'il a assez
  $somme = $quartier_id*1000;
  if ($competence->getCompetence_ARG() >= $somme) {
    $competence->setCompetence_ARG($competence->getCompetence_ARG() - $somme);
    $competenceDao->save(&$datasource, $competence);
    $planque->setPlanque_quartier($quartier_id);
    $planqueDao->save(&$datasource, $planque);
    $title = htmlspecialchars("Vous avez chang de quartier", ENT_QUOTES);
    $quartier = $quartierDao->getObject(&$datasource, $quartier_id);
    $content = htmlspecialchars('Vous dcidez de dmnager dans le quartier : ',ENT_QUOTES).$quartier->getQuartier_titre().htmlspecialchars(', pour cela vous dpensez ', ENT_QUOTES).$somme." $.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $OK = $TRUE;
  }
  else {
    $infoManager->setMessage("Vous n'avez pas assez d'argent pour dmnager.");
  }
  
  $logManager->message("init_planque : fin");
  

?>