 <?php 
/**
 * desactive_objt.php : partie mtier de dsactivation d'un objet
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */  
  $logManager->message("active_objet : debut");
  
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");

  // Rcupration des variables
  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $user_name = $sessionManager->load("user_name");

  // On rcupre l'objet dans l'inventaire
  $inventaireDao = new Darkcity_inventaireDao;
  $objet = $inventaireDao->getObject(&$datasource, $object_id); 
  $logManager->message("active_objet : objet rcupr");
  
  // On desactive l'objet
  $objet->setInventaire_actif($FALSE);
  $inventaireDao->save(&$datasource, $objet);
  $logManager->message("active_objet : objet active");

  $objet_name = ""; 
  $texte2="";
  $logManager->message($objet->getInventaire_cmpname());
  $armeDao = new Darkcity_armeDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;
  
  // Armes  feux
  if ($objet->getInventaire_cmpname() == "TIR") {
    $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $objet_name = $arme->getArme_name();
    $planqueDao = new Darkcity_planqueDao;
    $planque = $planqueDao->getObject(&$datasource, $user_name);
    if ($planque->getPlanque_combat() == "TIR") {
      $planque->setPlanque_combat("BGR");
      $planqueDao->save(&$datasource, $planque);
      $texte2 = "<br/>Votre style de combat passe  Bagarre.";
    }
  }
  // Armes blanches
  else if ($objet->getInventaire_cmpname() == "BGR") {
    $arme = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $objet_name = $arme->getAblanche_name();
  }
  // Armures
  else if ($objet->getInventaire_cmpname() == "PHY") {
    $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $objet_name = $armure->getArmure_name();
  }
  // Vehicules
  else if ($objet->getInventaire_cmpname() == "PIL") {
    $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $objet_name = $vehicule->getVehicule_name();
    $planqueDao = new Darkcity_planqueDao;
    $planque = $planqueDao->getObject(&$datasource, $user_name);
    if ($planque->getPlanque_attitude() == "FUITE") {
      $planque->setPlanque_attitude("COMBAT");
      $planqueDao->save(&$datasource, $planque);
      $texte2 = "<br/>Votre attitude passe  COMBAT.";
    }
  }
  // Divers
  else {
    $obj = $objetDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $objet_name = $obj->getObjet_name();
  }
  $logManager->message("active_objet : nom recupere");

  $infoManager->setMessage("Vous avez d&eacute;sactiv&eacute; ".$objet_name.".".$texte2);
  
  $logManager->message("active_objet : fin");
?>