<?php
/**
 * dim_securite.php : partie mtier de diminution de la scurit de la planque
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("aug_confort : debut");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_quartierDao.php");
  include_once("dao/objets/Darkcity_quartier.php");

  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $occupationDao = new Darkcity_occupationDao;
  $planqueDao = new Darkcity_planqueDao;
  $quartierDao = new Darkcity_quartierDao;

  // On rcupre la comptence scurit
  $logManager->message("On rcupre l'argent");
  $competence = $competenceDao->getObject(&$datasource, $user_name);
 
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_SEC()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $levelJ1 = $levelList[0]->getXptable_level();

  // Les infos de la planque
  $logManager->message("Les infos de la planque");
  $planque = $planqueDao->getObject(&$datasource, $user_name);

  $OK = $FALSE;
  $planque->setPlanque_securite($planque->getPlanque_securite()-1);
  $planqueDao->save(&$datasource, $planque);
  $title = htmlspecialchars("Vous avez diminu la scurit de votre appartement", ENT_QUOTES);
  $content = htmlspecialchars('Vous avez diminu la scurit de votre appartement.',ENT_QUOTES);
  $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
  $OK = $TRUE;
  
  $logManager->message("init_planque : fin");
  

?>