 <?php 
/**
 * fuir_combat_rue.php : partie de fuite d'un combat contre un pnj
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  
  $logManager->message("fuir_combat_rue : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");

  $user_name = $sessionManager->load("user_name");
  $adv = $sessionManager->load("adversaire");
  
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);
  
  $cmp = $competence->getCompetence_REP();
  
  $xptableDao = new Darkcity_xptableDao;
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($cmp)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $xp = ($levelList[0]->getXptable_level()) * 10;
  if (abs($cmp) < $xp) $xp = $cpm;
  
  $titre = htmlspecialchars("Vous fuyez devant votre adversaire, votre rputation diminue.", ENT_QUOTES);
  $texte = htmlspecialchars("Vous fuyez devant votre adversaire, votre ".($cmp < 0 ? "Mauvaise" : "Bonne"). " rputation diminue de ".$xp." points.", ENT_QUOTES);
  
  $competence_cpyDao = new Darkcity_competence_cpyDao;
  $competence_cpy = new Darkcity_competence_cpy;
  $competence_cpy->setCompetence_user($competence->getCompetence_user());
  
  $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR());
  $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR());
  $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY());
  $competence_cpy->setCompetence_REC($competence->getCompetence_REC());
  $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC());
  $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR());
  $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL());
  $competence_cpy->setCompetence_MED($competence->getCompetence_MED());
  $competence_cpy->setCompetence_PER($competence->getCompetence_PER());
  $competence_cpy->setCompetence_REP($cmp < 0 ? $cmp + $xp : $cmp - $xp);
  $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE());
  $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG());
  $competence_cpyDao->create(&$datasource, $competence_cpy);
  
  //$competence->setCompetence_REP($cmp < 0 ? $cmp + $xp : $cmp - $xp);
  //$competenceDao->save(&$datasource, $competence);

  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  $occupation->setOccupation_rue($dateManager->getFutureDate($DELAI_RUE));
//  $occupation->setOccupation_rue($dateManager->getFutureDate($DELAI_RUE));
  $occupationDao->save(&$datasource, $occupation);

  $messageManager->sendMessage('', $user_name, $titre, $texte, $dateManager->getCurrentDate());

  $logManager->message("fuir_combat_rue : fin");
?>