 <?php 
/**
 * init_armurier.php : partie mtier de l'armurier 
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_armurier : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/ArmurierDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $armurierDataBean = new armurierDataBean;
  
  $logManager->message("init_armurier : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $armurierDataBean->setName($joueur->getUser_name());
    
  $logManager->message("init_armurier : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= time()) {
    //$armurierDataBean->setMsgInfo("Vous n'&ecirc;tes actuellement pas occup&eacute;, vous vous reposez dans votre planque.");
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
  }
  else {
    $armurierDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $armurierDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  
  $logManager->message("init_armurier : rcupre competence");
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  
   
  // On recupre les levels 
  $xptableDao = new Darkcity_xptableDao;
  // TIR
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_TIR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_TIR = ($levelList[0]->getXptable_level());
  // BGR
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_BGR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_BGR = ($levelList[0]->getXptable_level());
  // PHY
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_PHY());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_PHY = ($levelList[0]->getXptable_level());
    
  // On rcupre les armes blanches *********************************************
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $sql = "SELECT * FROM darkcity_arme_blanche WHERE ablanche_level <= '".$lvl_BGR."' ORDER BY ablanche_level ASC, ablanche_prix ASC;";
  $armeList = $arme_blancheDao->listQuery(&$datasource, $sql); 
 
  $logManager->message("init_armurier : preparation liste couteau");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $objetDao = new Darkcity_objetDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "BGR");  
  for ($i = 0; $i < sizeof($armeList); $i++) {
    $arme = $armeList[$i];
    $logManager->message("init_armurier : boucle armeB n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($arme->getAblanche_key());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setName($arme->getAblanche_name());
    $inventaireDataBean->setDescription($arme->getAblanche_description());
    $inventaireDataBean->setImage($arme->getAblanche_image());
    $inventaireDataBean->setBonus($arme->getAblanche_precision());
    $degats = $arme->getAblanche_nombre().'D'.$arme->getAblanche_degats().($arme->getAblanche_bonus() > 0 ? '+'.$arme->getAblanche_bonus() : ($arme->getAblanche_bonus() < 0 ? $arme->getAblanche_bonus() : ''));
    $inventaireDataBean->setDegats($degats);
    $inventaireDataBean->setFiabilite($arme->getAblanche_fiabilite());      
    $inventaireDataBean->setPds($arme->getAblanche_structure());
    $inventaireDataBean->setPdsMax($arme->getAblanche_structure());
    $inventaireDataBean->setPrix($arme->getAblanche_prix());
    //mise a jour des infos
    $logManager->message("init_armurier : maj liste");
    $armurierDataBean->addCouteau($inventaireDataBean);
  } 

  // On rcupre les flingues *********************************************
  $armeDao = new Darkcity_armeDao;
  $sql = "SELECT * FROM darkcity_arme WHERE arme_level <= '".$lvl_TIR."' ORDER BY arme_level ASC, arme_prix ASC;";
  $armeList = $armeDao->listQuery(&$datasource, $sql); 
 
  $logManager->message("init_armurier : preparation liste flingue");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armeDao = new Darkcity_armeDao;
  $objetDao = new Darkcity_objetDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "TIR");  
  for ($i = 0; $i < sizeof($armeList); $i++) {
    $arme = $armeList[$i];
    $logManager->message("init_armurier : boucle flingue n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($arme->getArme_key());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setName($arme->getArme_name());
    $inventaireDataBean->setDescription($arme->getArme_description());
    $inventaireDataBean->setImage($arme->getArme_image());
    $inventaireDataBean->setBonus($arme->getArme_precision());
    $degats = $arme->getArme_nombre().'D'.$arme->getArme_degats().($arme->getArme_bonus() > 0 ? '+'.$arme->getArme_bonus() : ($arme->getArme_bonus() < 0 ? $arme->getArme_bonus() : ''));
    $inventaireDataBean->setDegats($degats);
    $inventaireDataBean->setFiabilite($arme->getArme_fiabilite());      
    $inventaireDataBean->setPds($arme->getArme_structure());
    $inventaireDataBean->setPdsMax($arme->getArme_structure());
    $inventaireDataBean->setPrix($arme->getArme_prix());
    //mise a jour des infos
    $logManager->message("init_armurier : maj liste");
    $armurierDataBean->addFlingue($inventaireDataBean);
  } 

  // On rcupre les armures *********************************************
  $armureDao = new Darkcity_armureDao;
  $sql = "SELECT * FROM darkcity_armure WHERE armure_level <= '".$lvl_PHY."' ORDER BY armure_level ASC, armure_prix ASC;";
  $armeList = $armeDao->listQuery(&$datasource, $sql); 
 
  $logManager->message("init_armurier : preparation liste armures");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armureDao = new Darkcity_armureDao;
  $objetDao = new Darkcity_objetDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "PHY");  
  for ($i = 0; $i < sizeof($armeList); $i++) {
    $armure = $armeList[$i];
    $logManager->message("init_armurier : boucle armure n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($armure->getArmure_key());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setName($armure->getArmure_name());
    $inventaireDataBean->setDescription($armure->getArmure_description());
    $inventaireDataBean->setImage($armure->getArmure_image());
    $inventaireDataBean->setBonus($armure->getArmure_bonus());
    $inventaireDataBean->setPdsMax($armure->getArmure_structure());
    $inventaireDataBean->setPrix($armure->getArmure_prix());
    //mise a jour des infos
    $logManager->message("init_armurier : maj liste");
    $armurierDataBean->addArmure($inventaireDataBean);
  } 
  
  
  // On rcupre l'inventeire pour les comptence BGR, TIR, PHY ****
  $inventaireDao = new Darkcity_inventaireDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'BGR' OR inventaire_cmpname = 'TIR' OR inventaire_cmpname = 'PHY') ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_inventaire : inventaire=".sizeof($inventaireList));
  $armeDao = new Darkcity_armeDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $objetDao = new Darkcity_objetDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  for ($i = 0; $i < sizeof($inventaireList); $i++) {
    $objet = $inventaireList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getInventaire_id());
    $inventaireDataBean->setPds($objet->getInventaire_structure());
    $inventaireDataBean->setActif($objet->getInventaire_actif());
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getInventaire_cmpname()); 
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    //Armes Blanche
    if ($objet->getInventaire_cmpname()== "BGR") {
      $arme_blancheDao = new Darkcity_arme_blancheDao;
      $arme = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($arme->getAblanche_name());
      $inventaireDataBean->setDescription($arme->getAblanche_description());
      $inventaireDataBean->setImage($arme->getAblanche_image());
      $inventaireDataBean->setBonus($arme->getAblanche_precision());
      $degats = $arme->getAblanche_nombre().'D'.$arme->getAblanche_degats().($arme->getAblanche_bonus() > 0 ? '+'.$arme->getAblanche_bonus() : ($arme->getAblanche_bonus() < 0 ? $arme->getAblanche_bonus() : ''));
      $inventaireDataBean->setDegats($degats);
      $inventaireDataBean->setFiabilite($arme->getAblanche_fiabilite());      
      $inventaireDataBean->setPdsMax($arme->getAblanche_structure());
      $inventaireDataBean->setPrix($arme->getAblanche_prix());
    } 
    //Flingues
    else if ($objet->getInventaire_cmpname()== "TIR") {
      $armeDao = new Darkcity_armeDao;
      $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($arme->getArme_name());
      $inventaireDataBean->setDescription($arme->getArme_description());
      $inventaireDataBean->setImage($arme->getArme_image());
      $inventaireDataBean->setBonus($arme->getArme_precision());
      $degats = $arme->getArme_nombre().'D'.$arme->getArme_degats().($arme->getArme_bonus() > 0 ? '+'.$arme->getArme_bonus() : ($arme->getArme_bonus() < 0 ? $arme->getArme_bonus() : ''));
      $inventaireDataBean->setDegats($degats);
      $inventaireDataBean->setFiabilite($arme->getArme_fiabilite());      
      $inventaireDataBean->setPdsMax($arme->getArme_structure());
      $inventaireDataBean->setPrix($arme->getArme_prix());
    }
    //Armures
    else if ($objet->getInventaire_cmpname()== "PHY") {
      $armureDao = new Darkcity_armureDao;
      $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($armure->getArmure_name());
      $inventaireDataBean->setDescription($armure->getArmure_description());
      $inventaireDataBean->setImage($armure->getArmure_image());
      $inventaireDataBean->setBonus($armure->getArmure_bonus());
      $inventaireDataBean->setPdsMax($armure->getArmure_structure());
      $inventaireDataBean->setPrix($armure->getArmure_prix());
    }
    //calcule cout de rparation 
    $Prix_repare = round($inventaireDataBean->getPrix() * 0.1);
    $inventaireDataBean->setPrix_repare($Prix_repare);
    //calcule prix de vente
    $Prix_vente = 0;
    if (($inventaireDataBean->getPds() / $inventaireDataBean->getPdsMax()) >= 0.5) {
       $Prix_vente = round($inventaireDataBean->getPrix() * 0.2);
    }
    if (($inventaireDataBean->getPds() / $inventaireDataBean->getPdsMax()) >= 0.75) {
      $Prix_vente = round($inventaireDataBean->getPrix() * 0.3);
    }
    if ($inventaireDataBean->getPds() == $inventaireDataBean->getPdsMax())  {
      $Prix_vente = round($inventaireDataBean->getPrix() * 0.5);
    }
    $inventaireDataBean->setPrix_vente($Prix_vente);
    //mise a jour du data bean
    $armurierDataBean->addInventaire($inventaireDataBean);
  }
  
  $logManager->message("init_armurier : fin");
?>