 <?php 
/**
 * init_combat_rue.php : partie mtier de selection de l'ennemie dans la rue
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("rechercheCombat : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/FicheAdversaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");

  $user_name = $sessionManager->load("user_name");
  
  $continuer = $TRUE;
 
  $occupationDao = new Darkcity_occupationDao;
  $xptableDao = new Darkcity_xptableDao;
  
  // On rcupre les comptences du joueur
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);

  $menuDataBean->desactiveTous();
  $menuDataBean->desactiveQuitter();
  $menuDataBean->setOccupe($FALSE);
  
  // Policier ou Bandit ?
  $choix = 0;
  if ($competence->getCompetence_REP() == 0) {
      $choix = $systemeDes->jeterN(1,2);
  }
  else if ($competence->getCompetence_REP() < 0) {
    $choix = 1;
  }
  else {
    $choix = 2;
  }
  
  $ficheAdvDataBean = new FicheAdversaireDataBean; 
  $ficheAdvDataBean->setName(($choix == 1 ? "Policier" : "Bandit"));
  $ficheAdvDataBean->setAvatar("events/".($choix == 1 ? "policier" : "bandit").".gif");

  // La comptence TIR
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_TIR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvlTir = $levelList[0]->getXptable_level();

  // La comptence BGR
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvlBgr = $levelList[0]->getXptable_level();

  // La comptence PHY
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvlPhy = $levelList[0]->getXptable_level();

  $lvlC = round(($lvlBgr+$lvlTir+$lvlPhy)/3);
  $lvlC2 = round($lvlC / 2);
  
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("TIR");
  $lvl = round($lvlPhy + $systemeDes->jeterN(1,round($lvlPhy/2)) - ($lvlPhy/4));
  if ($lvl<1) $lvl = 1;
  $comp->setLevel($lvl);
  $ficheAdvDataBean->addCompetence($comp);

  // La comptence BGR
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("BGR");
  $lvl = round($lvlPhy + $systemeDes->jeterN(1,round($lvlPhy/2)) - ($lvlPhy/4));
  if ($lvl<1) $lvl = 1;
  $comp->setLevel($lvl);
  $ficheAdvDataBean->addCompetence($comp);

  // La comptence PHY
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("PHY");
  $lvl = round(($lvlBgr + $lvlTir)/2 + $systemeDes->jeterN(1,round(($lvlBgr + $levelTir)/4)) - (($lvlBgr + $lvlTir)/8));
//  $lvl = round($lvlC + $systemeDes->jeterN(1,$lvlC) - $lvlC2);
  if ($lvl<1) $lvl = 1;
  $comp->setLevel($lvl);
  $ficheAdvDataBean->addCompetence($comp);  
  
  
  $logManager->message("recherche_rue : fin");
?>