 <?php 
/**
 * init_concessionnaire_envente.php : partie mtier du conscessionnaire (objets en vente)
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */  
  $logManager->message("init_concessionnaire : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/ConcessionnaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $concessionnaireDataBean = new concessionnaireDataBean;
  
  $logManager->message("init_concessionnaire : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $concessionnaireDataBean->setName($joueur->getUser_name());

  $logManager->message("init_concessionnaire : table occupation");
  // on rcupre son occupation
  $marchandage = $FALSE;
  $bonus = 0;
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= $dateManager->getCurrentDate()) {
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
    $logManager->message("Date actuelle: ".$dateManager->getCurrentDate());  
    $logManager->message("Date marchand: ".$occupation->getOccupation_marchandage());  
    if ($occupation->getOccupation_marchandage() <= $dateManager->getCurrentDate()) {
      $marchandage = $TRUE;
     // On rcupre les bonus en PERsuasion
     $logManager->message("Recherche Bonus");
     $inventaireDao = new Darkcity_inventaireDao;
     $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
     $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 
     $logManager->message("Bonus trouv ? ".sizeof($inventaireList));
     if (sizeof($inventaireList) > 0) {
       $objetDao = new Darkcity_objetDao;
       $obj = $objetDao->getObject(&$datasource, $inventaireList[0]->getInventaire_objid());
       $bonus = $obj->getObjet_bonus();
     }
    }
  }
  else {
    $concessionnaireDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $concessionnaireDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  $logManager->message("marchandage : ".$marchandage);
  $logManager->message("Bonus= ".$bonus);
  
  $logManager->message("init_concessionnaire : table competence");
  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $user_name); 
    if ($competence_cpy->getCompetence_PIL() != "" && $competence_cpy->getCompetence_PIL() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  

  //on stocke le niveau d argent
  $concessionnaireDataBean->setPortefeuille($competence->getCompetence_ARG());

  // On recupre le level 
  $xptableDao = new Darkcity_xptableDao;
  // PIL
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("PIL");  
  $comp->setXp($competence->getCompetence_PIL());
  $logManager->message("init_concessionnaire : XP pilotage ".$comp->getXP().".");
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $logManager->message("init_concessionnaire : level pilotage ".$levelList[0]->getXptable_level());
  
  // On rcupre les vhicules en ventes *********************************************
  $vehiculeDao = new Darkcity_vehiculeDao;
  $sql = "SELECT * FROM darkcity_vehicule WHERE vehicule_level <= '".$levelList[0]->getXptable_level()."' ORDER BY vehicule_level ASC, vehicule_prix ASC;";
  $vehiculeList = $vehiculeDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_concessionnaire : preparation liste vente");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "PIL");
  $xp = 0;

  $lvl_PER = 1;
  if ($marchandage == $TRUE) {
    //Rcupration du level d'XP
    $xptableDao = new Darkcity_xptableDao;
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $lvl_PER = $levelList[0]->getXptable_level();
    $resultat_user = $systemeDes->jeter($lvl_PER, $bonus, 0);
  }

  $xp = 0;
  for ($i = 0; $i < sizeof($vehiculeList); $i++) {
    $vehicule = $vehiculeList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($vehicule->getVehicule_key());
    $inventaireDataBean->setPds($vehicule->getVehicule_structure());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setName($vehicule->getVehicule_name());
    $inventaireDataBean->setDescription($vehicule->getVehicule_description());
    $inventaireDataBean->setImage($vehicule->getVehicule_image());
    $inventaireDataBean->setBonus($vehicule->getVehicule_bonus());
    $inventaireDataBean->setAcceleration($vehicule->getVehicule_acceleration());
    $inventaireDataBean->setPdsMax($vehicule->getVehicule_structure());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setPrix($vehicule->getVehicule_prix());
    $Prix_achat = ($vehicule->getVehicule_prix());        
    // calcule marchandage
    $xp_tmp = 0;
    if ($marchandage == $TRUE) {
      $resultat = $resultat_user - $systemeDes->jeter($vehicule->getVehicule_level(), 0, 0);
      $logManager->message("init_concessionnaire : marchander - rsultat=".$resultat);
      if ($resultat > 0) {
        $Prix_achat = $vehicule->getVehicule_prix() - round($vehicule->getVehicule_prix() * 0.1);
        $xp_tmp = $systemeDes->calculeXP($resultat, $lvl_PER, $vehicule->getVehicule_level());
      }
      if ($xp_tmp > $xp) {
        $xp = $xp_tmp; 
      }
    }
    $inventaireDataBean->setPrix_achat($Prix_achat);
    //Mise a jour de la table mmoire
    $concessionnaireDataBean->addvehicule($inventaireDataBean);
  } 
  
  //Message + Sauvagerde nouvelle Xp 
  if ($xp > 0) {
    $title = htmlspecialchars("Vous reussissez  marchander les prix avec le concessionnaire", ENT_QUOTES);
    $content = htmlspecialchars("Vous reussissez  marchander les prix avec le concessionnaire\n\nVous gagnez ", ENT_QUOTES).$xp." points d&#39;exprience en Persuasion.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $infoManager->setMessage($title);
    //sauvegarde xp
    $competence->setCompetence_PER($competence->getCompetence_PER() + $xp);
    $competenceDao->save(&$datasource, $competence);  
    //Mise a jour de l'objet PER
    if (sizeof($inventaireList) > 0) {
       $logManager->message("action_marchandage : update inventaire");
       $inventaireList[0]->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
       if ($inventaireList[0]->getInventaire_structure() == 0) {
       	$inventaireList[0]->setInventaire_actif($FALSE);
       }
      $inventaireDao->save(&$datasource, $inventaireList[0]);
    }  
    //sauvegarde occupation
    $occupation->setOccupation_marchandage($dateManager->getFutureDate($DELAI_MARCHANDAGE));
    $occupation->setOccupation_occupation("marchandage");
    $logManager->message("init_concessionnaire_envente : update occupation => ".$occupation->toString());
    $occupationDao->save(&$datasource, $occupation);
  }
  

  $logManager->message("init_concessionnaire : fin");
?>