 <?php 
/**
 * init_fichePerso.php : mtier pour la fiche perso
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  
  $logManager->message("init_fichePerso : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armeDao.php");
  include_once("dao/objets/Darkcity_arme.php");
  $logManager->message("init_fichePerso : debut 2");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");
  include_once("dao/accesseurs/Darkcity_chatDao.php");
  include_once("dao/objets/Darkcity_chat.php");  
  include_once("dao/accesseurs/Darkcity_newsingameDao.php");
  $logManager->message("init_fichePerso : debut3");
  include_once("dao/objets/Darkcity_newsingame.php");
  include_once("databean/FichePersoDataBean.php");
  include_once("databean/MiniFicheDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $fichePersoDataBean = new FichePersoDataBean;
  $miniFicheDataBean = new MiniFicheDataBean;
  $inventaireDao = new Darkcity_inventaireDao;
  $armeDao = new Darkcity_armeDao;
  $arme_blancheDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;
  $bonusDao = new Darkcity_bonusDao;
  $chatDao = new Darkcity_chatDao;
  $newsingameDao = new Darkcity_newsingameDao;
  
  // Verification du dernier message systme non lu
  $logManager->message("init_fichePerso : SystemMessage");
  $msgSys = $messageManager->getLastSystemMessage();
  // Vrificationdu dernier message utilisateur
  $msgUsr = $messageManager->getLastUserNotReadMessage();
  
  if (sizeof($msgSys) != 0) {
    $infoManager->addMessage('<a class="message" href="'.$sessionManager->parseURL("controleur.php", "action=lire&amp;id_message=".$msgSys[0]."&amp;pageCourante=messages".'">')."&lt;Action&gt; ".$msgSys[1]." Pour plus d'information consultez vos messages.".'</a>');
//    "&lt;Action&gt; ".$msgSys." Pour plus di'nformations consultez vos messages.");	
  }
  if (sizeof($msgUsr) != 0) {
    $infoManager->addMessage('<a class="message_perso" href="'.$sessionManager->parseURL("controleur.php", "action=lire&amp;id_message=".$msgUsr[0]."&amp;pageCourante=messages".'">').$msgUsr[2]."&gt; ".$msgUsr[1].'</a>');
  }	  
  $logManager->message('size de mesgUsr '.sizeof($msgUsr));
  // Des Message non lus
  if ($messageManager->hasNotReadMessages()) {
    $infoManager->addMessage("Vous avez des messages non lus.");	
  }
  $logManager->message("init_fichePerso : NotReadMessage");
  
  $logManager->message("init_fichePerso : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $fichePersoDataBean->setName($joueur->getUser_name());
  $fichePersoDataBean->setAvatar($joueur->getUser_avatar());
  $fichePersoDataBean->setDescription($joueur->getUser_description());

  $logManager->message("init_fichePerso : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= time()) {
    $fichePersoDataBean->setMsgInfo("Vous n'&ecirc;tes actuellement pas occup&eacute;.");
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
  }
  else {
    $fichePersoDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $fichePersoDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }

  // Rcupration de la dernire news
  $sql = "SELECT * FROM darkcity_newsingame ORDER BY newsingame_date DESC;";
  $listMessages = $newsingameDao->listQuery(&$datasource, $sql);
  if (sizeof($listMessages) > 0) {
    $msg = $listMessages[0];
    $date = $dateManager->dateToString($msg->getNewsingame_date());
    $texte = $msg->getNewsingame_text();
    // on supprime les news si plus de 10
    if (sizeof($listMessages) > 10) {
      $msg = $listMessages[9];
      $dateh = $msg->getNewsingame_date();
      $sql = "DELETE FROM darkcity_newsingame WHERE newsingame_date < $dateh;";
      $newsingameDao->databaseUpdate(&$datasource, $sql);
    }
    $infoManager->addMessage($date."&gt; ".$texte);	    
  }
  
  // Rcupration du dernier message dans le tchat
  $sql = "SELECT * FROM darkcity_chat ORDER BY chat_date DESC;";
  $listMessages = $chatDao->listQuery(&$datasource, $sql);
  if (sizeof($listMessages) > 0) {
    $msg = $listMessages[0];
    $date = $dateManager->dateToString($msg->getChat_date());
    $user = $msg->getChat_user();
    $texte = $msg->getChat_text();
    if (strlen($texte)>80) {
      $texte = substr($texte, 0, 80).'...';
    }
    // on supprime les message de plus de 60 mins
    $dateh = $dateManager->getCurrentDate() - (60*$MINUTE);
    $sql = "DELETE FROM darkcity_chat WHERE chat_date < $dateh;";
    $chatDao->databaseUpdate(&$datasource, $sql);
    $infoManager->addMessage('<a class="message_tchat" href="'.$sessionManager->parseURL("controleur.php", "action=tchatter".$msgUsr[0]."&amp;pageCourante=messages".'">')."Sur le tchat ".$date." ".$user."&gt; ".$texte.'</a>');	    
  }
  
  
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  $logManager->message("init_fichePerso : table competence");
  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $user_name); 
    if ($competence_cpy->getCompetence_VIE() != "" && $competence_cpy->getCompetence_VIE() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_TIR($competence_cpy->getCompetence_TIR());
      $competence->setCompetence_BGR($competence_cpy->getCompetence_BGR());
      $competence->setCompetence_PHY($competence_cpy->getCompetence_PHY());
      $competence->setCompetence_REC($competence_cpy->getCompetence_REC());
      $competence->setCompetence_SEC($competence_cpy->getCompetence_SEC());
      $competence->setCompetence_RPR($competence_cpy->getCompetence_RPR());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competence->setCompetence_MED($competence_cpy->getCompetence_MED());
      $competence->setCompetence_PER($competence_cpy->getCompetence_PER());
      $competence->setCompetence_REP($competence_cpy->getCompetence_REP());
      $competence->setCompetence_VIE($competence_cpy->getCompetence_VIE());
      $competence->setCompetence_ARG($competence_cpy->getCompetence_ARG());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
  $logManager->message("init_fichePerso : table xp_table");
  // Pour chaque comptence on recupre le level et le xp_next
  $xptableDao = new Darkcity_xptableDao;
  
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 
  // On alimente le DataBean pour la VUE
  $fichePersoDataBean->setReputation($competence->getCompetence_REP());
  // On rcupre le niveau de rputation
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($competence->getCompetence_REP())."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $fichePersoDataBean->setReputationLvl($levelList[0]->getXptable_level());

  $fichePersoDataBean->setArgent($competence->getCompetence_ARG());
  $fichePersoDataBean->setSante($competence->getCompetence_VIE());
  
  $miniFicheDataBean->setReputation($competence->getCompetence_REP());
  $miniFicheDataBean->setArgent($competence->getCompetence_ARG());
  $miniFicheDataBean->setSante($competence->getCompetence_VIE());
  
  $logManager->message("init_fichePerso : table planque");
  // On rcupre la Planque
  $planqueDao = new Darkcity_planqueDao;
  $planque = $planqueDao->getObject(&$datasource, $user_name); 
  $cmpnameDao = new Darkcity_competence_nameDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, $planque->getPlanque_combat()); 
  // On alimente le DataBean pour la VUE
  $fichePersoDataBean->setCombat($cmpname->getCmpname_title());
  $fichePersoDataBean->setCarractere($planque->getPlanque_attitude());
   

  $logManager->message("init_fichePerso : liste des competences");
  // TIR
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("TIR");
  $comp->setXp($competence->getCompetence_TIR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'TIR' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $armeDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getArme_precision(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "TIR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // BGR
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("BGR");
  $comp->setXp($competence->getCompetence_BGR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'BGR' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $arme_blancheDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getAblanche_precision(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "BGR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // PHY
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("PHY");
  $comp->setXp($competence->getCompetence_PHY());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PHY' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $armureDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getArmure_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "PHY");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // REC
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("REC");
  $comp->setXp($competence->getCompetence_REC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'REC' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $objetDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getObjet_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "REC");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // SEC
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("SEC");
  $comp->setXp($competence->getCompetence_SEC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'SEC' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $objetDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getObjet_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "SEC");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // RPR
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("RPR");
  $comp->setXp($competence->getCompetence_RPR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'RPR' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $objetDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getObjet_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "RPR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // PIL
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("PIL");
  $comp->setXp($competence->getCompetence_PIL());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PIL' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $vehiculeDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getVehicule_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "PIL");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // MED
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("MED");
  $comp->setXp($competence->getCompetence_MED());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'MED' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $objetDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getObjet_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "MED");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  // On rajoute la planwque
  $J1_bonus += $planque->getPlanque_confort();
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  // PER
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("PER");
  $comp->setXp($competence->getCompetence_PER());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $fichePersoDataBean->addCompetence($comp);
  // A t'il un objet qui l'aide
  $J1_bonus = 0;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_objet = sizeof($J1_inventaire) > 0;
  if ($J1_objet) {
    $J1_objet = $J1_inventaire[0];
    $objet = $objetDao->getObject(&$datasource, $J1_objet->getInventaire_objid());
    $J1_bonus = $objet->getObjet_bonus(); 
  }
  // A t'il un bonus supplmentaire
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "PER");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$dateManager->getCurrentDate()) {
    $J1_bonus += $bonus->getBonus_bonus();
  }
  $comp->setBonus($J1_bonus);
  $miniFicheDataBean->addCompetence($comp);
  $logManager->message("init_fichePerso : fin liste des competences => ".$fichePersoDataBean->getNbCompetence());

  $logManager->message("init_fichePerso : table inventaire");
  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
    $sql = "SELECT * FROM darkcity_inventaire_cpy WHERE inventaire_user = '".$user_name."' ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
    $inventaire_cpyList = $inventaire_cpyDao->listQuery(&$datasource, $sql); 
    for ($i = 0; $i < sizeof($inventaire_cpyList); $i++) {
      $objet_cpy = $inventaire_cpyList[$i];
      $objet = new Darkcity_inventaire;
      $objet->setInventaire_id($objet_cpy->getInventaire_id());
      $objet->setInventaire_cmpname($objet_cpy->getInventaire_cmpname());
      $objet->setInventaire_user($objet_cpy->getInventaire_user());
      $objet->setInventaire_objid($objet_cpy->getInventaire_objid());
      $objet->setInventaire_structure($objet_cpy->getInventaire_structure());
      $objet->setInventaire_actif($objet_cpy->getInventaire_actif());
      $inventaireDao = new Darkcity_inventaireDao;  
      $objetTemp = $inventaireDao->getObject(&$datasource, $objet->getInventaire_id()); 
      if ($objetTemp->getInventaire_cmpname() == "") {
        $inventaireDao->create(&$datasource, $objet);
      } else {
        $inventaireDao->save(&$datasource, $objet);
      }
      $inventaire_cpyDao->delete(&$datasource, $objet_cpy);
    }
  }
  
  // On rcupre les comptences
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 


  $logManager->message("init_fichePerso : preparation inventaire");
  for ($i = 0; $i < sizeof($inventaireList); $i++) {
    $objet = $inventaireList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getInventaire_id());
    $inventaireDataBean->setPds($objet->getInventaire_structure());
    $inventaireDataBean->setActif($objet->getInventaire_actif());
    $inventaireDataBean->setCmp($objet->getInventaire_cmpname());
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getInventaire_cmpname()); 
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    // Armes  feux
    if ($objet->getInventaire_cmpname() == "TIR") {
      $arme = $armeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($arme->getArme_name());
      $inventaireDataBean->setDescription($arme->getArme_description());
      $inventaireDataBean->setImage($arme->getArme_image());
      $inventaireDataBean->setBonus($arme->getArme_precision());
      $degats = $arme->getArme_nombre().'D'.$arme->getArme_degats().($arme->getArme_bonus() > 0 ? '+'.$arme->getArme_bonus() : ($arme->getArme_bonus() < 0 ? $arme->getArme_bonus() : ''));
      $inventaireDataBean->setDegats($degats);
      $inventaireDataBean->setFiabilite($arme->getArme_fiabilite());      
      $inventaireDataBean->setPdsMax($arme->getArme_structure());
      $inventaireDataBean->setPrix($arme->getArme_prix());
    }
    // Armes blanches
    else if ($objet->getInventaire_cmpname() == "BGR") {
      $arme = $arme_blancheDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($arme->getAblanche_name());
      $inventaireDataBean->setDescription($arme->getAblanche_description());
      $inventaireDataBean->setImage($arme->getAblanche_image());
      $inventaireDataBean->setBonus($arme->getAblanche_precision());
      $degats = $arme->getAblanche_nombre().'D'.$arme->getAblanche_degats().($arme->getAblanche_bonus() > 0 ? '+'.$arme->getAblanche_bonus() : ($arme->getAblanche_bonus() < 0 ? $arme->getAblanche_bonus() : ''));
      $inventaireDataBean->setDegats($degats);
      $inventaireDataBean->setFiabilite($arme->getAblanche_fiabilite());      
      $inventaireDataBean->setPdsMax($arme->getAblanche_structure());
      $inventaireDataBean->setPrix($arme->getAblanche_prix());
    }
    // Armures
    else if ($objet->getInventaire_cmpname() == "PHY") {
      $logManager->message($objet->toString());
      $armure = $armureDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($armure->getArmure_name());
      $inventaireDataBean->setDescription($armure->getArmure_description());
      $inventaireDataBean->setImage($armure->getArmure_image());
      $inventaireDataBean->setBonus($armure->getArmure_bonus());
      $inventaireDataBean->setPdsMax($armure->getArmure_structure());
      $inventaireDataBean->setPrix($armure->getArmure_prix());
      $logManager->message($armure->toString());
    }
    // Vehicules
    else if ($objet->getInventaire_cmpname() == "PIL") {
      $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($vehicule->getVehicule_name());
      $inventaireDataBean->setDescription($vehicule->getVehicule_description());
      $inventaireDataBean->setImage($vehicule->getVehicule_image());
      $inventaireDataBean->setBonus($vehicule->getVehicule_bonus());
      $inventaireDataBean->setAcceleration($vehicule->getVehicule_acceleration());
      $inventaireDataBean->setPdsMax($vehicule->getVehicule_structure());
      $inventaireDataBean->setPrix($vehicule->getVehicule_prix());
    }
    // Divers
    else {
      $obj = $objetDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($obj->getObjet_name());
      $inventaireDataBean->setDescription($obj->getObjet_description());
      $inventaireDataBean->setImage($obj->getObjet_image());
      $inventaireDataBean->setBonus($obj->getObjet_bonus());
      $inventaireDataBean->setPrix($obj->getObjet_prix());
      $inventaireDataBean->setPdsMax($obj->getObjet_utilisations());
    }
    $fichePersoDataBean->addInventaire($inventaireDataBean);
  }
  $sessionManager->save("miniFiche",$miniFicheDataBean);
  
  $logManager->message("init_fichePerso : fin");
?>