<?php
/**
 * init_flanerRue.php : partie mtier de flaner dans la rue
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  $logManager->message("init_flanerRue : debut");

  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");

  $user_name = $sessionManager->load("user_name");

  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
 
  if ($occupation->getOccupation_rue() > $dateManager->getCurrentDate()) {
    $infoManager->setMessage("Vous avez dja dambul dans les rues, vous ne pourrez le refaire que ".$dateManager->dateToString($occupation->getOccupation_rue()));
    $continuer = $FALSE;
  }

  if ($continuer) {
    $event_rue = $systemeDes->jeterN(1,2);
    $menuDataBean->desactiveTous();
    $menuDataBean->desactiveQuitter();

    $occupation->setOccupation_rue($dateManager->getFutureDate($DELAI_RUE));
    $occupationDao->save(&$datasource, $occupation);
  }  
  
  $logManager->message("init_flanerRue : fin");
?>