 <?php 
/**
 * init_highscore.php : partie mtier des higscores
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  
  $logManager->message("init_highscore : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_sessionDao.php");
  include_once("dao/objets/Darkcity_session.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/HighscoreDataBean.php");
  include_once("databean/UserlistDataBean.php");
    
  $user_name = $sessionManager->load("user_name");
  $highscoreDataBean = new highscoreDataBean;
  
  $logManager->message("init_highscore : table user");  
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $highscoreDataBean->setName($joueur->getUser_name());

  // On rcupre toutes les session ouverte (Nb user conncet)
  $sessionDao = new Darkcity_sessionDao;
  $date = $dateManager->getPastDate(30*$MINUTE);
  $sql = "SELECT * FROM darkcity_session WHERE session_lastaction >= ".$date.";" ;
  $sessionlist = $sessionDao->listQuery(&$datasource, $sql);
  $highscoreDataBean->setNb_connectes(sizeof($sessionlist));
  $logManager->message("init_highsore : nb connects :".$highscoreDataBean->getNb_connectes());

  $userlistDataBean = new UserlistDataBean;
  for ($i = 0; $i < sizeof($sessionlist); $i++) {
    $sessionDao = $sessionlist[$i];
    $userlistDataBean = new UserlistDataBean;
    $userlistDataBean->setPosition($i+1);
    $userlistDataBean->setList_user($sessionDao->getSession_user());    
    $highscoreDataBean->addEnligne($userlistDataBean);
    }
     
  // On rcupre les judticiers *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 ORDER BY competence_REP DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  //nombre de user total
  $highscoreDataBean->setNb_users(sizeof($competenceList));

  // On rcupre les judticiers *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REP > 0 ORDER BY competence_REP DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste justicier");

  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setReputation("");
  $highscoreDataBean->setUser_justicier($userlistDataBean);
  
  //nombre total de justiciers
  $highscoreDataBean->setNb_justicier(sizeof($competenceList));

  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle justicier :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 10) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setReputation($competence->getCompetence_REP());
      $highscoreDataBean->addJusticier($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 9) and ($competence->getCompetence_user() == $joueur->getUser_name())) {
      if ($i > 10) {
        $userlistDataBean2 = new UserlistDataBean;  	
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setReputation($competenceList[$i-1]->getCompetence_REP());
        $highscoreDataBean->setUser_justicier_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setReputation($competence->getCompetence_REP());
      $highscoreDataBean->setUser_justicier($userlistDataBean);
    }
  } 

  // On rcupre les gangsters *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REP < 0 ORDER BY competence_REP ASC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste gangster");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setReputation("");
  $highscoreDataBean->setUser_gangster($userlistDataBean);

  //nombre total de gangster
  $highscoreDataBean->setNb_gangster(sizeof($competenceList));

  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle gangster :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 10) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setReputation($competence->getCompetence_REP());
      $highscoreDataBean->addGangster($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 9) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 10) {
        $userlistDataBean2 = new UserlistDataBean;  	
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setReputation($competenceList[$i-1]->getCompetence_REP());
        $highscoreDataBean->setUser_gangster_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setReputation($competence->getCompetence_REP());
      $highscoreDataBean->setUser_gangster($userlistDataBean);
    }
  } 
  
  $xptableDao = new Darkcity_xptableDao;
  
  // On rcupre les tirreurs *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_TIR >= 0 ORDER BY competence_TIR DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste tirreur");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_tir($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle tir :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXp($competence->getCompetence_TIR());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addTir($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $j = $i -1;
        $cmp = $competenceList[$j];
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($cmp->getCompetence_user());    
        $userlistDataBean2->setXp($cmp->getCompetence_TIR());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_tir_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXp($competence->getCompetence_TIR());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_tir($userlistDataBean);
    }
  } 

  // On rcupre les bagarreurs *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_BGR >= 0 ORDER BY competence_BGR DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste bagarre");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_bagarre($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle bagarre :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXp($competence->getCompetence_BGR());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addBagarre($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_BGR());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_bagarre_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXp($competence->getCompetence_BGR());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_bagarre($userlistDataBean);
    }
  } 

  // On rcupre les costauds *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_PHY >= 0 ORDER BY competence_PHY DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste costauds");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_physique($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle physique :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXP($competence->getCompetence_PHY());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addPhysique($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_PHY());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_physique_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXP($competence->getCompetence_PHY());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_physique($userlistDataBean);
    }
  } 

  // On rcupre les detectivess *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REC >= 0 ORDER BY competence_REC DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste detectives");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_recherche($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle recherche :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXp($competence->getCompetence_REC());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addRecherche($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_REC());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_recherche_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXp($competence->getCompetence_REC());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_recherche($userlistDataBean);
    }
  } 

  // On rcupre les serruriers *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_SEC >= 0 ORDER BY competence_SEC DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste serrurier");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_securite($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle securite :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXp($competence->getCompetence_SEC());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addSecurite($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_SEC());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_securite_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXp($competence->getCompetence_SEC());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_securite($userlistDataBean);
    }
  } 

  // On rcupre les rparateurs *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_RPR >= 0 ORDER BY competence_RPR DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste reparation");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_reparation($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle reparation :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXP($competence->getCompetence_RPR());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addReparation($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_RPR());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_reparation_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXP($competence->getCompetence_RPR());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_reparation($userlistDataBean);
    }
  } 
  
  // On rcupre les pilotes *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_PIL >= 0 ORDER BY competence_PIL DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste pilotes");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_pilotage($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle pilotes :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXP($competence->getCompetence_PIL());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addPilotage($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_PIL());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_pilotage_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXP($competence->getCompetence_PIL());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_pilotage($userlistDataBean);
    }
  } 
  
  // On rcupre les mdecins *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence  , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_MED >= 0 ORDER BY competence_MED DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste medecine");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_medecine($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle medecine :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXP($competence->getCompetence_MED());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addMedecine($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_MED());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_medecine_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXP($competence->getCompetence_MED());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_medecine($userlistDataBean);
    }
  }  
  
  // On rcupre les Persuasion *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_PER >= 0 ORDER BY competence_PER DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $logManager->message("init_highsore : liste persuasion");
  
  $userlistDataBean = new UserlistDataBean;
  $userlistDataBean->setPosition(0);
  $userlistDataBean->setList_user("");    
  $userlistDataBean->setXp("");
  $highscoreDataBean->setUser_persuasion($userlistDataBean);
 
  for ($i = 0; $i < sizeof($competenceList); $i++) {
    $competence = $competenceList[$i];
    $logManager->message("init_highsore : boucle persuasion :".$i);
    $userlistDataBean = new UserlistDataBean;
    if ($i < 5) {
      $userlistDataBean->setPosition($i+1);
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $logManager->message("init_highsore: Name".$userlistDataBean->getList_user());
      $userlistDataBean->setXP($competence->getCompetence_PER());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->addPersuasion($userlistDataBean);
    }
    // recherche position du user  
    if (($i > 4) and (($competence->getCompetence_user()) == ($joueur->getUser_name()))) {
      if ($i > 5) {
        $userlistDataBean2 = new UserlistDataBean;
        $userlistDataBean2->setPosition($i);
        $logManager->message("init_highsore: Position User".$userlistDataBean2->getPosition());
        $userlistDataBean2->setList_user($competenceList[$i-1]->getCompetence_user());    
        $userlistDataBean2->setXp($competenceList[$i-1]->getCompetence_PER());
        $comp = new CompetenceDataBean;
        $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean2->getXp()."' ORDER BY xptable_level DESC;";
        $levelList = $xptableDao->listQuery(&$datasource, $sql); 
        $userlistDataBean2->setLevel($levelList[0]->getXptable_level());
        $highscoreDataBean->setUser_persuasion_b($userlistDataBean2);
      }
      $userlistDataBean->setPosition($i+1);
      $logManager->message("init_highsore: Position User".$userlistDataBean->getPosition());
      $userlistDataBean->setList_user($competence->getCompetence_user());    
      $userlistDataBean->setXP($competence->getCompetence_PER());
      $comp = new CompetenceDataBean;
      $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$userlistDataBean->getXp()."' ORDER BY xptable_level DESC;";
      $levelList = $xptableDao->listQuery(&$datasource, $sql); 
      $userlistDataBean->setLevel($levelList[0]->getXptable_level());
      $highscoreDataBean->setUser_persuasion($userlistDataBean);
    }
  } 
  
  // Calucl de la rputation de la ville
  $logManager->message("init_highscore : Rputation ville");
  $sql = "SELECT SUM(competence_REP) FROM darkcity_competence, darkcity_user WHERE user_name = competence_user AND user_actif = 1;";
  $logManager->message("init_highscore : ".$sql);
  $result = $datasource->execute($sql);
  $logManager->message("init_highscore : ".$result);
  $row = $datasource->nextRow($result);
  $logManager->message("init_highscore : ".$row[0]);
  $highscoreDataBean->setVilleRep($row[0]);
  $logManager->message("init_highscore : fin");
?>