 <?php 
 /**
 * init_marchand.php : partie mtier du manrchand
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_marchand : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/MarchandDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $marchandDataBean = new marchandDataBean;
  
  $logManager->message("init_marchand : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $marchandDataBean->setName($joueur->getUser_name());
    
  $logManager->message("init_marchand : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= time()) {
    //$marchandDataBean->setMsgInfo("Vous n'&ecirc;tes actuellement pas occup&eacute;, vous vous reposez dans votre planque.");
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
  }
  else {
    $marchandDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $marchandDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  
  $logManager->message("init_marchand : table competence");
  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $user_name); 
    if ($competence_cpy->getCompetence_PIL() != "" && $competence_cpy->getCompetence_PIL() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  

  //Objet pour comptence medecine
  
  // On recupre les levels 
  $xptableDao = new Darkcity_xptableDao;
  // MED
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_MED());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_MED = ($levelList[0]->getXptable_level());
  $logManager->message("init_marchand : level medecine ".$lvl_MED);
  // REC
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_REC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_REC = ($levelList[0]->getXptable_level());
  // RPR
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_RPR());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_RPR = ($levelList[0]->getXptable_level());
  // PER
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_PER());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_PER = ($levelList[0]->getXptable_level());
  // SEC
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_SEC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_SEC = ($levelList[0]->getXptable_level());
  
  // On rcupre les objet medecine en ventes *********************************************
  $objetDao = new Darkcity_objetDao;
  $sql = "SELECT * FROM darkcity_objet WHERE (objet_level <= '".$lvl_MED."' AND objet_competence = 'MED') OR (objet_level <= '".$lvl_REC."' AND objet_competence = 'REC') OR (objet_level <= '".$lvl_RPR."' AND objet_competence = 'RPR') OR (objet_level <= '".$lvl_PER."' AND objet_competence = 'PER') OR (objet_level <= '".$lvl_SEC."' AND objet_competence = 'SEC') ORDER BY objet_level ASC, objet_prix ASC;";
  $objetList = $objetDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_marchand : preparation liste vente");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $objetDao = new Darkcity_objetDao;
  for ($i = 0; $i < sizeof($objetList); $i++) {
    $objet = $objetList[$i];
    $logManager->message("init_marchand : boucle objet n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getObjet_key());
    $inventaireDataBean->setActif($FALSE);    
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getObjet_competence());  
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setName($objet->getObjet_name());
    $inventaireDataBean->setDescription($objet->getObjet_description());
    $inventaireDataBean->setImage($objet->getObjet_image());
    $inventaireDataBean->setBonus($objet->getObjet_bonus());
    $inventaireDataBean->setlevel($objet->getObjet_level());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setPrix($objet->getObjet_prix());
    //mise a jour des infos
    $logManager->message("init_marchand : maj liste");
    $marchandDataBean->addMarchand($inventaireDataBean);
  } 
  
  // On rcupre l'inventeire pour les comptence MED, REC, RPR, PER, SEC ****
  $inventaireDao = new Darkcity_inventaireDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'MED' OR inventaire_cmpname = 'REC' OR inventaire_cmpname = 'RPR' OR inventaire_cmpname = 'PER' OR inventaire_cmpname = 'SEC') ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_inventaire : preparation inventaire");
  $objetDao = new Darkcity_objetDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  for ($i = 0; $i < sizeof($inventaireList); $i++) {
    $objet = $inventaireList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getInventaire_id());
    $inventaireDataBean->setPds($objet->getInventaire_structure());
    $inventaireDataBean->setActif($objet->getInventaire_actif());
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getInventaire_cmpname()); 
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    
    //spcificit des objets
    $objetDao = new Darkcity_objetDao;
    $objet = $objetDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $inventaireDataBean->setName($objet->getObjet_name());
    $inventaireDataBean->setDescription($objet->getObjet_description());
    $inventaireDataBean->setImage($objet->getObjet_image());
    $inventaireDataBean->setBonus($objet->getObjet_bonus());
    $inventaireDataBean->setPdsMax($objet->getObjet_utilisations());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setPrix($objet->getObjet_prix());
    //calcule prix de vente
    $Prix_vente = 0;
    if ($inventaireDataBean->getPds() == $inventaireDataBean->getPdsMax()) {
      $Prix_vente = round($inventaireDataBean->getPrix() * 0.5);
    }
    $inventaireDataBean->setPrix_vente($Prix_vente);
    //mise a jour du data bean
    $marchandDataBean->addInventaire($inventaireDataBean);
  }
  
  $logManager->message("init_marchand : fin");
?>