<?php
/**
 * init_planque.php : partie mtier de la planque
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  $logManager->message("init_planque : debut");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/PlanqueDataBean.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_quartierDao.php");
  include_once("dao/objets/Darkcity_quartier.php");

  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");

  $planqueDataBean = new PlanqueDataBean;
  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $occupationDao = new Darkcity_occupationDao;
  $planqueDao = new Darkcity_planqueDao;
  $quartierDao = new Darkcity_quartierDao;

  // On rcupre la comptence scurit
  $logManager->message("On rcupre la comptence scurit");
  $competence = $competenceDao->getObject(&$datasource, $user_name);
  $comp = new CompetenceDataBean;
  $comp->setCompetenceName("SEC");
  $comp->setXp($competence->getCompetence_SEC());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $comp->setLevel($levelList[0]->getXptable_level());
  $comp->setXpLevel($levelList[0]->getXptable_xp());
  $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
  $comp->setXpNext($level->getXptable_xp());
  $comp->setLevelNext($level->getXptable_level());
  $planqueDataBean->setCompetence_SEC($comp);
  $planqueDataBean->setArgent($competence->getCompetence_ARG());
  $planqueDataBean->setReputation($competence->getCompetence_REP());

  // Les infos de la planque
  $logManager->message("Les infos de la planque");
  $planque = $planqueDao->getObject(&$datasource, $user_name);
  $planqueDataBean->setQuartier_actuel($planque->getPlanque_quartier());
  $planqueDataBean->setLevel_SEC($planque->getPlanque_securite());
  $planqueDataBean->setLevel_MED($planque->getPlanque_confort());
  
  // Les infos des quartiers
  $logManager->message("Les infos des quartiers");
  $sql = "SELECT * FROM darkcity_quartier ORDER BY quartier_id ASC;";
  $quartierList = $quartierDao->listQuery(&$datasource, $sql); 
  $planqueDataBean->setQuartiers($quartierList);

  $logManager->message("init_planque : fin");

?>