 <?php 
/**
 * init_planqueNews.php : partie mtier des news dans la planque
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */      
  $logManager->message("init_planqueNews : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_newsingameDao.php");
  include_once("dao/objets/Darkcity_newsingame.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("databean/NewsInGameDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $newsingameDao = new Darkcity_newsingameDao;
  $newsInGameDataBean = new NewsInGameDataBean;

  // Rcupration des 10 dernire news
  $sql = "SELECT * FROM darkcity_newsingame ORDER BY newsingame_date DESC;";
  $listMessages = $newsingameDao->listQuery(&$datasource, $sql);
  if (sizeof($listMessages) > 0) {
    // on supprime les news si plus de 10
    $nb_news = sizeof($listMessages);
    if ($nb_news > 10) {
      $nb_news = 10;
      $msg = $listMessages[9];
      $dateh = $msg->getNewsingame_date();
      $sql = "DELETE FROM darkcity_newsingame WHERE newsingame_date < $dateh;";
      $newsingameDao->databaseUpdate(&$datasource, $sql);
    }
    for ($i = 0; $i < $nb_news; $i++) {
      $msg = $listMessages[$i];
      $date = $dateManager->dateToString($msg->getNewsingame_date());
      $texte = $msg->getNewsingame_text();
      $newsInGameDataBean->addNews($date."&gt;".$texte);
    }
  }

  // On rcupre le plus grand justicier *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REP > 0 ORDER BY competence_REP DESC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $competence = $competenceList[0];
  $justicier = $competence->getCompetence_user();
  $newsInGameDataBean->setJusticier($justicier);
  
  // On rcupre les gangsters *********************************************
  $competenceDao = new Darkcity_competenceDao;
  $sql = "SELECT * FROM darkcity_competence , darkcity_user WHERE user_name = competence_user AND user_actif = 1 AND competence_REP < 0 ORDER BY competence_REP ASC, competence_user ASC;";
  $competenceList = $competenceDao->listQuery(&$datasource, $sql); 
  $competence = $competenceList[0];
  $bandit = $competence->getCompetence_user();
  $newsInGameDataBean->setBandit($bandit);
  
  // Calucl de la rputation de la ville
  $logManager->message("init_highscore : Rputation ville");
  $sql = "SELECT SUM(competence_REP) FROM darkcity_competence, darkcity_user WHERE user_name = competence_user AND user_actif = 1;";
  $result = $datasource->execute($sql);
  $row = $datasource->nextRow($result);
  $newsInGameDataBean->setVilleRep($row[0]);

  // on rcupre les news du jeu
  include("metier/init_news.php");
  
  $logManager->message("init_planqueNews : fin");
?>