 <?php 
/**
 * init_user_admin.php : partie mtier d'administartion du joueur
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_user_admin : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("databean/UserAdminDataBean.php");

  $logManager->message("init_user_admin : init data bean");
  $user_name = $sessionManager->load("user_name");
  $userAdminDataBean = new UserAdminDataBean;  

  $logManager->message("init_user_admin : accs base");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);

  $logManager->message("init_user_admin : alimentation");
  // On alimente le DataBean pour la VUE
  $userAdminDataBean->setName($joueur->getUser_name());
  $userAdminDataBean->setEmail($joueur->getUser_email());
  $logManager->message("init_user_admin : email=".$userAdminDataBean->getEmail());
  $userAdminDataBean->setDescription($joueur->getUser_description());
  $userAdminDataBean->setAvatar($joueur->getUser_avatar());
  $userAdminDataBean->setSexe($joueur->getUser_sex());

  
  $logManager->message("init_user_admin : fin");
?>