<?php
/**
 * maj_session.php : partie mtier de mise  jour de la session
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  $logManager->message("maj_session : debut");
  
  include_once("dao/accesseurs/Darkcity_sessionDao.php");
  include_once("dao/objets/Darkcity_session.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");

  $logManager->message("maj_session : chgt");
  $user_name = $sessionManager->load("user_name");
  
  $logManager->message("maj_session : getSession");
  $sessionDao = new Darkcity_sessionDao;
  $occupationDao = new Darkcity_occupationDao;
  // On epure les session vides
  $SQL = "DELETE FROM darkcity_session WHERE session_sessionid = '';";
  $sessionDao->databaseUpdate(&$datasource, $SQL);
  
  $creation = 0;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  $mySession = $sessionDao->getObject(&$datasource, $user_name);
  $creation = ($mySession->getSession_sessionid() == "") && ($mySession->getSession_lastaction() == 0);

  // En cas d'une session dja active on quitte sauf si on est en phase de login (ecrasement de session)
  if ($pageCourante != "login" && !$creation && ($mySession->getSession_sessionid() != $sessionManager->getId() && $mySession->getSession_sessionid() != "")) {
     $errorManager->setMessage("Une autre session est en cours pour cet utilisateur");
     include("metier/init_news.php");
     include("metier/init_login.php");
     include("vue/login.php");
     exit;
  }
  
  $mySession->setSession_sessionid($sessionManager->getId());
  $mySession->setSession_lastaction(time());
  $occupation->setOccupation_lastaction(time());
  $logManager->message("maj_session : saveSession");
  if ($creation) {
    $sessionDao->create(&$datasource, $mySession);
  }
  else {
    $sessionDao->save(&$datasource, $mySession);
  }
  $occupationDao->save(&$datasource, $occupation);
  
  $logManager->message("maj_session : fin");
?>