 <?php 
/**
 * payer_amende.php : partie mtier de payement d'une amende  la Police
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_fichePerso : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/PostePoliceDataBean.php");

  $amende = htmlspecialchars($_POST["amende"],ENT_QUOTES);
  $user_name = $sessionManager->load("user_name");

  $logManager->message("init_fichePerso : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);

  $logManager->message("init_fichePerso : table competence");
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  if ($competence->getCompetence_ARG() < $amende) {
    $infoManager->setMessage("Vous n'avez pas suffisemment d&#39;argent pour payer l'amende.");
  }
  else {
    $logManager->message("init_fichePerso : table xptable");
    $xptableDao = new Darkcity_xptableDao;
    $level = $amende / 100;
    $logManager->message("init_fichePerso : ".$level);
    $reputation = 0;
    if ($level > 1) {
      $logManager->message("init_fichePerso : table xptable 1");
      $levelS = $xptableDao->getObject(&$datasource, $level);
      $logManager->message("init_fichePerso : table xptable 2");
      $levelP = $xptableDao->getObject(&$datasource, $level - 1);
      $logManager->message("init_fichePerso : calcul");
      $reputation = $competence->getCompetence_REP() + ($levelS->getXptable_xp() - $levelP->getXptable_xp());
    }	
    $logManager->message("init_fichePerso : save");
    $competence->setCompetence_REP($reputation);
    $competence->setCompetence_ARG($competence->getCompetence_ARG() - $amende);
    $competenceDao->save(&$datasource, $competence);

    $logManager->message("init_fichePerso : send");
    $titre = "Vous vous tes rachet une conscience";
    $content = "Vous vous tes rachet une conscience, aucune amende ne vous sera donne avant 5 minutes\n".
               "Vous pouvez durant ce laps de temps consulter les avis de recherches au poste de police\n".
               "Votre Rputation passe dsormais  ".abs($reputation)." (".($reputation == 0 ? "Bonne" : "Mauvaise").").";
    $messageManager->sendMessage('', $user_name, $titre, $content, $dateManager->getCurrentDate());
             
    $infoManager->setMessage("Vous vous tes rachet une conscience, aucune amende ne vous sera donne avant 5 minutes");
    $logManager->message("init_fichePerso : occupation");  
    $occupation->setOccupation_amende($dateManager->getFutureDate($DELAI_AMENDE));
    $logManager->message("init_fichePerso : occupation");
    $occupationDao->save(&$datasource, $occupation);
  }
  $logManager->message("init_fichePerso : fin");
?>