 <?php 
/**
 * recherche_bar.php : partie mtier de provocation dans le bar
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("rechercheCombat : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/FicheAdversaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");

  $user_name = $sessionManager->load("user_name");
  
  $continuer = $TRUE;
 
  $occupationDao = new Darkcity_occupationDao;
  
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_bar() > $dateManager->getCurrentDate()) {
    $continuer=$FALSE;
    $infoManager->setMessage(htmlspecialchars("Vous vous tes dja bagarr dans ce bar, vous ne pourrez recommencer que ",ENT_QUOTES).$dateManager->dateToString($occupation->getOccupation_bar()));
  }
  else {
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competenceJ1 = $competenceDao->getObject(&$datasource, $user_name);
  $moy = round(($competenceJ1->getCompetence_BGR() + $competenceJ1->getCompetence_PHY()) / 2);
  $xptableDao = new Darkcity_xptableDao;
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$moy."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvlMin = floor($levelList[0]->getXptable_level() * 0.7);
  if ($levelList[0]->getXptable_level() < 5) $lvlMin = 1;
  if ($lvlMin < 1) $lvlMin = 1;
  $level = $xptableDao->getObject(&$datasource, $lvlMin); 
  $date = $dateManager->getPastDate(30*$MINUTE);
  $SQL = "SELECT * FROM `darkcity_competence`, `darkcity_occupation`, `darkcity_user`, `darkcity_session` WHERE user_name = competence_user AND session_user = competence_user AND user_actif = 1 AND user_bloque = 0 AND competence_user = occupation_user AND competence_user <> '".$user_name."' AND occupation_datefin < ".$dateManager->getCurrentDate()." AND occupation_attaque < ".$dateManager->getCurrentDate()." AND (competence_BGR >= ".$level->getXptable_xp()." OR competence_PHY >= ".$level->getXptable_xp().") AND (competence_VIE > 24 OR occupation_lastaction > occupation_attaque) AND session_lastaction >= ".$date." ORDER BY competence_BGR DESC, competence_PHY DESC;"; 
  $logManager->message("rechercheCombat : ".$SQL);
  $competenceList = $competenceDao->listQuery(&$datasource, $SQL);

  // On trouve quelqu'un ?
  $nbtrouve = sizeof($competenceList);
  if ($nbtrouve == 0) {
    // on a trouv personne
    $continuer=$FALSE;
    $infoManager->setMessage(htmlspecialchars("Le bar est presque vide et vous ne trouvez personne avec qui vous bagarrer.",ENT_QUOTES));
  }
  else {
    $menuDataBean->desactiveTous();
    $menuDataBean->desactiveQuitter();
    $menuDataBean->setOccupe($FALSE);
    $logManager->message("rechercheCombat : selection");
    $selectionne = $systemeDes->jeterN(1,$nbtrouve) - 1;	
    $competenceAdv = $competenceList[$selectionne];
    $adv = $competenceAdv->getCompetence_user();
    $logManager->message("rechercheCombat : save");
    $sessionManager->save("adversaire", $adv);
    
   // $infoManager->setMessage(htmlspecialchars("Vous avez trouvs $nbtrouve personnes avec qui vous bagarrer, votre choix se porte sur le numro $selectionne.",ENT_QUOTES));

    $logManager->message("rechercheCombat : create");
    $ficheAdvDataBean = new FicheAdversaireDataBean;

    $logManager->message("rechercheCombat : chargement user");
    // On recupre toutes les infos du User 
    $userDao = new Darkcity_userDao;
    $joueur = $userDao->getObject(&$datasource, $adv);
    $ficheAdvDataBean->setName($joueur->getUser_name());
    $ficheAdvDataBean->setAvatar($joueur->getUser_avatar());
    $ficheAdvDataBean->setDescription($joueur->getUser_description());

    $ficheAdvDataBean->setReputation($competenceAdv->getCompetence_REP());

    $xptableDao = new Darkcity_xptableDao;

    $logManager->message("rechercheCombat : chargement competence BGR");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("BGR");
    $comp->setXp($competenceAdv->getCompetence_BGR());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    $ficheAdvDataBean->addCompetence($comp);

    $logManager->message("rechercheCombat : chargement competence PHY");
    $comp = new CompetenceDataBean;
    $comp->setCompetenceName("PHY");
    $comp->setXp($competenceAdv->getCompetence_PHY());
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $comp->setLevel($levelList[0]->getXptable_level());
    $comp->setXpLevel($levelList[0]->getXptable_xp());
    $level = $xptableDao->getObject(&$datasource, $comp->getLevel()+1); 
    $comp->setXpNext($level->getXptable_xp());
    $comp->setLevelNext($level->getXptable_level());
    $ficheAdvDataBean->addCompetence($comp);

  }
  }
  $logManager->message("recherche_bar : fin");
?>