<?php
/**
 * centreLoisir.php : vue correspondant  la page centreLoisir
 *
 * Date    : 21/03/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

  $logManager->message("page centreLoisir : debut"); 
  include("vue/header.php");
?>
  <div class="main">

      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  

        <?php
          if ($infoManager->isInfo()) {
            echo '<div style="margin: 50px; margin-top: 20px;" >';
            echo '  <table style="width: 700px">';
            echo "    <tr class=\"tab\"><th class=\"titlebox\">Messages d'information</th></tr>";
            echo '    <tr class="tab"><td class="tab">';
            echo $infoManager->getMessage();
            echo '    </td></tr>';
            echo '  </table>';  
            echo '</div>';
          }
        ?>

    <div class="box">
      <input type="hidden" name="pageCourante" value="centreLoisir" />
      <div class="titlebox">Le centre de Loisirs</div>
      <div class="messages-box" style="text-align: left;">
        <img class="image" src="images/lieux/centre_karate.gif" alt="[Centre Loisir]" title="" /><br/>
          Vous arrivez au centre de loisir. Ce dernier dispense des cours et des entrainements dans diverses activit&eacute;s. De plus les activit&eacute;s propos&eacute;es sont adapt&eacute;es en fonction de vos niveaux.<br/>
          <br/>
          Il vous reste &agrave; choisir quel type d'entrainement vous conviendrait le mieux.<br/>
          <br/>
        </div>
      </div>  

  <div class="box">
    <div class="titlebox">Les entrainements</div>
    <div class="scenario-box" style="text-align: left;">
    <?php
        echo '<br/><div style="padding-left: 20px;">Voici la liste des entrainements qui vous sont proposes par le coach du centre de loisir :</div><br/>';
        $nbActivite = $activitesDataBean->getNbActivite();
        $logManager->message("test ".$nbActivite);
        for ($i = 0; $i < $activitesDataBean->getNbActivite(); $i++) {
          $logManager->message("test ".$i);
          $activite = $activitesDataBean->getActiviteAt($i);
          $logManager->message("test activite recup�r� : ".$activite->getIndice()." ".$activite->getActivite_libelle());
          $cout = round($activite->getXptable_level() / 10) * 10;
          echo '<div style="padding-left: 20px;"><input class="text" type="radio" name="activiteKey" value="'.$activite->getIndice().'" '.($i == 0 ? 'checked="checked"' : '').'/> '.$activite->getActivite_libelle(). ' ('.($cout+$SALAIRE).'$/15 min)'.'</div>'."\n";
        }
        echo '<br />';
        echo '<div style="padding-left: 20px;">';
        echo 'D&eacute;cidez maintenant de la dur&eacute;e de votre entrainement :&nbsp;';
        echo '<select class="text" name="duree">';
        echo '  <option value="15">15 minutes</option>';
        echo '  <option value="30">30 minutes</option>';
        echo '  <option value="45">45 minutes</option>';
        echo '  <option value="60">60 minutes</option>';
        echo '</select>';
        echo '</div>';
    ?>
      <br/>
    </div>
      <div class="actions-right">
        <input name="action" class="action" type="submit" value="entrainer" />
      </div>
  </div>  

      <div class="box">
        <div class="titlebox">Retourner en ville</div>
        <div class="action-box" style="text-align: left;">
          <img class="image" src="images/lieux/porte.gif" alt="[Sortir]" title=""/><br/>Vous ne trouvez aucune activit� qui vous int�resse, vous d�cidez de retourner en ville, et de revenir plus tard.<br/>
        </div>
        <div class="actions-right">
          <input name="action" class="action" type="submit" value="Sortir" /> 
        </div>  
      </div> 
    </form>
  </div>  
<?php
  include("vue/footer.php");
  $logManager->message("page centreLoisir : fin"); 
?>