<?php 
/**
 * tchat.php : vue correspondant  la page de tchat dans le jeu
 *
 * Date    : 18/03/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

  $logManager->message("page tchat : debut"); 
  include("vue/header.php");
?>
<div class="main">
<?php
  if ($errorManager->isError()) {
    echo "        <div class=\"error\">".$errorManager->getMessage()."</div>";
  }
  if ($infoManager->isInfo()) {
    echo '        <div style="margin: 50px; margin-top: 20px;" >'."\n";
    echo '          <table style="width: 700px">'."\n";
    echo "            <tr  class=\"tab\"><th class=\"titlebox\">Messages d'information</th></tr>"."\n";
    echo '            <tr class="tab"><td class="tab">'."\n";
    echo '        '.$infoManager->getMessage()."\n";
    echo '            </td></tr>'."\n";
    echo '          </table>'."\n";  
    echo '        </div>'."\n";
  }
  echo "        <form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
?>  
    <table>
    <tr>
    <td style="width: 650px; text-align: center">  
  <div class="box2" style="padding-left: 15px;">
    <div class="titlebox">Tchat</div>
    <div class="chat-box">
      <table style="width:605px;" cellspacing="0" cellpadding="0">
      <?php 
         for ($i = 0; $i < $chatDataBean->getNbMessages(); $i++) {
           $message = $chatDataBean->getMessagesAt($i);
           if ($message->getChat_user() == $chatDataBean->getName()) {
             $etat = "moi_lu";
           }
           else if (stristr($message->getChat_text(), $chatDataBean->getName())) {
             $etat = "perso_lu";
           }
           else {
             $etat = "lu";
           }
           echo '<tr class="'.$etat.'"><td style="text-align: left; vertical-align: top;">'.date("H:i:s", $message->getChat_date())." ".$message->getChat_user()."&gt; ".$message->getChat_text().'</td></tr>';
         }
      ?>
      </table>
    </div>
  </div>  
  <div class="box2" style="padding-left: 15px;">
    <div class="titlebox">Envoyer un message</div>
    <div class="text-box" style="text-align: center">
      <textarea name="texte" class="textarea" rows="4" cols="90"></textarea>
    </div>
    <div class="actions-left">
      <input type="hidden" name="pageCourante" value="chat" />
      <input name="action" class="action" type="submit" value="envoyer" /> 
      <input name="action" class="action" type="submit" value="rafraichir" /> 
    </div>  
  </div>  
  </td>
    <td valign="top"> 
        <!-- Les Connects -->
        <div>
          <table style="width: 120px">
            <tr  class="tab"><th class="titlebox">En ligne</th></tr>
            <?php 
              for ($i = 0; $i < $chatDataBean->getNbEnLigne(); $i++) {
                $userlistDataBean = $chatDataBean->getEnligneAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $chatDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>     
    </td>
    </tr>
  </table>   
  
  
  </form>
</div>
<?php 
include("vue/footer.php");
$logManager->message("page tchat : fin"); 
?>