<?php 
/**
 * conditions.php : vue correspondant  la page des conditions du jeu
 *
 * Date    : 21/03/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

 $logManager->message("page conditions : debut"); 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
  <head>
    <title>DarkCity - MMORPG par Navigateur</title>
    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />
    <meta http-equiv="keywords" content="dark, bay, bar, australien, bordeaux, victoire" />
    <link rel="stylesheet" href="themes/default/style.css" type="text/css" />
  </head>
  <body>
  <div class="border">
    <div class="body">
    <?php
      echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
    ?>  
        <div class="title"><img class="title" src="images/jeu/ville2.jpg" alt="DARKCITY - La ville est &agrave; toi" title=""/></div>
        <hr />
        <div class="menu">
          <input type="hidden" name="pageCourante" value="news" />
          <input name="action" type="submit" class="menu" value="accueil"/> 
          <input name="action" type="submit" class="menu" value="news"/> 
          <input name="action" type="submit" class="menu" value="images"/> 
          <input name="action" type="submit" class="menu" value="cr&eacute;dits"/>
          <input name="action" type="submit" class="menu" value="soutien"/>
        </div>
    </form>
      <hr />
      <div class="main">
        <p/>
        <?php
          if ($errorManager->isError()) {
            echo "<div class=\"error\">";
            echo $errorManager->getMessage();
            echo "</div>";
          }
        ?>
        <div class="box">
          <div class="titlebox">Conditions gnrales d'utilisation du jeu DarkCity</div>
          <div class="scenario-box" style="text-align: left;">
            <p/>
            Afin de respecter la lgislation europenne sur la protection de la vie prive et 
            du traitement des donnes personnelles,  vous devez accepter les conditions d'utilisation 
            avant de pouvoir accder  votre compte.            
            <p/>
            <strong>1. Protection des donnes personnelles</strong><br/>
            Quand vous vous inscrivez  DarkCity, vous devez fournir une adresse email valide, 
            celle-ci permet d'activer votre compte, et nous permet de pouvoir vous contacter en 
            cas de problme. Nous nous engageons  ne pas nous servir de cette adresse  des fins 
            commerciales ou publicitaires quelconques.
            <p/>
            <strong>2. Age lgal pour jouer  DarkCity</strong><br/>
            Du fait du caractre violent et immoral de certaines actions dans le jeu nous 
            conseillons aux mineurs  de demander l'autorisation  leurs parents avant de crer 
            un compte et de jouer  DarkCity.<br/>
            Dans tous les cas, si vous avez moins de 18 ans et si la loi dans votre pays l'exige,  
            vous devez demander l'autorisation  vos parents pour jouer.
            <p/>
            <strong>3. Respect des rgles du jeu et savoir vivre</strong><br/>
            Vous devez toujours suivre les rgles du jeu. Vous ne devez pas enfreindre les rgles 
            du jeu ou tenter  de pirater DarkCity ou le compte d'un autre utilisateur. N'oubliez 
            pas la Netiquette ! Restez courtois. Ne menacez pas ou n'insultez pas les autres 
            utilisateurs. Ne les spammez pas.
            <p/>
            <strong>4. En cas de non respect de l'article 3</strong><br/>
            Si vous enfreignez ces rgles, un GameMaster peut bloquer votre compte pour une dure 
            dtermine ou non. Vous ne pouvez en aucun cas engager de poursuite envers un GameMaster
            pour avoir bloqu ou supprim  votre compte, en cas de litige, un simple change d'email 
            suffira  dbloquer la situation.
            <p/>
            <strong>5. En cas d'agression de la part d'un autre joueur</strong><br/>
            Si vous tes agress par un autre joueur, vous ne devez en aucun cas rpondre par une 
            agression, veuillez simplement le signaler  un GameMaster (par un bouton "signaler un 
            abus" dans le jeu) ou en envoyant un email au Webmaster, en indiquant les dtails de 
            votre plainte. Attention, tout abus sera puni par un possible blocage du compte.
            <p/>
            <strong>6. Il s'agit d'un jeu non de la ralit</strong><br/>
            Attention, ce jeu est un jeu de rle et il ne faut absolument pas comparer les actions 
            du jeu avec la  ralit, n'essayez en aucun cas de reproduire les actions du jeu dans 
            le monde rel.
            <p/>
            <strong>7. Garanties</strong><br/>
            Ce jeu est gratuit et, est dvelopp par des bnvoles passionns. Nous faisons notre 
            maximum pour assurer le meilleur service possible mais nous ne pouvons en aucun cas 
            garantir un fonctionnement permanent du jeu. Il se peut galement que des donnes du 
            jeu soient perdues.
            <p/>
            <strong>8. Licence</strong><br/>
            Ce jeu est entirement dvelopp dans l'esprit du libre selon les termes de la <strong>
            Gnu General Public License v2</strong>. Son utilisation au travers de ce site est galement 
            soumis  cette licence pour plus d'information veuillez consulter cette licence : 
            <a href="http://darken33.free.fr/article.php?cat=5&amp;rub=22&amp;art=39">Gnu General Public License v2</a>.
            <p/>
            <p/>
            <strong>9. Creation d'un persionnage</strong><br/>
            La cration du personnage passe par une activation suite  une rception d'un mail automatique, hors il se peut pour diverses 
            raisons, que vous ne receviez jamais cet email. Dans ce cas il suffit de nous envoyer un email  
            <a href="mailto:darkcitgame@free.fr" >darkcitgame@free.fr</a> en indiquant :
            <ul>
            <li>Le pseudonyme choisi pour la cration du personnage</li>
            <li>L'email choisi pour la cration du personnage</li>
            </ul>
            Nous procderons alors de faon manuelle afin que vous puissiez activer votre compte.
            FIN DES CONDITIONS GENERALES.<br/><br/>
          </div>
        </div>  
    <?php
      echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
    ?>  
  <div class="box">
    <input type="hidden" name="pageCourante" value="conditions" />
    <div class="titlebox">Accepter les conditions</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/ok.gif" alt="[Bi&egrave;re]" title=""/><br/><input type="checkbox" name="conditions" value="1" /> J'ai lu et j'accepte les conditions gnrales d'utilisation du jeu DarkCity dans leur ensemble.<br/>
    </div>
    <div class="actions-right">
      <input name="action" class="action" type="submit" value="continuer" /> 
    </div>  
  </div>  
      </form>        
      </div>
      <hr />
<?php      
  include("vue/footer.php");
  $logManager->message("Page gnre en ".$chrono->stop()."s.");  
  $logManager->message("page conditions : fin"); 
?>