<?php 
/**
 * fichePerso.php : vue correspondant  la page de fiche du personnage
 *
 * Date    : 18/03/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */

  $logManager->message("page fichePerso : debut"); 
  include("vue/header.php");
?>
      <div class="main">
        <script type="text/javascript">
        <!--       
          var timer = <?php echo $dateManager->compteRebour($fichePersoDataBean->getDateFin()); ?>;
          function updateChrono() {
            timer = timer - 1;
            if (timer>=0) {
              tmp = timer / 60;
              min = Math.floor(tmp);
              s = Math.round((tmp - min) * 60);
              tmp = min / 60;
              h = Math.floor(tmp);
              m = Math.round((tmp - h) * 60);
              if (h < 10) h = '0' + h;
              if (m < 10) m = '0' + m;
              if (s < 10) s = '0' + s;
              document.getElementById("crebour").innerHTML = '['+h+':'+m+':'+s+']';
              if (timer == 0) {
                window.location = '<?php echo $sessionManager->parseURL("index.php", ""); ?>';
              }
            }
          }
          setInterval("updateChrono()",1000);
        // --> 
        </script>
        
        <p style="padding-top: 30px;"/>
        <!-- Les Messages Systemes -->
        <div style="width: 700px; margin: auto;">
          <table style="width: 700px;">
            <tr class="tab"><th class="titlebox">Messages d'information</th></tr>
            <tr class="tab"><td class="tab">
<?php 
  echo $infoManager->getMessage();
  echo $fichePersoDataBean->getMsgInfo();
  if ($fichePersoDataBean->getDateFin()>0) {
    echo '              <div id="crebour" style="text-align:center;">Fin '.$dateManager->dateToString($fichePersoDataBean->getDateFin()).'.</div>'."\n";
  }
?>
            </td></tr>
          </table>  
        </div>

        <p style="padding-top: 30px;"/>
<?php
  echo "        <form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">\n";   
?>  
        <div style="width: 700px; margin: auto;">
          <!-- La Photo -->
          <div style="padding-left: 25px; padding-right: 25px; float: left;">
<?php 
  echo "            <img src=\"images/".$fichePersoDataBean->getAvatar()."\" alt=\"[photo]\" title=\"\" />\n"; 
?>
          </div>
      
          <!-- Identit&eacute; du joueur -->
          <div>
            <input name="pageCourante" type="hidden" value="fichePerso" />
            <table class="tab" style="width: 500px;">
              <tr class="tab"><th class="titlebox" colspan="5"><?php echo $fichePersoDataBean->getName(); ?></th></tr>
<?php  
  echo '              <tr class="tab"><td class="tab" style="width: 100px" title="La r&eacute;putation indique comment vous &ecirc;tes per&ccedil;u dans le monde de DarkCity">R&eacute;putation</td><td colspan="2" style="text-align: center; color: '.($fichePersoDataBean->getReputation() < 0 ? "red":"#00FF00").'">'.($fichePersoDataBean->getReputation() < 0 ? "Mauvaise":"Bonne").' ('.abs($competence->getCompetence_REP()).')</td><td style="width: 100px">&nbsp;</td></tr>'."\n"; 
?>
              <tr class="tab"><td class="tab" title="Ceci est l&#39;argent que vous poss&eacute;dez sur vous.">Argent </td><td class="tab"  colspan="2" style="text-align: center;"><?php echo $fichePersoDataBean->getArgent(); ?> $</td><td>&nbsp;</td></tr> 
              <tr class="tab"><td class="tab" title="Indique ce que vous pr&eacute;f&eacute;rez mettre en avant lorsqu&#39;un autre joueur tente de vous attaquer : Le combat, Le baratin, ou La course poursuite">Caract&egrave;re </td><td class="tab"  colspan="2" style="text-align: center;"><input type="radio" name="carract" value="COMBAT" <?php echo ($fichePersoDataBean->getCarractere() == "COMBAT" ? 'checked="checked"' : ''); ?>/> Combattant <input type="radio" class="text" name="carract" value="BARATIN" <?php echo ($fichePersoDataBean->getCarractere() == "BARATIN" ? 'checked="checked"' : ''); ?>/> Baratineur <input type="radio" name="carract" value="FUITE" <?php echo ($fichePersoDataBean->getCarractere() == "FUITE" ? 'checked="checked"' : ''); ?>/> Rapide</td><td><?php echo '<input type="submit" class="action'.($menuDataBean->isOccupe() ? '_disabled' : '').'" name="action" value="changer" '.($menuDataBean->isOccupe() ? 'disabled="disabled"' : '').'/>'; ?></td></tr> 
<?php
  $vie = $fichePersoDataBean->getSante();
  $viept = ($vie / 100) * 200;
  $viept2 = 200 - $viept;
  if ($vie == 0) {
    $pic = "empty";
  }
  if ($vie < 25) {
    $pic = "bad";
  }
  else if ($vie < 75) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
  echo '              <tr class="tab"><td class="tab" title="Indique vos points de vie actuels">Sant&eacute;</td><td class="tab" style="text-align: right;">'.$vie.'/100</td><td class="tab" style="text-align: center;"><img class="competence" src="images/jeu/'.($vie > 0 ? $pic : 'empty').'-left.gif" alt="'.$vie.'/100" title="('.$vie.'/100)"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$viept.'px; height: 12px;" alt="" title="('.$vie.'/100)"/><img src="images/jeu/empty-grad.gif" style="width: '.$viept2.'px; height: 12px;" alt="" title="('.$vie.'/100)"/><img src="images/jeu/'.($vie < 100 ? 'empty' : 'full').'-right.gif" alt="" title="('.$vie.'/100)"/></td><td class="tab"><input type="submit" class="action'.($menuDataBean->isOccupe() ? '_disabled' : '').'" name="action" value="soigner" '.($menuDataBean->isOccupe() ? 'disabled="disabled"' : '').'/></td></tr>'; 
?>
            </table>
          </div>
        </div>  
        </form>
          
        <p style="padding-top: 60px;"/>
        <div style="width: 730px; margin: auto;">
          <!-- Les comptences du joueur -->
          <div style="padding-right: 15px; float: left;">
          <table>
            <tr class="tab"><th class="titlebox" colspan="4">Comp&eacute;tences</th></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(0);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre ma&icirc;trise des armes &agrave; feux lors d&#39;un combat.">Tir</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(1);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre ma&icirc;trise du combat au corps &agrave; corps.">Bagarre</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(2);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre condition physique, ce qui se traduit par votre niveau d&eacute;fensif lors d&#39;un combat.">Physique</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(3);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre niveau d&#39;enqu&ecirc;teur.">Recherche</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(4);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre niveau pour d&eacute;jouer les syst&egrave;mes de s&eacute;curit&eacute;.">S&eacute;curit&eacute;</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(5);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre capacit&eacute; &agrave; r&eacute;parer des objets.">R&eacute;paration</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(6);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre niveau dans les courses poursuites.">Poursuite</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(7);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence repr&eacute;sente votre capacit&eacute; &agrave; soigner une personne.">M&eacute;decine</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
<?php 
  $comp = $fichePersoDataBean->getCompetenceAt(8);
  $valeur = round((($comp->getXp() - $comp->getXpLevel()) / ($comp->getXpNext() - $comp->getXpLevel())) * 200);
  $valeur2 = 200 - $valeur;
  $altvalue = round($valeur / 20);
  $alttext="=====";
  $alttext2="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  if ($valeur == 0) {
    $pic = "empty";
  }
  else if ($valeur < 50) {
    $pic = "bad";
  }
  else if ($valeur < 150) {
    $pic = "med";
  }
  else {
    $pic = "full";
  }
?>
            <tr class="tab"><td class="tab" style="width: 100px" title="Cette comp&eacute;tence indique votre niveau empathique, utile notamment pour le marchandage ou le baratin.">Persuasion</td><?php echo '<td  class="level" style="width:20px; text-align: right;" >'.$comp->getLevel().'</td><td class="tab"><img class="competence" src="images/jeu/'.$pic.'-left.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.$pic.'-grad.gif" style="width: '.$valeur.'px; height: 12px;" alt="['.$comp->getXp().'/'.$comp->getXpNext().']" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/empty-grad.gif" style="width: '.$valeur2.'px; height: 12px;" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/><img src="images/jeu/'.($valeur < 200 ? 'empty' : 'full').'-right.gif" alt="" title="Vous avez acquis '.$comp->getXp().' points d&#39;exp&eacute;rience, encore '.($comp->getXpNext() - $comp->getXp()).' points pour changer de niveau"/></td><td  class="level" style="width:20px; text-align: left;" title="">'.$comp->getLevelNext().'</td>'; ?></tr>
          </table>
          </div>
<?php
  echo "          <form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">\n";   
?>  
            <!-- La description du joueur -->
            <div>
              <input name="pageCourante" type="hidden" value="fichePerso" />
              <table style="width: 100px">
                <tr class="tab"><th  class="titlebox">Description</th></tr>
                <tr class="tab"><td class="tab"><textarea name="description" class="textarea" rows="10" cols="50"><?php echo $fichePersoDataBean->getDescription(); ?></textarea></td></tr>
                <tr class="tab"><td  class="tab" style="text-align: center;"><input type="submit" class="action" name="action" value="modifier" /></td></tr>
              </table>  
            </div>
          </form>
        </div>  
         
        <p style="padding-top: 30px;"/>
        <!-- Inventaire du joueur -->
        <div style="width: 700px; margin: auto;">
          <table style="width: 700px">
            <tr  class="tab"><th class="titlebox" colspan="3">Inventaire</th></tr>
<?php 
  if ($fichePersoDataBean->getNbInventaire() == 0) {
    echo "            <tr class=\"tab\"><td class=\"tab\" colspan=\"3\">Pas d'objet d'ans l'inventaire</td></tr>\n";
  }
  else {
    for ($i = 0; $i < $fichePersoDataBean->getNbInventaire(); $i++) {
      $objet = $fichePersoDataBean->getInventaireAt($i);
      echo '            <tr  class="tab">'."\n";
      echo '              <td  class="tab" style="text-align: center;">'."\n";
      echo '                <span class="object">'.$objet->getName().'</span><br/>'."\n";
      echo '                <img class="object" src="images/'.$objet->getImage().'" alt="'.$objet->getDescription().'" title="'.$objet->getDescription().'" /><br/>'."\n";
      if ($objet->getCmp() == "TIR" || $objet->getCmp() == "BGR" || $objet->getCmp() == "PIL" || $objet->getCmp() == "PHY") {
        echo '                <span class="state-'.($objet->getPds() == 0 ? 'broken' : ($objet->isReparable() ? 'bad' : 'good')).'">['.$objet->getPds().'/'.$objet->getPdsMax().']</span><br/>'."\n";
      }
      else {
        echo '                <span class="state-'.($objet->getPds() == 0 ? 'broken' : ($objet->getPds() < $objet->getPdsMax() ? 'bad' : 'good')).'">['.$objet->getPds().']</span><br/>'."\n";
      }
      echo '                <span class="active">'.($objet->isActif() ? '' : 'in').'actif</span>'."\n";
      echo '              </td>'."\n";
      echo '              <td class="tab" style="vertical-align: top">'."\n";
      echo '                '.$objet->getDescription().' associ&eacute;(e) &agrave; la comp&eacute;tence '.$objet->getCompetence().'<br/>	'."\n";
      echo '                Bonus : '.($objet->getBonus() >= 0 ? '+' : '').$objet->getBonus().'<br/>'."\n";
      if ($objet->hasDegats()) {
        echo '                D&eacute;gats : '.$objet->getDegats().'<br/>'."\n";
      }
      if ($objet->hasFiabilite()) {
        echo '                Fiabilit&eacute; : '.($objet->getFiabilite() == 'B' ? 'Bonne' : ($objet->getFiabilite() == 'S' ? 'Standard' : 'Faible')).'<br/>'."\n";
      }
      if ($objet->hasAcceleration()) {
        echo '                Acc&eacute;l&eacute;ration : '.$objet->getAcceleration().'<br/>'."\n";
      }
      echo '                Prix : '.$objet->getPrix().' $'."\n";
      echo '              </td>'."\n";
      echo '              <td class="tab" style="text-align: center; vertical-align: top">'."\n";
      echo '                <form action="'.$sessionManager->parseURL("index.php", "").'" method="post">';   
      echo '                  <div>'."\n";
      echo '                    <input name="pageCourante" type="hidden" value="fichePerso" />'."\n";
      echo '                    <input name="object_id" type="hidden" value="'.$objet->getId().'" /><br/>'."\n";
      if ($objet->isActif()) {
        echo '                    <input name="action" class="action'.($menuDataBean->isOccupe() ? '_disabled' : '').'" type="submit" value="d&eacute;sactiver" '.($menuDataBean->isOccupe() ? 'disabled="disabled"' : '').' /><br/><br/>'."\n";
      }
      else if ($objet->isActivable()) {
        echo '                    <input name="action" class="action'.($menuDataBean->isOccupe() ? '_disabled' : '').'" type="submit" value="activer" '.($menuDataBean->isOccupe() ? 'disabled="disabled"' : '').' /><br/><br/>'."\n";
      }
      if ($objet->isReparable()) {
        echo '                    <input name="action" class="action'.($menuDataBean->isOccupe() ? '_disabled' : '').'" type="submit" value="r&eacute;parer" '.($menuDataBean->isOccupe() ? 'disabled="disabled"' : '').' /><br/><br/>'."\n";
      }
      if (!$objet->isActif()) {
        echo '                    <input name="action" class="action'.'" type="submit" value="jeter" '.' /><br/><br/>'."\n";
      }
      echo '                  </div>  '."\n";
      echo '                </form>'."\n";
      echo '              </td>'."\n";
      echo '            </tr>'."\n";
    }
  }
?>
          </table>
        </div>
      </div>    
<?php 
  include("vue/footer.php");
  $logManager->message("page fichePerso : fin"); 
?>