<?php 
/**
 * highscore.php : vue correspondant  la page des highscore
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet & Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */
  $logManager->message("page highscore : debut"); 
  include("vue/header.php");
?>
      <div class="main">
        <br/>
    <table>
    <tr>
    <td style="width: 650px">  
      
        <!-- Les Users -->
        <div style="margin-bottom: 30px;" align="center">
          <table style="width: 350px">
            <tr  class="tab"><th class="titlebox" colspan="2">Informations Joueurs</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Nombre de connects</td><td style="text-align: center; font-weight: bold;">Nombre de joueurs total</td>'."\n";
              echo '</tr>'."\n";
              echo '<tr class="tab">'."\n";
              echo '  <td class="tab" style="text-align: center;">'."\n";
              echo '    '.$highscoreDataBean->getNb_connectes().'</td>'."\n";
              echo '  <td class="tab" style="text-align: center;">'."\n";
              echo '    '.$highscoreDataBean->getNb_users().'</td>'."\n";
              echo '</tr>'."\n";
            ?>
          </table>
        </div>
	
	<!-- Sous quelle emprise est la ville -->
        <div style="margin-bottom: 30px;" align="center">
          <table style="width: 600px">
            <tr  class="tab"><th class="titlebox">La ville est sous l&#39;emprise <?php echo ($highscoreDataBean->getVilleRep() < 0 ? "de la Mafia" : "de la Justice"); ?></th></tr>
            <?php
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: left;">';
              echo '<span style="color: '.($highscoreDataBean->getVilleRep() < 0 ? "#FF0000" : "#00FF00").'">La ville jouit d&#39;une '.($highscoreDataBean->getVilleRep() < 0 ? "Mauvaise" : "Bonne").' rputation ('.abs($highscoreDataBean->getVilleRep()).').</span><br/>';
              if ($highscoreDataBean->getVilleRep() < 0) {
                echo 'Il y a une agression toutes les deux minutes, et la population vit dans la peur continuelle, les criminels rient  gorge dploye, mais que fait la Police ?';
              }
              else {
                echo 'La criminalit est au plus bas, il fait bon vivre  DarkCity, on pourrait mme entendre les oiseaux chanter, videmment s&#39;il y avait encore des oiseaux dans ce monde...';
              }
              echo '  </td>'."\n";
              echo '</tr>'."\n";
            ?>
          </table>
        </div>

        <!-- Les justiciers -->
        <div style="margin-left: 12px; margin-right: 20px; float: left;">
          <table style="width: 300px">
            <?php 
              echo '<tr  class="tab"><th class="titlebox" colspan="3">Top 10 des '.$highscoreDataBean->getNb_justicier().' justiciers</th></tr>'."\n";
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Position</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Rputation</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste justicier=".$highscoreDataBean->getNbjusticier().".");
              for ($i = 0; $i < $highscoreDataBean->getNbjusticier(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getJusticierAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "yellow":"green").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "yellow":"green").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "yellow":"green").'">'."\n";
                echo '    '.$userlistDataBean->getReputation().'</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_justicier();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_justicier_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_justicier_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center; color: green">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center; color: green">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center; color: green">'."\n";
                  echo '    '.$userlistDataBean2->getReputation().'</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getReputation().'</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>

        <!-- Les gangsters -->
        <div style="margin-bottom: 50px;">
          <table style="width: 300px">
            <?php 
              echo '<tr  class="tab"><th class="titlebox" colspan="3">Top 10 des '.$highscoreDataBean->getNb_gangster().' gangsters</th></tr>'."\n";
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Position</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Rputation</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste gangster=".$highscoreDataBean->getNbgangster().".");
              for ($i = 0; $i < $highscoreDataBean->getNbgangster(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getGangsterAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "yellow":"red").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "yellow":"red").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "yellow":"red").'">'."\n";
                echo '    '.abs($userlistDataBean->getReputation()).'</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_gangster();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                $logManager->message("page highscore : user hors top 5");
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_gangster_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_gangster_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center; color: red">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center; color: red">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center; color: red">'."\n";
                  echo '    '.abs($userlistDataBean2->getReputation()).'</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.abs($userlistDataBean->getReputation()).'</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>

        <br/>
        <table style="margin-left: 5px">
        <tr>
        <td valign="top">  
        <!-- Les tireur d'lites -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les tireurs d'lite</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste tir".$highscoreDataBean->getNbtir().".");
              for ($i = 0; $i < $highscoreDataBean->getNbtir(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getTirAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_tir();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_tir_b() != "") {
                  $userDataBean = $highscoreDataBean->getUser_tir_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userDataBean->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userDataBean->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userDataBean->getLevel().' ('.$userDataBean->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        <td valign="top">  
        <!-- Les bagarreurs -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les bagarreurs</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste bagarre".$highscoreDataBean->getNbbagarre().".");
              for ($i = 0; $i < $highscoreDataBean->getNbbagarre(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getBagarreAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_bagarre();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_bagarre_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_bagarre_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        <td valign="top">  
        <!-- Les Costauds -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les costauds</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste physique".$highscoreDataBean->getNbphysique().".");
              for ($i = 0; $i < $highscoreDataBean->getNbphysique(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getPhysiqueAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_physique();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_physique_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_physique_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        </tr>
        <tr>
        <td valign="top">  
        <!-- Les Dtectives -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les dtectives</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste recherche".$highscoreDataBean->getNbrecherche().".");
              for ($i = 0; $i < $highscoreDataBean->getNbrecherche(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getRechercheAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_recherche();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_recherche_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_recherche_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        <td valign="top">  
        <!-- Les serruriers -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les serruriers</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste serruires".$highscoreDataBean->getNbsecurite().".");
              for ($i = 0; $i < $highscoreDataBean->getNbsecurite(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getSecuriteAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_securite();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_securite_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_securite_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        <td valign="top">   
        <!-- Les rparateurs -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les rparateurs</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste reparation".$highscoreDataBean->getNbreparation().".");
              for ($i = 0; $i < $highscoreDataBean->getNbreparation(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getReparationAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_reparation();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_reparation_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_reparation_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        </tr>
        <tr>
        <td valign="top">        
        <!-- Les rapides -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les rapides</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste pilotes".$highscoreDataBean->getNbpilotage().".");
              for ($i = 0; $i < $highscoreDataBean->getNbpilotage(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getPilotageAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_pilotage();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_pilotage_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_pilotage_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        <td valign="top">  
        <!-- Les Mdecins -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les mdecins</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste medecine".$highscoreDataBean->getNbmedecine().".");
              for ($i = 0; $i < $highscoreDataBean->getNbmedecine(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getMedecineAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_medecine();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_medecine_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_medecine_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>
        </td>
        <td valign="top">  
        <!-- Les Commerciaux -->
        <div>
          <table style="width: 220px">
            <tr  class="tab"><th class="titlebox" colspan="3">Les commerciaux</th></tr>
            <?php 
              echo '<tr  class="tab">'."\n";
              echo '  <td  class="tab" style="text-align: center; font-weight: bold;">Pos</td><td style="text-align: center; font-weight: bold;">User</td><td style="text-align: center; font-weight: bold;">Level</td>'."\n";
              echo '</tr>'."\n";
              $logManager->message("page highscore : liste persuasion".$highscoreDataBean->getNbpersuasion().".");
              for ($i = 0; $i < $highscoreDataBean->getNbpersuasion(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getPersuasionAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
              }
              $userlistDataBean = $highscoreDataBean->getUser_persuasion();
              if ($userlistDataBean->getList_user() == $highscoreDataBean->getName()) {
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
                if ($highscoreDataBean->getUser_persuasion_b() != "") {
                  $userlistDataBean2 = $highscoreDataBean->getUser_persuasion_b();
                  echo '<tr class="tab">'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getPosition().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getList_user().'</td>'."\n";
                  echo '  <td class="tab" style="text-align: center;">'."\n";
                  echo '    '.$userlistDataBean2->getLevel().' ('.$userlistDataBean2->getXp().')</td>'."\n";
                  echo '</tr>'."\n";
                }
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getPosition().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '  <td class="tab" style="text-align: center; color: yellow">'."\n";
                echo '    '.$userlistDataBean->getLevel().' ('.$userlistDataBean->getXp().')</td>'."\n";
                echo '</tr>'."\n";
                echo '<tr class="tab">'."\n";
                echo '  <td  class="tab" style="text-align: center;">...</td><td style="text-align: center;">...</td><td style="text-align: center;">...</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>     
        </td>
        </tr>
        </table>
        
    </td>
    <td valign="top"> 
        <!-- Les Connects -->
        <div>
          <table style="width: 120px">
            <tr  class="tab"><th class="titlebox">En ligne</th></tr>
            <?php 
              $logManager->message("page highscore : liste persuasion".$highscoreDataBean->getNbpersuasion().".");
              for ($i = 0; $i < $highscoreDataBean->getNb_connectes(); $i++) {
                $logManager->message("page highscore : nouvelle occurence=".$i);
                $userlistDataBean = $highscoreDataBean->getEnligneAt($i);
                echo '<tr class="tab">'."\n";
                echo '  <td class="tab" style="text-align: center; '.($userlistDataBean->getList_user() == $highscoreDataBean->getName() ? "color: yellow":"").'">'."\n";
                echo '    '.$userlistDataBean->getList_user().'</td>'."\n";
                echo '</tr>'."\n";
              }
            ?>
          </table>
        </div>     
    </td>
    </tr>
  </table>   
 </div>
      
<?php 
include("vue/footer.php");
$logManager->message("page highscore : fin"); 
?>