<?php
/**
 * planque.php : vue correspondant  la page de la planque
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  include("vue/header.php");
?>
  <div class="main">


        <?php
          if ($infoManager->isInfo()) {
            echo '<div style="margin: 50px; margin-top: 20px;" >';
            echo '  <table style="width: 700px">';
            echo "    <tr class=\"tab\"><th class=\"titlebox\">Messages d'information</th></tr>";
            echo '    <tr class="tab"><td class="tab">';
            echo $infoManager->getMessage();
            echo '    </td></tr>';
            echo '  </table>';  
            echo '</div>';
          }
        ?>
      <hr />
  <div class="box">
    <div class="titlebox">Votre appartement</div>
    <?php
      $quartierJ1 = $planqueDataBean->getQuartierAt($planqueDataBean->getQuartier_actuel()-1);
    ?>
    <div class="messages-box" style="text-align: left;">
          <img class="image" src="images/lieux/planque.gif" alt="[photo]" title="" /><br/><br />
          Bienvenue chez vous, il est bon de se retrouver chez soi.<br/><br />
          Vous habitez actuellement dans le quartier : <?php echo $quartierJ1->getQuartier_titre(); ?><br/>
          Votre niveau de confort : <?php echo $planqueDataBean->getLevel_MED(); ?><br />
          Votre niveau de s&eacute;curit&eacute; : <?php echo $planqueDataBean->getLevel_SEC(); ?><br /><br/>
          Vous avez actuellement <?php echo $planqueDataBean->getArgent(); ?> $.
    </div>
  </div>  

      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  
  <div class="box">
    <input type="hidden" name="pageCourante" value="planque_confort" />
    <div class="titlebox">Modifier votre confort</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/confort.gif" alt="[Confort]" title=""/>
      Le confort de votre appartement vous permet de vous soigner plus efficacement,<br/>
      Le quartier <?php echo $quartierJ1->getQuartier_titre(); ?> vous permet d'avoir un niveau de confort compris entre <?php echo $quartierJ1->getQuartier_confort_min(); ?> et  <?php echo $quartierJ1->getQuartier_confort_max(); ?><br/>
      <?php
        if ($planqueDataBean->getLevel_MED() < $quartierJ1->getQuartier_confort_max()) {
          $mult = $quartierJ1->getQuartier_id();
          if ($mult == 1) $mult = 1;
          if ($mult == 2) $mult = 1.5;
          if ($mult == 3) $mult = 2;
          if ($mult == 4) $mult = 3;
          echo "Augmenter d'un niveau votre confort vous coutera ".$mult*1000*($planqueDataBean->getLevel_MED()+1)." $<br/>";
        }
        else {
          echo "Vous avez atteint le niveau maximum de confort pour ce quartier, il serait peut &ecirc;tre temps d'en changer.<br />";
        }
        if ( $planqueDataBean->getLevel_MED() > $quartierJ1->getQuartier_confort_min() ) {
          echo "Diminuer d'un niveau votre confort est gratuit, pour cela il vous suffit de tout casser.";
        }
        else {
          echo "Vous &ecirc;tes au niveau minimum de confort pour ce quartier, vous ne pouvez pas le diminuer.<br />";
        }
      ?>
    </div>
    <?php
      if (!$menuDataBean->isOccupe()) {
      echo '<div class="actions-right">';
      echo '<input name="action" class="action'.($planqueDataBean->getLevel_MED() > $quartierJ1->getQuartier_confort_min() ? '' : '_disabled').'" type="submit" value="diminuer" '.($planqueDataBean->getLevel_MED() > $quartierJ1->getQuartier_confort_min() ? '' : 'disabled="disabled"').'/>&nbsp;'; 
      echo '<input name="action" class="action'.($planqueDataBean->getLevel_MED() < $quartierJ1->getQuartier_confort_max() ? '' : '_disabled').'" type="submit" value="augmenter" '.($planqueDataBean->getLevel_MED() < $quartierJ1->getQuartier_confort_max() ? '' : 'disabled="disabled"').'/>';
      echo '</div>';
      }
    ?>
  </div>  
    </form>

      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  
  <div class="box">
    <input type="hidden" name="pageCourante" value="planque_securite" />
    <div class="titlebox">Modifier la s&eacute;curit&eacute;</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/securite.gif" alt="[S&eacute;curit&eacute;]" title=""/>
      La s&eacute;curit&eacute; de votre appartement vous permet de vous prot&eacute;ger lorsque vous n'&ecirc;tes pas dans le jeu.<br/>
      Le quartier <?php echo $quartierJ1->getQuartier_titre(); ?> vous permet d'avoir un niveau de s&eacute;curit&eacute; compris entre <?php echo $quartierJ1->getQuartier_securite_min(); ?> et  <?php echo $quartierJ1->getQuartier_securite_max(); ?><br/>
      <?php
        if ($planqueDataBean->getLevel_SEC() < $quartierJ1->getQuartier_securite_max()) {
          $mult = $quartierJ1->getQuartier_id();
          if ($mult == 1) $mult = 1;
          if ($mult == 2) $mult = 1.5;
          if ($mult == 3) $mult = 2;
          if ($mult == 4) $mult = 3;
          echo "Augmenter d'un niveau votre s&eacute;curit&eacute; vous coutera ".$mult*1000*($planqueDataBean->getLevel_SEC()+1)." $<br/>";
        }
        else {
          echo "Vous avez atteint le niveau maximum de s&eacute;curit&eacute; pour ce quartier, il serait peut &ecirc;tre temps d'en changer.<br />";
        }
        if ( $planqueDataBean->getLevel_SEC() > $quartierJ1->getQuartier_securite_min() ) {
          echo "Diminuer d'un niveau votre s&eacute;curit&eacute; est gratuit.";
        }
        else {
          echo "Vous &ecirc;tes au niveau minimum de s&eacute;curit&eacute; pour ce quartier, vous ne pouvez pas le diminuer.<br />";
        }
      ?>
    </div>
    <?php
      if (!$menuDataBean->isOccupe()) {
        echo '<div class="actions-right">';
        echo '<input name="action" class="action'.($planqueDataBean->getLevel_SEC() > $quartierJ1->getQuartier_securite_min() ? '' : '_disabled').'" type="submit" value="diminuer" '.($planqueDataBean->getLevel_SEC() > $quartierJ1->getQuartier_securite_min() ? '' : 'disabled="disabled"').'/>&nbsp;'; 
        echo '<input name="action" class="action'.($planqueDataBean->getLevel_SEC() < $quartierJ1->getQuartier_securite_max() ? '' : '_disabled').'" type="submit" value="augmenter" '.($planqueDataBean->getLevel_SEC() < $quartierJ1->getQuartier_securite_max() ? '' : 'disabled="disabled"').'/>'; 
        echo '</div>';
      }
    ?>
  </div>  
    </form>

      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  
  <div class="box">
    <input type="hidden" name="pageCourante" value="planque" />
    <div class="titlebox">Changer de quartier</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/rue.gif" alt="[Quartier]" title=""/>
      Vous pouvez dcider de changer de quartiers, voici les quatiers accessibles :<br/>
      <?php
        $nb = 0;
        for ($i=0; $i<$planqueDataBean->getNbQuartier(); $i++) {
           $quartier = $planqueDataBean->getQuartierAt($i);
           if ($quartierJ1->getQuartier_id() != $quartier->getQuartier_id() and
               $planqueDataBean->getLevel_MED() >= $quartier->getQuartier_confort_min() and
               $planqueDataBean->getLevel_MED() <= $quartier->getQuartier_confort_max() and
               $planqueDataBean->getLevel_SEC() >= $quartier->getQuartier_securite_min() and
               $planqueDataBean->getLevel_SEC() <= $quartier->getQuartier_securite_max() and
               !($planqueDataBean->getReputation() < 0 and $quartier->getQuartier_id() == 4)) {
             $nb++;
             echo '<input type="radio" name="quartier" value="'.$quartier->getQuartier_id().'" '.($nb == 1 ? 'checked="checked" ' : '').' />'.$quartier->getQuartier_titre().' ('.($quartier->getQuartier_id()*1000).' $)<br/>';
           }
        }
        if ($nb == 0) {
          echo "vos niveaux de confort et de scurit actuels ne vous permettent pas de changer de quartier<br />";
        }
      ?>
    </div>
    <?php
      if (!$menuDataBean->isOccupe()) {
        echo '<div class="actions-right">';
        echo '<input name="action" class="action'.($nb == 0 ? '_disabled' : '').'" type="submit" value="dmnager" '.($nb == 0 ? 'disabled="disabled"' : '').'/>';
        echo '</div>  ';
      }
    ?>
  </div>  
    </form>

      <?php
        echo "<form action=\"".$sessionManager->parseURL("index.php", "")."\" method=\"post\">";   
      ?>  
      <div class="box">
    <input type="hidden" name="pageCourante" value="planque" />
    <div class="titlebox">Les dernires news sur News 54</div>
    <div class="action-box" style="text-align: left;">
      <img class="image" src="images/actions/tv.gif" alt="[TV]" title=""/>
      News 54 est la chaine TV qui vous permet de vous tenir inform sur ce qui se passe dans cette ville.<br/>
      <br/>
      Pour tre sr de ne rien rater des dernires information, regardez "News 54"...<br/>
    </div>
    <div class="actions-right">
      <?php echo '<input name="action" class="action" type="submit" value="regarder" />'; ?>
    </div>  
  </div> 
   </form>
  </div>  
  
<?php
  include("vue/footer.php");
?>